#!/usr/bin/perl
#$Id: journal_activity_update_sheet.cgi,v 1.9 2003/10/01 15:58:03 moreejt Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
# journal_activity_update.cgi  -  Created by Jason A. Pattie, 09/28/1999
# This script creates or updates the modified journal entry in the database.

use strict;

use Pg;  # PostgreSQL Database Module
use cgi_lib;  # CGI Library routines
use custom;  # our customizable features
use reports;

use vars '$date';
use vars '$date_ago';
use vars '$count';
use vars '$count2';
use vars '@journal_code_array';
use vars '$trans_month';
use vars '$trans_day';
use vars '$trans_day1';
use vars '$trans_day2';
use vars '$trans_year';
use vars '@payee_payer_array';
use vars '@payee_payer_ref_num_array';
use vars '@payee_payer_journal_code_array';
use vars '$current_fiscal_year';
use vars '$start_fiscal';
use vars '$stop_fiscal';
use vars '$start_month_fiscal';
use vars '$stop_month_fiscal';
use vars '$start_day_fiscal';
use vars '$stop_day_fiscal';
use vars '$start_year_fiscal';
use vars '$stop_year_fiscal';
use vars '$start_day1';
use vars '$start_day2';
use vars '$stop_day1';
use vars '$stop_day2';
use vars '$temp_payee_payer';
use vars '$journal_code';
use vars '$trans_date';
use vars '$payee_payer';
use vars '$memo';
use vars '$remember';
use vars '$ref_num';
use vars '$temp';
use vars '$temp1';
use vars '$temp2';
use vars '$temp3';
use vars '$amount';
use vars '$dorc';
use vars '$sub_entity_element';
use vars '$account_element';
use vars '$sub_account_element';
use vars '$sub_account_text';
use vars '$cleared';
use vars '$journal_command';
use vars '$journal_view_command';
use vars '$journal_display_string';

use vars '$transaction_record';
use vars '$transaction_item';
use vars '$transaction_key';
use vars '$transaction_value';
use vars '$transaction_debit_count';
use vars '$transaction_credit_count';
use vars '%transaction_debits_values';
use vars '%transaction_credits_values';

# get the values being passed in from the client
%input = ();  # make sure it is empty!
cgi_lib::ReadParse(*input);

# begin the HTML Output
print cgi_lib::PrintHeader();
print "<html>\n";

my $mode;  # modes are "new" and "edit"
my $ledger_name;  # name of ledger to work with
my $ledger_db;
my $ledger_color;
my $journal_name;
my $result2;
my $date_from;
my $date_to;
my $sort_journal;
my $sort_by;
my $journal_bgcolor;
my $num_journal_entries;
my $ledger_code;
my $report_obj;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";
  
    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
$db_name = $dbObj->dbName;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $database_connected;
$database_connected = 0;

if (not (exists $input{'edit_submit'} or exists $input{'new_submit'}))
{
  PrintErrorHeader();
  print "<h1>Error:  Access Denied!</h1>\n";
  print "Invalid options.<br>$sys_admin";
  CleanUp();
}

$ledger_db = $input{'ledger_db'};
if (length $ledger_db == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a ledger to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

$journal_code = $input{'journal_code'};
if (length $journal_code == 0)
{
  PrintErrorHeader();
  print "<h1>Error: You must specify a journal to work with!</h1>\n";
  print "$back_button";
  CleanUp();
}

$journal_bgcolor = $input{'journal_bgcolor'};
if (length $journal_bgcolor == 0)
{
  $journal_bgcolor = "deepskyblue";
}

# validate we got valid input from the user.
if (exists $input{'edit_submit'})
{
  $mode = "edit";
}
elsif (exists $input{'new_submit'})
{
  $mode = "new";
}
else
{
  PrintErrorHeader();
  print "<h1>Access Denied!</h1>\n";
  print "Error: Invalid options given!\n<br>$sys_admin";
  CleanUp();
}

# check to see if we are running under mod_perl
if (exists $ENV{MOD_PERL})
{
  # check to see if the database is still connected
  if (defined $conn)
  {
    # check the status of the connection
    if ($conn->status != PGRES_CONNECTION_OK)
    {
      $database_connected = 0;
    }
    else
    {
      # connection still good!
      $database_connected = 1;
    }
  }
  else
  {
    $database_connected = 0;
  }
}

if (not $database_connected)
{
  # connect to the database.
  $conn = Pg::connectdb("host = $db_host dbname = $db_name user = $db_user password = $db_passwd");
  if ($conn->status == PGRES_CONNECTION_BAD)
  {
    PrintErrorHeader();
    print "<h1>Error:  Couldn't connect to the database!</h1><br>\n";
    print $conn->errorMessage . "<br>$sys_admin";
    CleanUp();
  }
}

# set the DateStyle for the Database.
$result = setDBDateStyle($conn);
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Setting Date Style failed!</h1>\n";
  print $conn->errorMessage . "<br>$sys_admin";
  CleanUp();
}

# now validate that the ledger they specified is valid
$result = $conn->exec("select name from entity_tb where database_name = '$ledger_db'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Trying to check entity table.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error: Ledger <font color=\"blue\">$ledger_db</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
else
{
  $ledger_name = $result->getvalue(0, 0);
}

# create the reports object
$report_obj = reports->new($conn, $ledger_db);
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_code = $report_obj->getLedgerCode();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}
$ledger_color = $report_obj->getLedgerColor();
if ($report_obj->didErrorOccur())
{
  PrintErrorHeader();
  print $report_obj->getErrorMessage();
  CleanUp();
}

# now make sure that the journal exists that we are supposed to work with
$result = $conn->exec("select name from journal_tb where code = '$journal_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  PrintErrorHeader();
  print "<h1>Error:  Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to validate Journal with code = <font color=\"blue\">$journal_code</font>.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  PrintErrorHeader();
  print "<h1>Error:  Journal with code = <font color=\"blue\">$journal_code</font> does not exist!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
$journal_name = $result->getvalue(0, 0);

if ($mode eq "edit")
{
  $ref_num = $input{'ref_num'};
}
# parse the debit_values/credit_values hidden input fields to recreate the form rows
$count = 0;
foreach $transaction_record (split /\;/, $input{'debit_values'})
{
  foreach $transaction_item (split /\|/, $transaction_record)
  {
    ($transaction_key, $transaction_value) = split /\=/, $transaction_item, 2;
    $transaction_debits_values{"$count - $transaction_key"} = $transaction_value;
  }
  $count++;
}
$transaction_debit_count = $count;
$count = 0;
foreach $transaction_record (split /\;/, $input{'credit_values'})
{
  foreach $transaction_item (split /\|/, $transaction_record)
  {
    ($transaction_key, $transaction_value) = split /\=/, $transaction_item, 2;
    $transaction_credits_values{"$count - $transaction_key"} = $transaction_value;
  }
  $count++;
}
$transaction_credit_count = $count;

# verify that check/deposit numbers that are used on the form do not already exist in the database
for ($count=0; $count < $transaction_debit_count; $count++)
{
  # find only those rows that have debits/credits entered to check for check/deposit numbers
  $transaction_key = "$count - ac";
  $account_element = $transaction_debits_values{$transaction_key};

  $transaction_key = "$count - sa";
  $sub_account_element = $transaction_debits_values{$transaction_key};

  $transaction_key = "$count - cd";
  $sub_account_text = $transaction_debits_values{$transaction_key};

  $dorc = "true";
  if ($sub_account_element eq "D")
  {
    # sub_account_text contains a deposit number; based on dorc value, determine whether deposit is already in use
    # see if deposit number value is already in database
    if ($mode eq "edit")
    {
      $temp = "parent_num <> " . $ref_num . " and";
    }
    else
    {
      $temp = "";
    }
    $result = $conn->exec("select parent_num from debitcredit_tb where $temp account_num = $account_element and sub_account_num = $sub_account_text and dorc = $dorc AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get deposit numbers already in use.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 0)
    {
      PrintErrorHeader();
      print "<h1>Error: Deposit number <b>$sub_account_text</b> already in use in database!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
}
for ($count=0; $count < $transaction_credit_count; $count++)
{
  # find only those rows that have debits/credits entered to check for check/deposit numbers
  $transaction_key = "$count - ac";
  $account_element = $transaction_credits_values{$transaction_key};

  $transaction_key = "$count - sa";
  $sub_account_element = $transaction_credits_values{$transaction_key};

  $transaction_key = "$count - cd";
  $sub_account_text = $transaction_credits_values{$transaction_key};

  $dorc = "false";
  if ($sub_account_element eq "C")
  {
    # sub_account_text contains a check number; based on dorc value, determine whether check is already in use
    # see if check number value is already in database
    if ($mode eq "edit")
    {
      $temp = "parent_num <> " . $ref_num . " and";
    }
    else
    {
      $temp = "";
    }
    $result = $conn->exec("select parent_num from debitcredit_tb where $temp account_num = $account_element and sub_account_num = $sub_account_text and dorc = $dorc AND ledger_code = '$ledger_code'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get check numbers already in use.<br>$sys_admin";
      CleanUp();
    }
    if ($result->ntuples > 0)
    {
      PrintErrorHeader();
      print "<h1>Error: Check number <b>$sub_account_text</b> already in use in database!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
}

# get current fiscal year and verify that it is not closed
$result = $conn->exec("select working_year from variables_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record in the variables_tb.  " . $result->ntuples . " were returned.<br>$sys_admin";
  CleanUp();
}
$current_fiscal_year = $result->getvalue(0, 0);
# get the date ranges for the current fiscal year if it is not closed
$result = $conn->exec("select closed, start_date, end_date from known_years_tb where year = $current_fiscal_year AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get current fiscal year info. from database.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples != 1)
{
  print "<h1>Error: Wrong number of records returned!</h1>\n";
  print "There should only be one record for each individual fiscal year.<br>$sys_admin";
  CleanUp();
}
if ($result->getvalue(0, 0) eq "t")
{
  print "<h1>Fiscal Year ($current_fiscal_year) is Closed!</h1>\n";
  print "You cannot work with the records in a closed fiscal year.<br>$sys_admin";
  CleanUp();
}
$start_fiscal = $result->getvalue(0, 1);
$stop_fiscal = $result->getvalue(0, 2);
($start_month_fiscal, $start_day_fiscal, $start_year_fiscal) = split "-", $start_fiscal;
($stop_month_fiscal, $stop_day_fiscal, $stop_year_fiscal) = split "-", $stop_fiscal;

# begin a transaction so that if anything goes wrong, the changes will not be partially committed to the database but will be rolled back
$result = $conn->exec("begin work");
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  PrintErrorHeader();
  print "<h1>Error: Attempted to begin a transaction!</h1>\n";
  print "Failed to start the transaction to update/create the journal entry in the database.<br>$sys_admin";
  CleanUp();
}

print "<head><title>$prog_name $prog_version Journals Activity</title></head>\n";
print "<body bgcolor=$body_bgcolor onLoad=\"do_load();\">\n";
print <<"END_OF_STYLE";
<style type="text/css"><!--
  a:hover   { color: red }
  a:link    { text-decoration: none; color: blue }
  a:visited { text-decoration: none; color: blue }
  a:active  { text-decoration: none; color: blue }-->
</style>
<script language="Javascript1.2" src="../js/common.js"></script>
<script lnaguage="Javascript1.2">
<!--
END_OF_STYLE

  $start_day1 = int ($start_day_fiscal / 10);
  $start_day2 = ($start_day_fiscal % 10);
  $stop_day1 = int ($stop_day_fiscal / 10);
  $stop_day2 = ($stop_day_fiscal % 10);
  print <<"END_OF_STYLE";
  var trans_month;
  var trans_day1;
  var trans_day2;
  var trans_year;
  var start_month_fiscal = $start_month_fiscal;
  var start_day_fiscal = $start_day_fiscal;
  var start_day1_fiscal = $start_day1;
  var start_day2_fiscal = $start_day2;
  var start_year_fiscal = $start_year_fiscal;
  var stop_month_fiscal = $stop_month_fiscal;
  var stop_day_fiscal = $stop_day_fiscal;
  var stop_day1_fiscal = $stop_day1;
  var stop_day2_fiscal = $stop_day2;
  var stop_year_fiscal = $stop_year_fiscal;
  var start_day;
  var stop_day;
  var month_name;
  var month;
  var year;
  var old_trans_month;
  var old_trans_day1;
  var old_trans_day2;
  var old_trans_year;
  var date_valid;
  var journal_code_array = new Array();

  function do_load()
  {
    // fill in values for month, day1, day2, and year select form values

    // assign values to trans_month, trans_day, trans_year variables
    trans_month = document.edit_trans_form.trans_month.value;
    trans_day1 = document.edit_trans_form.trans_day1.value;
    trans_day2 = document.edit_trans_form.trans_day2.value;
    trans_year = document.edit_trans_form.trans_year.value;

    old_trans_month = trans_month;
    old_trans_day1 = trans_day1;
    old_trans_day2 = trans_day2;
    old_trans_year = trans_year;
    date_valid = true;

    // set the focus to the journal drop-down select
    document.edit_trans_form.journal_code_select.focus();
  }

  function payee_payer_text_change()
  {
    var count;
    var regexp;
    var payee_payer;
    var reg_exp;
    var non_space_found = false;

    regexp = eval("/^" + document.edit_trans_form.payee_payer_text.value + "+/i");

    // run through the payee_payer_select and see if the typed value matches any options in the select
    for (count=0; count < document.edit_trans_form.payee_payer_select.options.length; count++)
    {
      if (document.edit_trans_form.payee_payer_select.options[count].text.search(regexp) != -1)
      {
        document.edit_trans_form.payee_payer_select.selectedIndex = count;
        document.edit_trans_form.payee_payer_text.value = document.edit_trans_form.payee_payer_select.options[count].text;
        // select the last used journal code for the payee-payer from the journal code select
        document.edit_trans_form.journal_code_select.selectedIndex = journal_code_array[document.edit_trans_form.payee_payer_select.options[count].value];
      }
    }
    // if what is currently typed in the text field does not match what is selected in the select combo and what is typed starts with
    // "R> ", then throw an alert and clear the text field
    if (document.edit_trans_form.payee_payer_select.options[document.edit_trans_form.payee_payer_select.selectedIndex].text != document.edit_trans_form.payee_payer_text.value)
    {
      if ((document.edit_trans_form.payee_payer_text.value[0] == "R" || document.edit_trans_form.payee_payer_text.value[0] == "r") && document.edit_trans_form.payee_payer_text.value[1] == ">" && document.edit_trans_form.payee_payer_text.value[2] == " ")
      {
        alert("No match for remembered payee-payer found!");
        document.edit_trans_form.payee_payer_text.value = "";
      }
    }
    // if blank is typed in, uncheck the remembered checkbox
    // make sure the payee-payer is not empty
    payee_payer = "";
    payee_payer = document.edit_trans_form.payee_payer_text.value;
    for (var count=0; count < payee_payer.length && non_space_found == false; count++)
    {
      if (payee_payer[count] != " ")
      {
        non_space_found = true;
      }
    }
    if (!non_space_found)
    {
      // clear the payee-payer text field
      document.edit_trans_form.payee_payer_text.value = "";
      document.edit_trans_form.remembered_check.checked = false;
      // select the first (blank) payee-payer
      document.edit_trans_form.payee_payer_select.selectedIndex = 0;
    }
  }

  function payee_payer_select_change()
  {
    // set the payee_payer_text field to the string value of the option selected
    if (document.edit_trans_form.payee_payer_select.selectedIndex != 0)
    {
      document.edit_trans_form.payee_payer_text.value = document.edit_trans_form.payee_payer_select.options[document.edit_trans_form.payee_payer_select.selectedIndex].text;
      // select the last used journal code for the payee-payer from the journal code select
      document.edit_trans_form.journal_code_select.selectedIndex = journal_code_array[document.edit_trans_form.payee_payer_select.options[document.edit_trans_form.payee_payer_select.selectedIndex].value];
    }
    else
    {
      document.edit_trans_form.payee_payer_text.value = "";
    }
    // if blank is selected, uncheck the remembered checkbox
    if (document.edit_trans_form.payee_payer_select.options[document.edit_trans_form.payee_payer_select.selectedIndex].text == "" || document.edit_trans_form.payee_payer_select.options[document.edit_trans_form.payee_payer_select.selectedIndex].value == -1)
    {
      document.edit_trans_form.remembered_check.checked = false;
    }
  }

  function trans_month_text_change()
  {
    var date_array = new Array();
    var value;

    // split the date on "-"'s
    date_array = document.edit_trans_form.trans_date.value.split("-", 3);

    // make sure the value entered is a number
    value = document.edit_trans_form.trans_month_text.value;
    if (isNaN(parseInt(value, 10)))
    {
      if (value != "")
      {
        alert("Month value entered is not a number!\\nValue: " + value);
        document.edit_trans_form.trans_month_text.value = "";
        document.edit_trans_form.trans_month_text.focus();
      }
    }
    else
    {
      value = parseInt(value, 10);
      // make sure the month is between 1 and 12
      if (value < 1 || value > 12)
      {
        alert("Month value entered is out of range (1 - 12)!");
        document.edit_trans_form.trans_month_text.value = "";
        document.edit_trans_form.trans_month_text.focus();
      }
      else
      {
        // change the date_array element to contain the entered value
        date_array[0] = value;
        // clear the input field
        document.edit_trans_form.trans_month_text.value = "";
        // output the modified date
        document.edit_trans_form.trans_date.value = date_array[0] + "-" + date_array[1] + "-" + date_array[2];
        // validate the entered value
        trans_date_change();
      }
    }
  }

  function trans_day_text_change()
  {
    var date_array = new Array();
    var value;

    // split the date on "-"'s
    date_array = document.edit_trans_form.trans_date.value.split("-", 3);

    // make sure the value entered is a number
    value = document.edit_trans_form.trans_day_text.value;
    if (isNaN(parseInt(value, 10)))
    {
      if (value != "")
      {
        alert("Day value entered is not a number!\\nValue: " + value);
        document.edit_trans_form.trans_day_text.value = "";
        document.edit_trans_form.trans_day_text.focus();
      }
    }
    else
    {
      value = parseInt(value, 10);
      // make sure the day is between 1 and 31
      if (value < 1 || value > 31)
      {
        alert("Day value entered is out of range (1 - 31)!");
        document.edit_trans_form.trans_day_text.value = "";
        document.edit_trans_form.trans_day_text.focus();
      }
      else
      {
        // change the date_array element to contain the entered value
        date_array[1] = value;
        // clear the input field
        document.edit_trans_form.trans_day_text.value = "";
        // output the modified date
        document.edit_trans_form.trans_date.value = date_array[0] + "-" + date_array[1] + "-" + date_array[2];
        // validate the entered value
        trans_date_change();
      }
    }
  }

  function trans_year_text_change()
  {
    var date_array = new Array();
    var value;

    // split the date on "-"'s
    date_array = document.edit_trans_form.trans_date.value.split("-", 3);

    // make sure the value entered is a number
    value = document.edit_trans_form.trans_year_text.value;
    if (isNaN(parseInt(value, 10)))
    {
      if (value != "")
      {
        alert("Year value entered is not a number!\\nValue: " + value);
        document.edit_trans_form.trans_year_text.value = "";
        document.edit_trans_form.trans_year_text.focus();
      }
    }
    else
    {
      value = parseInt(value, 10);
      // make sure the year is greater than or equal to the beginning fiscal year value
      if (value < start_year_fiscal)
      {
        alert("Year value entered is less than the beginning fiscal year value (" + start_year_fiscal + ")!");
        document.edit_trans_form.trans_year_text.value = "";
        document.edit_trans_form.trans_year_text.focus();
      }
      else
      {
        // change the date_array element to contain the entered value
        date_array[2] = value;
        // clear the input field
        document.edit_trans_form.trans_year_text.value = "";
        // output the modified date
        document.edit_trans_form.trans_date.value = date_array[0] + "-" + date_array[1] + "-" + date_array[2];
        // validate the entered value
        trans_date_change();
      }
    }
  }

  function trans_date_change()
  {
    // parse the inputted date for validity to see if it falls between the start and stop dates of the current fiscal range
    var date_to_parse = new Date();
    var month;
    var day;
    var day1;
    var day2;
    var year;
    var date_string;
    var regular_expression;
    var date_array = new Array();

    regular_expression = new RegExp("-", "g");
    // before parsing date text field, substitute all "-"'s with "/"'s
    date_string = document.edit_trans_form.trans_date.value;
    date_string = date_string.replace(regular_expression, "/");
    // determine if the date string has a month, day, and year by 'split'ting it on '/'s and seeing how many array elements are returned
    date_array = date_string.split("/");
    if (date_array.length == 2)
    {
      // year was not entered; attempt to determine which fiscal year to enter based on the month and day values
      month = date_array[0];
      day = date_array[1];
      if (month >= start_month_fiscal)
      {
        year = start_year_fiscal;
      }
      else if (month <= stop_month_fiscal)
      {
        year = stop_year_fiscal;
      }
      day1 = Math.floor(day/10);
      day2 = day % 10;
    }
    else
    {
      // make sure they entered a correct year; if not, mangle the year into one of the (possibly) two year values for the fiscal range
      if (parseInt(date_array[2], 10) < 100)  // user entered a two or less digit year
      {
        var year_count = start_year_fiscal;
        var year_check;
        var year_stop = parseInt(date_array[2], 10);
        // run from the start_fiscal_year up to the value entered by adding to the start year until the last two digits match the counter
        year_check = parseInt(year_count % 100, 10);
        while (year_check != year_stop)
        {
          year_count++;
          year_check = parseInt(year_count % 100, 10);
        }
        year = year_count;
        month = date_array[0];
        day = date_array[1];
        day1 = Math.floor(day/10);
        day2 = day % 10;
      }
      else
      {
        date_to_parse.setTime(Date.parse(date_string));
        month = parseInt(date_to_parse.getMonth()) + 1;
        day = parseInt(date_to_parse.getDate());
        day1 = Math.floor(day/10);
        day2 = day % 10;
        year = parseInt(date_to_parse.getFullYear());
      }
    }

    // make sure that year is in the fiscal range of years
    if (year != start_year_fiscal && year != stop_year_fiscal)
    {
      if (year > stop_year_fiscal)
      {
        if (!confirm("You are entering a date that is in the future\\\nbased on the current fiscal range.\\\nDo you want to enter this date?"))
        {
          month = old_trans_month;
          day1 = old_trans_day1;
          day2 = old_trans_day2;
          year = old_trans_year;
        }
        else
        {
          date_valid = true;
        }
      }
      else
      {
        date_valid = false;
        alert("Year entered is not in fiscal range!");
        return;
      }
    }
    // make sure that month entered is in fiscal range for the year input
    if (year == start_year_fiscal && month < start_month_fiscal)
    {
      date_valid = false;
      alert("Month entered is not in fiscal range!");
      return;
    }
    if (year == stop_year_fiscal && month > stop_month_fiscal)
    {
      if (!confirm("You are entering a date that is in the future\\\nbased on the current fiscal range.\\\nDo you want to enter this date?"))
      {
        month = old_trans_month;
        day1 = old_trans_day1;
        day2 = old_trans_day2;
        year = old_trans_year;
      }
      else
      {
        date_valid = true;
      }
    }
    // make sure that day entered is in fiscal range for the year and month input
    if (year == start_year_fiscal && month == start_month_fiscal && day < start_day_fiscal)
    {
      date_valid = false;
      alert("Day entered is not in fiscal range!");
      return;
    }
    if (year == stop_year_fiscal && month == stop_month_fiscal && day > stop_day_fiscal)
    {
      if (!confirm("You are entering a date that is in the future\\\nbased on the current fiscal range.\\\nDo you want to enter this date?"))
      {
        month = old_trans_month;
        day1 = old_trans_day1;
        day2 = old_trans_day2;
        year = old_trans_year;
      }
      else
      {
        date_valid = true;
      }
    }

    // redisplay the date from the parsed input into the trans_date text field
    document.edit_trans_form.trans_date.value = month + "-" + day1 + day2 + "-" + year;
    old_trans_month = month;
    old_trans_day1 = day1;
    old_trans_day2 = day2;
    old_trans_year = year;
  }

  function validate_form()
  {
    var date_to_parse = new Date();
    var month;
    var day;
    var day1;
    var day2;
    var year;
    var date_string;
    var regular_expression;
    var payee_payer;
    var non_space_found = false;

    // make sure the date is within the fiscal year range

    regular_expression = new RegExp("-", "g");
    // before parsing date text field, substitute all "-"'s with "/"'s
    date_string = document.edit_trans_form.trans_date.value;
    date_string = date_string.replace(regular_expression, "/");
    date_to_parse.setTime(Date.parse(date_string));
    month = parseInt(date_to_parse.getMonth()) + 1;
    day = parseInt(date_to_parse.getDate());
    day1 = Math.floor(day/10);
    day2 = day % 10;
    year = parseInt(date_to_parse.getFullYear());

    // make sure that year is in the fiscal range of years
    if (year != start_year_fiscal && year != stop_year_fiscal)
    {
      if (!date_valid)
      {
        alert("Year entered is not in fiscal range!");
        return false;
      }
    }
    // make sure that month entered is in fiscal range for the year input
    if (year == start_year_fiscal && month < start_month_fiscal)
    {
      alert("Month entered is not in fiscal range!");
      return false;
    }
    if (year == stop_year_fiscal && month > stop_month_fiscal)
    {
      if (!date_valid)
      {
        alert("Month entered is not in fiscal range!");
        return false;
      }
    }
    // make sure that day entered is in fiscal range for the year and month input
    if (year == start_year_fiscal && month == start_month_fiscal && day < start_day_fiscal)
    {
      alert("Day entered is not in fiscal range!");
      return false;
    }
    if (year == stop_year_fiscal && month == stop_month_fiscal && day > stop_day_fiscal)
    {
      if (!date_valid)
      {
        alert("Day entered is not in fiscal range!");
        return false;
      }
    }

    // make sure the payee-payer is not empty
    payee_payer = document.edit_trans_form.payee_payer_text.value;
    for (var count=0; count < payee_payer.length && non_space_found == false; count++)
    {
      if (payee_payer[count] != " ")
      {
        non_space_found = true;
      }
    }
    if (!non_space_found)
    {
      // clear the payee-payer text field
      document.edit_trans_form.payee_payer_text.value = "";
      document.edit_trans_form.remembered_check.checked = false;
    }
    return true;
  }
//-->
</script>
END_OF_STYLE
# get the date
$date = `/bin/date +%m-%d-%Y`;
chomp $date;
$date_ago = `/bin/date -d '1 year 6 months ago' +%m-%d-%Y`;
chomp $date_ago;

print "<center>\n";
print "<table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
if ($mode eq "edit")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Updating Journal <font color=\"blue\">$journal_name</font>";
}
elsif ($mode eq "new")
{
  print "<td align=left width=47%><font color=\"red\">";
  print "Creating Journal Entry in Journal <font color=\"blue\">$journal_name</font>";
}
print " in Ledger <font color=\"$ledger_color\">$ledger_name</font></font></td>\n";
print "<td align=left><a href=\"$site_dir/help.html#journal\" target=\"docs\"><img border=0 src=\"$site_dir/images/help.jpg\" alt=\"Help\"></a></td>\n";
print "<td align=right>$date</td></tr></table>\n<hr><br>\n";
print PrintStandardLedgerMainMenu($ledger_db);

if ($mode eq "edit") # update the journal entry in journal_entry_tb, delete all references to the journal entry in debitcredit_tb, add them back to debitcredit_tb
{
  # update first portion of transaction (journal_entry_tb)
  $ref_num = $input{'ref_num'};
  $journal_code = $input{'journal_code'};
  $trans_date = $input{'trans_date'};
  $payee_payer = $input{'payee_payer'};
  # escape all ('), ($), (\) characters
  $payee_payer =~ s/\\/\\\\/g;
  $payee_payer =~ s/\'/\\\'/g;
  $payee_payer =~ s/\$/\\\$/g;
  $remember = $input{'remember'};
  $memo = $input{'memo'};
  # escape all ('), ($), (\) characters
  $memo =~ s/\\/\\\\/g;
  $memo =~ s/\'/\\\'/g;
  $memo =~ s/\$/\\\$/g;
  $result = $conn->exec("update journal_entry_tb set journal_code = '$journal_code', trans_date = '$trans_date', payee_payer = '$payee_payer', memo = '$memo', remember = $remember where ref_num = $ref_num AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error: Updating database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to update the information for journal entry $ref_num.<br>$sys_admin";
    CleanUp();
  }
  print "<table border=1 cellspacing=0 cellpadding=$table_cellpadding bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th>Ref#</th><th>Jnl</th><th>Date</th><th>Payee-Payer</th><th>Remember</th><th>Memo</th>\n";
  print "</tr>\n";
  print "<tr align=center>\n";
  print "<td>$ref_num</td>\n";
  print "<td>$journal_code</td>\n";
  print "<td>$trans_date</td>\n";
  if ($payee_payer eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$payee_payer</td>\n";
  }
  if ($remember eq "true")
  {
    print "<td>Yes</td>\n";
  }
  else
  {
    print "<td>No</td>\n";
  }
  if ($memo eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$memo</td>\n";
  }
  print "</tr>\n";
  print "</table>\n";
  # delete values from debitcredit_tb with parent_num == ref_num of journal entry
  $result = $conn->exec("delete from debitcredit_tb where parent_num = $ref_num AND ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error: Deleting entries from debit/credit table failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to remove the entries for journal entry $ref_num.<br>$sys_admin";
    CleanUp();
  }
  print "<table border=1 cellspacing=0 cellpadding=$table_cellpadding bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th>SbE</th><th>Account</th><th>SubAccount</th><th>Debit</th><th>Credit</th><th>Cleared</th><th>Counter</th>\n";
  print "</tr>\n";
  # insert values into debitcredit_tb with old and new information
  for ($count=0; $count < $transaction_debit_count; $count++)
  {
    $transaction_key = "$count - se";
    $sub_entity_element = $transaction_debits_values{$transaction_key};

    $transaction_key = "$count - ac";
    $account_element = $transaction_debits_values{$transaction_key};

    $transaction_key = "$count - sa";
    $sub_account_element = $transaction_debits_values{$transaction_key};
    if ($sub_account_element eq "")
    {
      $sub_account_element = "-1";
    }

    $transaction_key = "$count - cd";
    $sub_account_text = $transaction_debits_values{$transaction_key};
    if ($sub_account_text eq "")
    {
      $sub_account_text = "-1";
    }
    if ($sub_account_element ne "C" and $sub_account_element ne "D")
    {
      $sub_account_text = $sub_account_element;
    }

    $transaction_key = "$count - am";
    $amount = $transaction_debits_values{$transaction_key};
    $dorc = "true";

    $transaction_key = "$count - cl";
    $cleared = $transaction_debits_values{$transaction_key};

    # insert values into database
    $result = $conn->exec("insert into debitcredit_tb (parent_num, trans_date, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter, ledger_code, d_amount, c_amount) values ($ref_num, '$trans_date', '$sub_entity_element', '$account_element', '$sub_account_text', '$amount', $dorc, '$cleared', $count, '$ledger_code', dorcify('$amount', '$dorc', debit_increases_account_num('$account_element')), dorcify('$amount', '$dorc', class_action_account_num('$account_element', 'cash')) )");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error: Inserting data failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to insert row data for journal entry $ref_num.<br>$sys_admin";
      CleanUp();
    }
    print "<tr align=center>\n";
    if ($sub_entity_element eq "")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$sub_entity_element</td>\n";
    }
    print "<td>$account_element</td>\n";
    if ($sub_account_text ne "-1")
    {
      print "<td>$sub_account_text</td>\n";
    }
    else
    {
      print "<td><br></td>\n";
    }
    if ($dorc eq "true")
    {
      print "<td align=right>$amount</td>\n";
      print "<td><br></td>\n";
    }
    else
    {
      print "<td><br></td>\n";
      print "<td align=right>$amount</td>\n";
    }
    if ($cleared eq " ")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$cleared</td>\n";
    }
    print "<td>$count</td>\n";
    print "</tr>\n";
  }
  for ($count2=0; $count2 < $transaction_credit_count; $count++, $count2++)
  {
    $transaction_key = "$count2 - se";
    $sub_entity_element = $transaction_credits_values{$transaction_key};

    $transaction_key = "$count2 - ac";
    $account_element = $transaction_credits_values{$transaction_key};

    $transaction_key = "$count2 - sa";
    $sub_account_element = $transaction_credits_values{$transaction_key};
    if ($sub_account_element eq "")
    {
      $sub_account_element = "-1";
    }

    $transaction_key = "$count2 - cd";
    $sub_account_text = $transaction_credits_values{$transaction_key};
    if ($sub_account_text eq "")
    {
      $sub_account_text = "-1";
    }
    if ($sub_account_element ne "C" and $sub_account_element ne "D")
    {
      $sub_account_text = $sub_account_element;
    }

    $transaction_key = "$count2 - am";
    $amount = $transaction_credits_values{$transaction_key};
    $dorc = "false";

    $transaction_key = "$count2 - cl";
    $cleared = $transaction_credits_values{$transaction_key};

    # insert values into database
    $result = $conn->exec("insert into debitcredit_tb (parent_num, trans_date, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter, ledger_code, d_amount, c_amount) values ($ref_num, '$trans_date', '$sub_entity_element', '$account_element', '$sub_account_text', '$amount', $dorc, '$cleared', $count, '$ledger_code', dorcify('$amount', '$dorc', debit_increases_account_num('$account_element')), dorcify('$amount', '$dorc', class_action_account_num('$account_element', 'cash')) )");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error: Inserting data failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to insert row data for journal entry $ref_num.<br>$sys_admin";
      CleanUp();
    }
    print "<tr align=center>\n";
    if ($sub_entity_element eq "")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$sub_entity_element</td>\n";
    }
    print "<td>$account_element</td>\n";
    if ($sub_account_text ne "-1")
    {
      print "<td>$sub_account_text</td>\n";
    }
    else
    {
      print "<td><br></td>\n";
    }
    if ($dorc eq "true")
    {
      print "<td align=right>$amount</td>\n";
      print "<td><br></td>\n";
    }
    else
    {
      print "<td><br></td>\n";
      print "<td align=right>$amount</td>\n";
    }
    if ($cleared eq " ")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$cleared</td>\n";
    }
    print "<td>$count</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
}
elsif ($mode eq "new") # create a new journal entry in journal_entry_tb with ref_num from sequence, create entries in debitcredit_tb
{
  # get next ref_num value
  $result = $conn->exec("select nextval('journal_entry_tb_ref_num_seq')");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Attempted to retrieve the next reference number.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples == 0)
  {
    print "<h1>Error: Next journal reference value not available!</h1>\n";
    print "Attempted to retrieve the next reference number.  No records were returned.<br>$sys_admin";
    CleanUp();
  }
  else
  {
    $ref_num = $result->getvalue(0, 0);
  }
  # insert values into journal_entry_tb and debitcredit_tb
  $journal_code = $input{'journal_code'};
  $trans_date = $input{'trans_date'};
  $payee_payer = $input{'payee_payer'};
  # escape all ('), ($), (\) characters
  $payee_payer =~ s/\\/\\\\/g;
  $payee_payer =~ s/\'/\\\'/g;
  $payee_payer =~ s/\$/\\\$/g;
  $memo = $input{'memo'};
  # escape all ('), ($), (\) characters
  $memo =~ s/\\/\\\\/g;
  $memo =~ s/\'/\\\'/g;
  $memo =~ s/\$/\\\$/g;
  $remember = $input{'remember'};
  $result = $conn->exec("insert into journal_entry_tb (ref_num, journal_code, trans_date, payee_payer, memo, remember, ledger_code) values ($ref_num, '$journal_code', '$trans_date', '$payee_payer', '$memo', $remember, '$ledger_code')");
  if ($result->resultStatus != PGRES_COMMAND_OK)
  {
    print "<h1>Error: Failed to insert data into database!</h1>\n";
    print $conn->errorMessage . "<br>Tried to create new journal entry.<br>$sys_admin";
    CleanUp();
  }
  print "<table border=1 cellspacing=0 cellpadding=$table_cellpadding bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th>Ref#</th><th>Jnl</th><th>Date</th><th>Payee-Payer</th><th>Remember</th><th>Memo</th>\n";
  print "</tr>\n";
  print "<tr align=center>\n";
  print "<td>$ref_num</td>\n";
  print "<td>$journal_code</td>\n";
  print "<td>$trans_date</td>\n";
  if ($payee_payer eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$payee_payer</td>\n";
  }
  if ($remember eq "true")
  {
    print "<td>Yes</td>\n";
  }
  else
  {
    print "<td>No</td>\n";
  }
  if ($memo eq "")
  {
    print "<td><br></td>\n";
  }
  else
  {
    print "<td>$memo</td>\n";
  }
  print "</tr>\n";
  print "</table>\n";

  print "<table border=1 cellspacing=0 cellpadding=$table_cellpadding bgcolor=\"$body_bgcolor\">\n";
  print "<tr>\n";
  print "<th>SbE</th><th>Account</th><th>SubAccount</th><th>Debit</th><th>Credit</th><th>Cleared</th><th>Counter</th>\n";
  print "</tr>\n";
  for ($count=0; $count < $transaction_debit_count; $count++)
  {
    $transaction_key = "$count - se";
    $sub_entity_element = $transaction_debits_values{$transaction_key};

    $transaction_key = "$count - ac";
    $account_element = $transaction_debits_values{$transaction_key};

    $transaction_key = "$count - sa";
    $sub_account_element = $transaction_debits_values{$transaction_key};
    if ($sub_account_element eq "")
    {
      $sub_account_element = "-1";
    }

    $transaction_key = "$count - cd";
    $sub_account_text = $transaction_debits_values{$transaction_key};
    if ($sub_account_text eq "")
    {
      $sub_account_text = "-1";
    }
    if ($sub_account_element ne "C" and $sub_account_element ne "D")
    {
      $sub_account_text = $sub_account_element;
    }

    $transaction_key = "$count - am";
    $amount = $transaction_debits_values{$transaction_key};
    $dorc = "true";
    $cleared = " ";

    # insert values into database
    $result = $conn->exec("insert into debitcredit_tb (parent_num, trans_date, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter, ledger_code, d_amount, c_amount) values ($ref_num, '$trans_date', '$sub_entity_element', '$account_element', '$sub_account_text', '$amount', $dorc, '$cleared', $count, '$ledger_code', dorcify('$amount', '$dorc', debit_increases_account_num('$account_element')), dorcify('$amount', '$dorc', class_action_account_num('$account_element', 'cash')) )");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error: Inserting data failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to insert row data for journal entry $ref_num.<br>$sys_admin";
      CleanUp();
    }
    print "<tr align=center>\n";
    if ($sub_entity_element eq "")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$sub_entity_element</td>\n";
    }
    print "<td>$account_element</td>\n";
    if ($sub_account_text ne "-1")
    {
      print "<td>$sub_account_text</td>\n";
    }
    else
    {
      print "<td><br></td>\n";
    }
    if ($dorc eq "true")
    {
      print "<td align=right>$amount</td>\n";
      print "<td><br></td>\n";
    }
    else
    {
      print "<td><br></td>\n";
      print "<td align=right>$amount</td>\n";
    }
    if ($cleared eq " ")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$cleared</td>\n";
    }
    print "<td>$count</td>\n";
    print "</tr>\n";
  }
  for ($count2=0; $count2 < $transaction_credit_count; $count++, $count2++)
  {
    $transaction_key = "$count2 - se";
    $sub_entity_element = $transaction_credits_values{$transaction_key};

    $transaction_key = "$count2 - ac";
    $account_element = $transaction_credits_values{$transaction_key};

    $transaction_key = "$count2 - sa";
    $sub_account_element = $transaction_credits_values{$transaction_key};
    if ($sub_account_element eq "")
    {
      $sub_account_element = "-1";
    }

    $transaction_key = "$count2 - cd";
    $sub_account_text = $transaction_credits_values{$transaction_key};
    if ($sub_account_text eq "")
    {
      $sub_account_text = "-1";
    }
    if ($sub_account_element ne "C" and $sub_account_element ne "D")
    {
      $sub_account_text = $sub_account_element;
    }

    $transaction_key = "$count2 - am";
    $amount = $transaction_credits_values{$transaction_key};
    $dorc = "false";
    $cleared = " ";

    # insert values into database
    $result = $conn->exec("insert into debitcredit_tb (parent_num, trans_date, sub_e_code, account_num, sub_account_num, amount, dorc, cleared, counter, ledger_code, d_amount, c_amount) values ($ref_num, '$trans_date', '$sub_entity_element', '$account_element', '$sub_account_text', '$amount', $dorc, '$cleared', $count, '$ledger_code', dorcify('$amount', '$dorc', debit_increases_account_num('$account_element')), dorcify('$amount', '$dorc', class_action_account_num('$account_element', 'cash')) )");
    if ($result->resultStatus != PGRES_COMMAND_OK)
    {
      print "<h1>Error: Inserting data failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to insert row data for journal entry $ref_num.<br>$sys_admin";
      CleanUp();
    }
    print "<tr align=center>\n";
    if ($sub_entity_element eq "")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$sub_entity_element</td>\n";
    }
    print "<td>$account_element</td>\n";
    if ($sub_account_text ne "-1")
    {
      print "<td>$sub_account_text</td>\n";
    }
    else
    {
      print "<td><br></td>\n";
    }
    if ($dorc eq "true")
    {
      print "<td align=right>$amount</td>\n";
      print "<td><br></td>\n";
    }
    else
    {
      print "<td><br></td>\n";
      print "<td align=right>$amount</td>\n";
    }
    if ($cleared eq " ")
    {
      print "<td><br></td>\n";
    }
    else
    {
      print "<td>$cleared</td>\n";
    }
    print "<td>$count</td>\n";
    print "</tr>\n";
  }
  print "</table>\n";
}

# commit the transaction; everything successfully updated
$result = $conn->exec("commit work");
if ($result->resultStatus != PGRES_COMMAND_OK)
{
  print "<h1>Error: Could not end transaction!</h1>\n";
  print "Failed to end the transaction!  Record(s) not updated!<br>$sys_admin";
  CleanUp();
}

if ($mode eq "edit")
{
  print "<br>Update of journal entry $ref_num successful.<br>\n";
}
elsif ($mode eq "new")
{
  print "<br>Insert of new journal entry $ref_num successful.<br>\n";
}

# re-edit the just created or edited journal transaction
print "<br><br>\n";
print "<form method=post name=\"edit_trans_form1\" action=\"$site_dir/cgi-bin/journal_activity.cgi\">\n";
print "  <input type=\"hidden\" name=\"ledger\" value=\"$ledger_db\">\n";
print "  <input type=\"hidden\" name=\"journal_code\" value=\"G\">\n";
print "  <input type=\"hidden\" name=\"journal_command\" value=\"edit\">\n";
print "  <input type=\"hidden\" name=\"journal_entry\" value=\"$ref_num\">\n";
print "  <input type=\"submit\" value=\"Re-edit Transaction\">\n";
print "</form>\n";

# print a horizontal rule to break the menu from the behind the scenes links
print "<br><hr>\n";
print "</center>\n";

# get the date of the largest reference number
$result = $conn->exec("select max(ref_num) from journal_entry_tb WHERE ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get the maximum ref_num in order to get the most recently entered date.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  $trans_date = `/bin/date +%m-%d-%Y`;
  chomp $trans_date;
}
elsif ($result->ntuples == 1)
{
  if ($result->getvalue(0, 0) eq "")
  {
    $trans_date = `/bin/date +%m-%d-%Y`;
    chomp $trans_date;
  }
  else
  {
    $result2 = $conn->exec("select trans_date from journal_entry_tb where ledger_code = '$ledger_code' AND ref_num = " . $result->getvalue(0, 0));
    if ($result2->resultStatus != PGRES_TUPLES_OK)
    {
      print "<h1>Error: Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get trans_date from record " . $result->getvalue(0, 0) . ".<br>$sys_admin";
      CleanUp();
    }
    if ($result2->ntuples == 1)
    {
      $trans_date = $result2->getvalue(0, 0);
    }
    else
    {
      print "<h1>Error: Wrong number of records returned!</h1>\n";
      print $result2->ntuples . " records were returned. There should be only one.<br>$sys_admin";
      CleanUp();
    }
  }
}
else
{
  print "<h1>Error: Too many records returned!</h1>\n";
  print "There should only be one date returned for the maximum reference number.<br>$sys_admin";
  CleanUp();
}
($trans_month, $trans_day, $trans_year) = split "-", $trans_date;
$trans_day1 = int ($trans_day / 10);
$trans_day2 = int ($trans_day % 10);
$payee_payer = "";
$memo = "";
$remember = "f";

if ($trans_year < $start_year_fiscal || $trans_year > $stop_year_fiscal)
{
  $trans_month = $start_month_fiscal;
  $trans_day = $start_day_fiscal;
  $trans_day1 = int ($start_day_fiscal / 10);
  $trans_day2 = int ($start_day_fiscal % 10);
  $trans_year = $start_year_fiscal;
  $trans_date = $trans_month . "-" . $trans_day . "-" . $trans_year;
}
elsif (($trans_month < $start_month_fiscal && $trans_year == $start_year_fiscal) || ($trans_month > $stop_month_fiscal && $trans_year == $stop_year_fiscal))
{
  $trans_month = $start_month_fiscal;
  $trans_day = $start_day_fiscal;
  $trans_day1 = int ($start_day_fiscal / 10);
  $trans_day2 = int ($start_day_fiscal % 10);
  $trans_year = $start_year_fiscal;
  $trans_date = $trans_month . "-" . $trans_day . "-" . $trans_year;
}
elsif (($trans_day < $start_day_fiscal && $trans_month == $start_month_fiscal && $trans_year == $start_year_fiscal) || ($trans_day > $stop_day_fiscal && $trans_month == $stop_month_fiscal && $trans_year == $stop_year_fiscal))
{
  $trans_month = $start_month_fiscal;
  $trans_day = $start_day_fiscal;
  $trans_day1 = int ($start_day_fiscal / 10);
  $trans_day2 = int ($start_day_fiscal % 10);
  $trans_year = $start_year_fiscal;
  $trans_date = $trans_month . "-" . $trans_day . "-" . $trans_year;
}

# get the journal codes from the ledger to fill in the journal_code_array
$result = $conn->exec("select code from journal_tb WHERE code <> 'IS'"); # remove investment journal code from list
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\">$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to retrieve Journal Codes from ledger.<br>$sys_admin";
  CleanUp();
}
if ($result->ntuples == 0)
{
  print "<h1>Error: No journals defined for the ledger $ledger_db!</h1>\n";
  print "$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  $journal_code_array[$count] = $result->getvalue($count, 0);
}

# get the payee/payers in the current fiscal year for remembered transactions from the ledger to fill in the payee_payer_array
$result = $conn->exec("select payee_payer, memo, ref_num from journal_entry_tb where remember = true and trans_date between '$start_fiscal' and '$stop_fiscal' AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get remembered payee/payers for fiscal year.<br>$sys_admin";
  CleanUp();
}
for ($count=0; $count < $result->ntuples; $count++)
{
  # add payee/payers to payee_payer_array with R> in front and " - " and up to 8 characters of the memo field at the end
  $payee_payer_array[$count] = "R> " . $result->getvalue($count, 0) . " - " . substr($result->getvalue($count, 1), 0, 8);
  $payee_payer_ref_num_array[$count] = $result->getvalue($count, 2);
}
# get the distinct payee/payers from the current date back a year and a half for all most recently entered journal entries (recall data)
$result = $conn->exec("select distinct payee_payer from journal_entry_tb where trans_date between '$date_ago' and '$date' AND ledger_code = '$ledger_code'");
if ($result->resultStatus != PGRES_TUPLES_OK)
{
  print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
  print $conn->errorMessage . "<br>Tried to get unique payee/payers for one year and a half ago to now.<br>$sys_admin";
  CleanUp();
}
for ($count2=0; $count2 < $result->ntuples; $count++, $count2++)
{
  $payee_payer_array[$count] = $result->getvalue($count2, 0);
  $temp_payee_payer = $payee_payer_array[$count];
  $temp_payee_payer =~ s/\\/\\\\/g;
  $temp_payee_payer =~ s/\'/\\\'/g;
  $temp_payee_payer =~ s/\$/\\\$/g;
  # get the maximum ref_num for the payee_payer entry
  $result2 = $conn->exec("select max(ref_num) from journal_entry_tb where payee_payer = '" . $temp_payee_payer . "' AND ledger_code = '$ledger_code'");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing database <font color=\"blue\"$ledger_db</font> failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get max ref_num for distinct payee/payer " . $payee_payer_array[$count] . " for fiscal year.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples != 1)
  {
    print "<h1>Error: No value returned!</h1>\n";
    print "Tried to get max ref_num for distinct payee/payer.  No record returned!<br>$sys_admin";
    CleanUp();
  }
  $payee_payer_ref_num_array[$count] = $result2->getvalue(0, 0);
  # find the most recently used journal code for the unique set of payee-payers in the database
  $result2 = $conn->exec("select journal_code from journal_entry_tb where ledger_code = '$ledger_code' and payee_payer = '$temp_payee_payer' and ref_num = $payee_payer_ref_num_array[$count]");
  if ($result2->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the most recently used journal code for payee-payer: $temp_payee_payer.<br>$sys_admin";
    CleanUp();
  }
  if ($result2->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the most recently used journal code for payee-payer: $temp_payee_payer.<br>$sys_admin";
    CleanUp();
  }
  $payee_payer_journal_code_array[$count] = $result2->getvalue(0, 0);
}

print "<br>\n";
print "<div align=center><b>New Transaction</b></div>\n";
# start form
print "<form method=post name=\"edit_trans_form\" action=\"$site_dir/cgi-bin/journal_activity_rows_sheet.cgi\">\n";
# hidden ledger_name value
print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
# hidden journal code value
print "<input type=hidden name=\"journal_code\" value=\"$journal_code\">\n";
# hidden transaction date value
print "<input type=hidden name=\"trans_month\" value=\"$trans_month\">\n";
print "<input type=hidden name=\"trans_day1\" value=\"$trans_day1\">\n";
print "<input type=hidden name=\"trans_day2\" value=\"$trans_day2\">\n";
print "<input type=hidden name=\"trans_year\" value=\"$trans_year\">\n";
# hidden payee-payer value
print "<input type=hidden name=\"payee_payer\" value=\"$payee_payer\">\n";
# hidden memo value
print "<input type=hidden name=\"memo\" value=\"$memo\">\n";
# hidden mode for row script (edit or new)
print "<input type=hidden name=\"mode\" value=\"new\">\n";

print "<center>\n";
# build table out of the data
print "<table border=1 cellspacing=1 cellpadding=2 bgcolor=\"$body_bgcolor\">\n";
print "<tr>\n";
print "<th valign=top>Journal</th><th valign=top align=left>Date</th><th valign=top align=left>Payee-Payer</th>";
print "</tr>\n";
print "<tr nowrap>\n";
# journal code select
print "<td><select name=\"journal_code_select\">\n";
for ($count=0; $count < @journal_code_array; $count++)
{
  print "<option";
  if ($journal_code eq $journal_code_array[$count])
  {
    print " selected";
  }
  print ">" . $journal_code_array[$count] . "\n";
}
print "</select></td>\n";
# date input field
print "<td>\n";
print "M:<input type=text size=2 maxlength=2 name=\"trans_month_text\" value=\"\" onChange=\"trans_month_text_change();\">";
print "D:<input type=text size=2 maxlength=2 name=\"trans_day_text\" value=\"\" onChange=\"trans_day_text_change();\">";
print "Y:<input type=text size=4 maxlength=4 name=\"trans_year_text\" value=\"\" onChange=\"trans_year_text_change();\">";
print "&nbsp;<input type=text size=10 name=\"trans_date\" value=\"$trans_date\" onChange=\"trans_date_change()\">\n";
print "</td>\n";
# payee/payer select and input text field
print "<td><input type=text name=\"payee_payer_text\" value=\"$payee_payer\" size=25 onChange=\"payee_payer_text_change();\"> <select name=\"payee_payer_select\" onChange=\"payee_payer_select_change();\">\n";
print "<option value=\"-1\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\n";
for ($count=0; $count < @payee_payer_array; $count++)
{
  print "<option value=\"$payee_payer_ref_num_array[$count]\"";
  if ($payee_payer eq $payee_payer_array[$count])
  {
    print " selected";
  }
  print ">" . $payee_payer_array[$count] . "\n";
}
print "</select></td>\n";
print "</tr>\n";
print "<tr>\n";
print "<th align=left>Remembered</th><th colspan=2 align=left>Memo</th>\n";
print "</tr>\n";
print "<tr>\n";
# remembered check box
print "<td><input type=checkbox name=\"remembered_check\" value=\"ON\"";
if ($remember eq "t")
{
  print " checked";
}
print "></td>\n";
# memo text field
print "<td colspan=2><input type=text name=\"memo_text\" value=\"$memo\" size=75></td>\n";
print "</tr>\n";
print "</table>\n";
# adding the Javascript code for the most recently used journal code for payee-payers
print "<script language=Javascript>\n";
print "  <!--\n";
print "  // Inserting values for journal_code_array...\n";
my $match_found;
$match_found = 0;
for ($count=0; $count < scalar @payee_payer_ref_num_array; $count++)
{
  print "  journal_code_array[\"$payee_payer_ref_num_array[$count]\"] = ";
  # search for the journal code to assign the ref_num to
  for ($count2=0; $count2 < scalar @journal_code_array; $count2++)
  {
    if ($journal_code_array[$count2] eq $payee_payer_journal_code_array[$count])
    {
      print "$count2";
      $match_found = 1;
    }
  }
  if (not $match_found)
  {
    print "0";
  }
  else
  {
    $match_found = 0;
  }
  print ";\n";
}
print "  //-->\n";
print "</script>\n";
print "</center>\n";
print "<center><input type=submit name=\"create_submit\" value=\"Continue\" onClick=\"return validate_form();\"><input type=reset></center>\n";
my $temp_str;
$temp_str = GetJournalViewInput();
if (length $temp_str > 0)
{
  print "$temp_str";
}
print "</form>\n";
$temp_str = GetJournalViewInput();
if (length $temp_str > 0)
{
  print "<form name=\"journal_view_form\" method=post action=\"$site_dir/cgi-bin/journal_mod1.cgi\">\n";
  print "$temp_str";
  print "<br><br><a href=\"$site_dir/cgi-bin/journal_mod1.cgi\" onClick=\"document.journal_view_form.submit(); return false;\">To return to the Journal View, click <u>here</u>.</a>\n";
  print "</form>\n";
}

print "</body>\n";
print "</html>\n";
exit 0;

sub GetJournalViewInput
{
  my ($mode, $date_type, $date_from, $date_to, $redisplay_string, $journal_name, $journal_code, $ref_num, $error_string, $payee_payer, $memo, $account_name, $account_num, $sub_acct_name, $sub_acct_num, $sub_acct_parent);
  my ($money_type, $money_search, $money1, $money2, $sort_by, $sort_journal, $num_entries_to_display, $start_index, $ledger_db, $check_num, $deposit_num, $sort_operator);
  my %valid_entries_to_display = ( 0 => "all", 5 => "5", 10 => "10", 15 => "15", 20 => "20", 25 => "25", 30 => "30", 35 => "35", 40 => "40", 45 => "45", 50 => "50" );
  my %valid_options = ( "open" => "open", "delete" => "delete", "add" => "add", "search" => "search", "search2" => "search2" );

  if (not exists $input{'journal_view_command'})
  {
    return "";  # nothing to do.
  }
  if (not exists $valid_options{$input{'journal_view_command'}})
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Access Denied!</h1>\n";
    print "Invalid option given.  Option = '$input{'journal_view_command'}'.<br>$sys_admin";
    CleanUp();
  }

  $ledger_db = $input{'ledger'};
  if (length $ledger_db == 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error: You must specify a ledger to work with!</h1>\n";
    print "$back_button";
    CleanUp();
  }
  $error_string = IsValidString($ledger_db);
  if (length $error_string > 0)
  {
    PrintErrorHeader();
    print "<h1>(Journal View Re-display Code) Error:  Invalid Database Name!</h1>\n";
    print "<b>$error_string</b> is invalid!<br>$back_button";
    CleanUp();
  }
  $redisplay_string .= "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";

  # validate we got valid input from the user.
  if ($input{'journal_view_command'} eq "open")
  {
    $mode = 1;
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"open\">\n";
    if (not exists $input{'journal'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify a Journal to work with!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal\" value=\"" . $input{'journal'} . "\">\n";
    $date_from = $input{'date_from'};
    if (length $date_from == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a From date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to'};
    if (length $date_to == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a To date!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $sort_by = $input{'sort_by'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $redisplay_string .= "<input type=hidden name=\"date_from\" value=\"$date_from\">\n<input type=hidden name=\"date_to\" value=\"$date_to\">\n<input type=hidden name=\"sort_by\" value=\"" . $input{'sort_by'} . "\">\n";
  }
  elsif ($input{'journal_view_command'} eq "search")
  {
    $mode = 4;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'date_type'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date Qualifier must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_type = $input{'date_type'};
    if (not exists $input{'date_from_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search from must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($date_type eq "equal" || $date_type eq "betweeni" || $date_type eq "betweene" || $date_type eq "afteri" || $date_type eq "aftere" || $date_type eq "beforei" || $date_type eq "beforee"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date Qualifier Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $date_from = $input{'date_from_search'};
    if (not exists $input{'date_to_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Date to search to must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (length $date_from > 0 && (not IsValidDateSyntax($date_from)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The From date is invalid.<br>$back_button";
      CleanUp();
    }
    $date_to = $input{'date_to_search'};
    if (length $date_to > 0 && (not IsValidDateSyntax($date_to)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Date given!</h1>\n";
      print "The To date is invalid.<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search\">\n";
    $redisplay_string .= "<input type=hidden name=\"date_type\" value=\"$date_type\">\n<input type=hidden name=\"date_from_search\" value=\"$date_from\">\n<input type=hidden name=\"date_to_search\" value=\"$date_to\">\n";
    if (not exists $input{'journal2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Journal selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($journal_name, $journal_code) = split /\|/, $input{'journal2'};
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'check_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Check Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $check_num = $input{'check_num'};
    $error_string = IsValidUInteger($check_num);
    if (length $check_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Check Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'deposit_num'})
    {
      PrintErrorHeader();
      print "<h1>Error: Deposit Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $deposit_num = $input{'deposit_num'};
    $error_string = IsValidUInteger($deposit_num);
    if (length $deposit_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Deposit Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'payee_payer2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Payee-Payer selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $payee_payer = $input{'payee_payer2'};
    $error_string = IsValidString($payee_payer);
    if (length $payee_payer > 0 && length $error_string > 0 && (not $error_string eq "_"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Payee-Payer!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal2\" value=\"" . $input{'journal2'} . "\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n<input type=hidden name=\"check_num\" value=\"$check_num\">\n<input type=hidden name=\"deposit_num\" value=\"$deposit_num\">\n<input type=hidden name=\"payee_payer2\" value=\"$payee_payer\">\n";
    if (not exists $input{'memo2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Memo field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $memo = $input{'memo2'};
    $error_string = IsValidString($memo);
    if (length $memo > 0 && length $error_string > 0 && (not ($error_string eq "*" || $error_string eq "?")))
    {
      PrintErrorHeader();
      print "<h1(Journal View Re-display Code) >Error:  Invalid Memo!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if (not exists $input{'sub_entity'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code)Error: Sub Entity selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not exists $input{'account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($account_name, $account_num) = split /\|/, $input{'account'};
    if (not exists $input{'sub_account'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Sub Account selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    ($sub_acct_name, $sub_acct_num, $sub_acct_parent) = split /\|/, $input{'sub_account'};
    if (not exists $input{'dorc'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_type = $input{'dorc'};
    if (not ($money_type eq "select_dorc" || $money_type eq "debit" || $money_type eq "credit" || $money_type eq "both"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Selection type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"memo2\" value=\"$memo\">\n<input type=hidden name=\"account\" value=\"" . $input{'account'} . "\">\n<input type=hidden name=\"sub_account\" value=\"" . $input{'sub_account'} . "\">\n";
    $redisplay_string .= "<input type=hidden name=\"dorc\" value=\"$money_type\">\n<input type=hidden name=\"sub_entity\" value=\"$input{sub_entity}\">\n";
    if (not exists $input{'dorc_search'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Debit or Credit Search Type Selection must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money_search = $input{'dorc_search'};
    if (not ($money_search eq "all" || $money_search eq "equal" || $money_search eq "less_than" || $money_search eq "less_than_equal" || $money_search eq "greater_than" || $money_search eq "greater_than_equal" || $money_search eq "betweene" || $money_search eq "betweeni"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Debit or Credit Search type!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $money1 = $input{'money1'};
    $error_string = IsValidInteger($money1);
    my $error_string2 = IsValidFloat($money1);
    if (length $money1 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid First Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $redisplay_string .= "<input type=hidden name=\"dorc_search\" value=\"$money_search\">\n<input type=hidden name=\"money1\" value=\"$money1\">\n<input type=hidden name=\"money2\" value=\"" . $input{'money2'} . "\">\n";
    $money2 = $input{'money2'};
    $error_string = IsValidInteger($money2);
    $error_string2 = IsValidFloat($money2);
    if (length $money2 > 0)
    {
      if (length $error_string > 0 && (not $error_string eq "."))
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
      elsif (length $error_string > 0 && $error_string eq "." && length $error_string2 > 0)
      {
        PrintErrorHeader();
        print "<h1>(Journal View Re-display Code) Error:  Invalid Second Money Field!</h1>\n";
        print "<b>$error_string</b> is invalid!<br>$back_button";
        CleanUp();
      }
    }
    $sort_by = $input{'sort_by2'};
    if (length $sort_by == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify a SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    #print "\"$sort_by\"<br>";
    if (not ($sort_by eq "date" || $sort_by eq "ref_num" || $sort_by eq "payee_payer"))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid SortBy Option!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if ($sort_by eq "date")
    {
      $sort_by = "trans_date";
    }
    if (exists $input{'sort_journal'})
    {
      $sort_journal = 1;
      $redisplay_string .= "<input type=hidden name=\"sort_journal\" value=\"1\">\n";
    }
    else
    {
      $sort_journal = 0;
    }
    $sort_operator = $input{'sort_operator'};
    if (length $sort_operator == 0)
    {
      PrintErrorHeader();
      print "<h1>Error:  You must specify a Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (not ($sort_operator eq "AND" || $sort_operator eq "OR"))
    {
      PrintErrorHeader();
      print "<h1>Error:  Invalid Search Operator!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"sort_by2\" value=\"" . $input{'sort_by2'} . "\">\n<input type=hidden name=\"sort_operator\" value=\"$sort_operator\">\n";

    # make sure they entered something in at least one field, but not something in both the debit and credit fields.
    if ((length $input{'date_from_search'} == 0) && (length $input{'date_to_search'} == 0) && ($input{'journal2'} eq "select_journal") && (length $input{'ref_num2'} == 0) && (length $input{'check_num'} == 0) && (length $input{'deposit_num'} == 0) && ($input{'payee_payer2'} eq "select_payee_payer") && (length $input{'memo2'} == 0) && ($input{'account'} eq "select_account") && ($input{'sub_account'} eq "select_sub_acct") && ($input{'dorc'} eq "select_dorc") && ($input{'dorc_search'} eq "all") && (length $input{'money1'} == 0) && (length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify something for your search!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that the date_to_search field is given only if the date_type is "Between".
    if ((length $input{'date_from_search'} > 0) && (length $input{'date_to_search'} > 0) && ((not $input{'date_type'} eq "betweeni") && (not $input{'date_type'} eq "betweene")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify <b>Between</b> to use the second Date field!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    # make sure that both money fields are not both filled in if they are not doing a between search or no Dorc value selected.
    if ((length $input{'money1'} > 0) && (length $input{'money2'} > 0) && ((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "betweene") && (not $input{'dorc_search'} eq "betweeni")))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify both money fields when not searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (($input{'dorc_search'} eq "betweene" || $input{'dorc_search'} eq "betweeni") && (length $input{'money1'} == 0 || length $input{'money2'} == 0))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify both money fields when searching with between!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    if (((not $input{'dorc'} eq "select_dorc") && (not $input{'dorc_search'} eq "all")) && ((length $input{'money1'} == 0) && (length $input{'money2'} == 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You must specify an amount to search for!</h1>\n";
      print "Error: 1007<br>$back_button";
      CleanUp();
    }
    # make sure that if they enter a Ref-Num that they don't select anything else.
    if ((length $input{'ref_num2'} > 0) && ((length $input{'date_from_search'} > 0) || (length $input{'date_to_search'} > 0) || (length $input{'check_num'} > 0) || (length $input{'deposit_num'} > 0) || (not $input{'payee_payer2'} eq "select_payee_payer") || (not $input{'journal2'} eq "select_journal") || (not $input{'account'} eq "select_account") || (not $input{'sub_account'} eq "select_sub_acct") || (not $input{'dorc'} eq "select_dorc") || (not $input{'dorc_search'} eq "all") || (length $input{'money1'} > 0) || (length $input{'money2'} > 0) || (length $input{'memo2'} > 0)))
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  You can not specify anything else when specifying the Reference Number!</h1>\n";
      print "$back_button";
      CleanUp();
    }
  }
  elsif ($input{'journal_view_command'} eq "search2")
  {
    $mode = 5;
    # first make sure all the correct variables are being passed in.
    if (not exists $input{'ref_num2'})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: Reference Number field must be given!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $ref_num = $input{'ref_num2'};
    $error_string = IsValidUInteger($ref_num);
    if (length $ref_num > 0 && length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Ref Number!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"journal_view_command\" value=\"search2\">\n<input type=hidden name=\"ref_num2\" value=\"$ref_num\">\n";
  }

  if ($mode == 1 || $mode == 4 || $mode == 5)
  {
    $num_entries_to_display = $input{'num_entries_to_display'};
    if (length $num_entries_to_display == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the number of Journal entries to display!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($num_entries_to_display);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }

    # verify it is a valid value
    if (not exists $valid_entries_to_display{$num_entries_to_display})
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Number of Entries to Display!</h1>\n";
      print "<b>$num_entries_to_display</b> is not valid!<br>$back_button";
      CleanUp();
    }

    $start_index = $input{'start_index'};
    if (length $start_index == 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error: You must specify the Starting Index to work from!</h1>\n";
      print "$back_button";
      CleanUp();
    }
    $error_string = IsValidInteger($start_index);
    if (length $error_string > 0)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  Invalid Value for Start Index to display from!</h1>\n";
      print "<b>$error_string</b> is invalid!<br>$back_button";
      CleanUp();
    }
    if ($start_index < 1)
    {
      PrintErrorHeader();
      print "<h1>(Journal View Re-display Code) Error:  The Start Index can not be less than 1!</h1>\n";
      print "$sys_admin";
      CleanUp();
    }
    $redisplay_string .= "<input type=hidden name=\"num_entries_to_display\" value=\"$num_entries_to_display\">\n<input type=hidden name=\"start_index\" value=\"$start_index\">\n";
  }

  return $redisplay_string;  # return the string that will contain everything necessary to re-display the journal like how the person just left it.
}
