#$Id: reports_account_balance_sheet.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
my $display_total;
$display_total = 0;
my @balance_total;

sub reports3AccountBalanceSheetJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3AccountBalanceSheetJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified at least one complete date range
    var date1_start, date1_end, date2_start, date2_end, date3_start, date3_end, date4_start, date4_end;
    date1_start = doc.date1.value;
    date2_start = doc.date2.value;
    date3_start = doc.date3.value;
    date4_start = doc.date4.value;

    if (date1_start.length == 0 && date2_start.length == 0 && date3_start.length == 0 && date4_start.length == 0)
    {
      msg += "You must specify some dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is valid
    {
      if (date1_start.length > 0)
      {
        tmp = IsValidDateSyntax(date1_start);
        if (tmp.length > 0)
        {
          msg += "Date 1: " + tmp + "\\n";
        }
      }
      if (date2_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date2_start);
        if (tmp.length > 0)
        {
          msg += "Date 2: " + tmp + "\\n";
        }
      }
      if (date3_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date3_start);
        if (tmp.length > 0)
        {
          msg += "Date 3: " + tmp + "\\n";
        }
      }
      if (date4_start.length > 0) // check and make sure the dates are valid.
      {
        tmp = IsValidDateSyntax(date4_start);
        if (tmp.length > 0)
        {
          msg += "Date 4: " + tmp + "\\n";
        }
      }
    }
    // now verify that they have selected at least one account to work with.
    tmp = doc.accounts;
    var i, found=false;
    for (i=0; i < tmp.length; i++)
    {
      if (tmp.options[i].selected)
      {
        found = true;
      }
    }
    if (!found)
    {
      msg += "You must select an account to work with!\\n";
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3AccountBalanceSheetJavaScript
{
  print "<script language=Javascript1.2>\n";

  my ($account_list, $j, $num);
  $accounts = $conn->exec("select acct_num from local_accounts_tb where sub_entity_code is null AND ledger_code = '$ledger_code'");
  if ($accounts->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of accounts used in debitcredit table.<br>$sys_admin";
    CleanUp();
  }
  if ($accounts->ntuples > 0)
  {
    $account_list = "(";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      $num = $accounts->getvalue($j, 0);
      $account_list .= $num;
      if ($j < $accounts->ntuples-1)
      {
        $account_list .= ", ";
      }
    }
    $account_list .= ")";

    $accounts = $conn->exec("select name, number from account_tb where number in $account_list ORDER BY name, number");
    if ($accounts->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get info for global accounts that were used in the debitcredit table (ordered by Name - Number).<br>List = $account_list<br>$sys_admin";
      CleanUp();
    }

    # now we create the Javascript array for the Name-Number list
    print "  function create_group(value, text)\n  {\n    this.value = value;\n    this.text = text;\n  }\n\n";
    print "  var Name_Number = new Array();\n";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      my $name = $accounts->getvalue($j, 0);
      my $number = $accounts->getvalue($j, 1);
      print "  Name_Number[$j] = new create_group(\"$number\", \"$name - $number\");\n";
    }

    $accounts = $conn->exec("select name, number from account_tb where number in $account_list ORDER BY number, name");
    if ($accounts->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get info for global accounts that were used in the debitcredit table (ordered by Number - Name).<br>List = $account_list<br>$sys_admin";
      CleanUp();
    }

    # now we create the Javascript array for the Number-Name list
    print "\n  var Number_Name = new Array();\n";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      my $name = $accounts->getvalue($j, 0);
      my $number = $accounts->getvalue($j, 1);
      print "  Number_Name[$j] = new create_group(\"$number\", \"$number - $name\");\n";
    }
  }

  print <<"END_OF_SCRIPT";

    function initialize()
    {
      Name_Number_Display();
      SelectAllAccounts();  // This is the default behaviour.
    }

    function SelectAllAccounts()
    {
      var i;
      for (i=0; i < document.customize_form.accounts.length; i++)
      {
        document.customize_form.accounts.options[i].selected = true;
      }
    }

    function ClearAllAccounts()
    {
      var i;
      for (i=0; i < document.customize_form.accounts.length; i++)
      {
        document.customize_form.accounts.options[i].selected = false;
      }
    }

    function Name_Number_Display()
    {
      // get a list of all items that are currently selected.
      var i, j;
      var items = new Array();

      for (i=0, j=0; i < document.customize_form.accounts.length; i++)
      {
        if (document.customize_form.accounts.options[i].selected)
        {
          items[j++] = document.customize_form.accounts.options[i].value;
        }
      }

      // now we clear the accounts select box.
      document.customize_form.accounts.options.length = 0;

      // fill it back in with the Name_Number Array of options.
      for (i=0; i < Name_Number.length; i++)
      {
        document.customize_form.accounts.options[i] = new Option(Name_Number[i].text, Name_Number[i].value);
      }

      // now walk through the items array and for every value in it, find the value in the accounts.options array and select it.
      for (i=0; i < items.length; i++)
      {
        for (j=0; j < document.customize_form.accounts.options.length; j++)
        {
          if (document.customize_form.accounts.options[j].value == items[i])
          {
            document.customize_form.accounts.options[j].selected = true;
          }
        }
      }
    }

    function Number_Name_Display()
    {
      // get a list of all items that are currently selected.
      var i, j;
      var items = new Array();

      for (i=0, j=0; i < document.customize_form.accounts.length; i++)
      {
        if (document.customize_form.accounts.options[i].selected)
        {
          items[j++] = document.customize_form.accounts.options[i].value;
        }
      }

      // now we clear the accounts select box.
      document.customize_form.accounts.options.length = 0;

      // fill it back in with the Number_Name Array of options.
      for (i=0; i < Number_Name.length; i++)
      {
        document.customize_form.accounts.options[i] = new Option(Number_Name[i].text, Number_Name[i].value);
      }

      // now walk through the items array and for every value in it, find the value in the accounts.options array and select it.
      for (i=0; i < items.length; i++)
      {
        for (j=0; j < document.customize_form.accounts.options.length; j++)
        {
          if (document.customize_form.accounts.options[j].value == items[i])
          {
            document.customize_form.accounts.options[j].selected = true;
          }
        }
      }
    }
  </script>
END_OF_SCRIPT

$OnLoadString = " onLoad=\"initialize();\"";
$name_Num_onclickString = " onClick=\"Name_Number_Display();\"";
$Num_name_onclickString = " onClick=\"Number_Name_Display();\"";
}

sub reports3AccountBalanceSheetCustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 1:&nbsp;</font><input type=text name=\"date1\" value=\"$date\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_1\" value=\"Clear\" onClick=\"document.customize_form.date1.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 2:&nbsp;</font><input type=text name=\"date2\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_2\" value=\"Clear\" onClick=\"document.customize_form.date2.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 3:&nbsp;</font><input type=text name=\"date3\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_3\" value=\"Clear\" onClick=\"document.customize_form.date3.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Date 4:&nbsp;</font><input type=text name=\"date4\" size=10 maxlength=10>&nbsp;<input type=button name=\"clear_4\" value=\"Clear\" onClick=\"document.customize_form.date4.value='';\"></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Where to start Activity Detail at: </font><select name=\"activity_start_point\">
END_OF_FORM
  # now we display all the possible month values based upon the number of years in the known years table that are < than the current fiscal year.
  $known_years = $conn->exec("SELECT working_year FROM variables_tb WHERE ledger_code = '$ledger_code'");
  if ($known_years->resultStatus != PGRES_TUPLES_OK)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the Current Working year from the database.<br>$sys_admin";
    CleanUp();
  }
  if ($known_years->ntuples == 0)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Program not configured!</h1>\n";
    print "There is no current Fiscal Year set in the Ledger!<br>$sys_admin";
    CleanUp();
  }
  my $current_year = $known_years->getvalue(0, 0);

  $known_years = $conn->exec("SELECT year FROM known_years_tb WHERE year < $current_year AND ledger_code = '$ledger_code'");
  if ($known_years->resultStatus != PGRES_TUPLES_OK)
  {
    print "</select></td></tr></table></form>\n";
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of years from Known Years Table that are < than the Current Fiscal Year of '$current_year'.<br>$sys_admin";
    CleanUp();
  }

  my ($i, $j, $counter);
  $counter = $known_years->ntuples;
  if ($counter == 0)
  {
    $counter = 1;  # at least do 1 year's dates away even though they won't probably exist.
  }

  for ($i=0; $i < $counter; $i++)
  {
    for ($j=1; $j <= 12;)
    {
      if ($i > 0) # we are past 12 months out
      {
        print "    <option value=\"" . (($i * 12) + $j) . "\">";
        if ($j < 12)
        {
          print "$i year";
          if ($i > 1)
          {
            print "s";
          }
          print " $j month";
          if ($j > 1)
          {
            print "s";
          }
        }
        else
        {
          print int ($i + 1) . " years";
        }
        print " back\n";

      }
      else
      {
        print "    <option value=\"$j\">";
        if ($j < 12)
        {
          print "$j month";
          if ($j > 1)
          {
            print "s";
          }
        }
        else
        {
          print "1 year";
        }
        print " back\n";
      }
      $j += 2;
      $j = 6 if ($j == 5);
      $j = 12 if ($j == 8);
    } # end of months loop
  } # end of known_years loop
  print "    </select></td></tr>\n";
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">All Accounts&nbsp;</font><input type=radio name=\"all_accounts\" value=\"YES\" checked onClick=\"SelectAllAccounts();\">&nbsp;&nbsp;&nbsp;<font color=\"$menu_fgcolor\">Choose Accounts&nbsp;</font><input type=radio name=\"all_accounts\" value=\"NO\" onClick=\"ClearAllAccounts();\"></td></tr>
  <tr><td align=center><select name=\"accounts\" multiple width=200 size=\"6\"></select></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Display Total Line:&nbsp;</font><input type=radio name=\"display_total\" value=\"YES\" checked>&nbsp;Yes&nbsp;&nbsp;&nbsp;<input type=radio name=\"display_total\" value=\"NO\">&nbsp;No</td></tr>
END_OF_FORM
}

sub reports4AccountBalanceSheetJavaScript
{
  print "<script language=Javascript1.2>\n";
  print <<"END_OF_SCRIPT";
  function display_entries(Acct_Num, Acct_Name, Start_Date, End_Date)
  {
    document.Dummy_form.acct_num.value = Acct_Num;
    document.Dummy_form.acct_name.value = Acct_Name;
    document.Dummy_form.start_date.value = Start_Date;
    document.Dummy_form.end_date.value = End_Date;
    document.Dummy_form.submit();

    return false;
  }
END_OF_SCRIPT
  print "</script>\n";
}

sub reports4AccountBalanceSheetDisplayForm
{
  # @Data will have the following structure:
  # [account] = account_name, account_num, [dates]
  # [dates] = balance, number_of_entries - Each entry in the dates array will represent a date column.
  # The name and number will be sorted based upon the output desired by the user (name-number, number-name).
  # if Show zero balances is off, then any zero balance entries will not be included unless there are entries that exist.

  # generate the from dates for any detailed viewing.
  my @Start_Date = ();
  for (my $j=0; $j < $num_columns; $j++)
  {
    my $tmp_date = $Dates[$j];
    $tmp_date =~ s/-/\//g;

    $tmp_date = `/bin/date --date "$tmp_date $activity_start_point months ago" +%m-%d-%Y`;
    chomp $tmp_date;
    $Start_Date[$j] = $tmp_date;
  }

  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'><tr><td width=35%>Ledger <font color='$ledger_color'>$ledger_name</font>";
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";

  # create the dummy form that will be used to submit the detailed view data from.
  my $time = `/bin/date +%s`;
  chomp $time;

  print "<form name=\"Dummy_form\" method=post action=\"$site_dir/cgi-bin/report_detailed_view.cgi\" target=\"report_win_$time\">\n";
  print "<input type=hidden name=\"ledger\" value=\"$ledger_db\">\n";
  print "<input type=hidden name=\"report_group\" value=\"$report_group\">\n";
  print "<input type=hidden name=\"run\" value=\"\">\n";
  print "<input type=hidden name=\"report\" value=\"$report\">\n";
  print "<input type=hidden name=\"custom_report_name\" value=\"$custom_title\">\n";
  print "<input type=hidden name=\"show_zero_balances\" value=\"" . ($show_zero_balances ? "YES" : "NO") . "\">\n";
  print "<input type=hidden name=\"show_accounts_as\" value=\"" . ($show_accounts_as ? "name-number" : "number-name") . "\">\n";
  print "<input type=hidden name=\"data_precision\" value=\"$data_precision\">\n";
  print "<input type=hidden name=\"font_size_text\" value=\"$font_size_text\">\n";
  print "<input type=hidden name=\"font_size_data\" value=\"$font_size_data\">\n";
  print "<input type=hidden name=\"show_by_sub_entities\" value=\"" . ($show_by_sub_entities ? "YES" : "NO") . "\">\n";
  print "<input type=hidden name=\"show_non_tax_section\" value=\"" . ($show_non_tax_section ? "YES" : "NO") . "\">\n";
  print "<input type=hidden name=\"report_name\" value=\"$report_name\">\n";
  print "<input type=hidden name=\"print_report\" value=\"\">\n";
  print "<input type=hidden name=\"header_string\" value=\"$header_string\">\n";
  print "<input type=hidden name=\"acct_type_num\" value=\"-1\">\n";
  print "<input type=hidden name=\"acct_num\" value=\"-1\">\n";
  print "<input type=hidden name=\"acct_name\" value=\"-1\">\n";
  print "<input type=hidden name=\"debit_increases\" value=\"-1\">\n";
  print "<input type=hidden name=\"sub_acct_name\" value=\"-1\">\n";
  print "<input type=hidden name=\"sub_entity_code\" value=\"\">\n";
  print "<input type=hidden name=\"sub_entity_name\" value=\"\">\n";
  print "<input type=hidden name=\"start_date\" value=\"-1\">\n";
  print "<input type=hidden name=\"end_date\" value=\"-1\">\n";
  print "<input type=hidden name=\"sub_acct_num\" value=\"-2\">\n";
  print "</form>\n";

  # start a table that will be 100% of the available window.
  print "<table border=0 width=100% cellpadding=0 cellspacing=0>\n";

  # print the date headers.
  print "<tr><td align=left width=$text_width%>&nbsp;</td>";
  for (my $j=0; $j < $max_columns; $j++)
  {
    my $width = ($data_width / $max_columns);
    print "<td align=right width=$width%>";
    if ($j < $num_columns)
    {
      print "$Dates[$j]";
    }
    else
    {
      print "&nbsp;";
    }
    print "</td>";
  }
  print "</tr>\n";
  print "<tr><td colspan=$max_columns>&nbsp;</td></tr>\n";

  for (my $i=0; $i < scalar @Data; $i++)
  {
    print "<tr><td align=left width=$text_width%><font size=$font_size_text face='$font_str'>";
    if ($show_accounts_as)
    {
      print "$Data[$i][0] - $Data[$i][1]";
    }
    else
    {
      print "$Data[$i][1] - $Data[$i][0]";
    }
    print "</font></td>";
    for (my $j=0; $j < $num_columns; $j++)
    {
      my $width = ($data_width / $max_columns);
      print "<td align=right width=$width%><font face='$font_str' size=$font_size_data>";
      if ($Data[$i][2][$j][0] eq "0.00" && $Data[$i][2][$j][1] == 0)
      {
        my $balance = $Data[$i][2][$j][0];
        if ($balance < 0)
        {
          $balance *= -1;
          $balance = sprintf "%.2f", $balance;
          print "<font color=\"red\">(";
        }
        print commify($balance);
        if ($Data[$i][2][$j][0] < 0)  # print normally, no hyperlink
        {
          print ")</font>";
        }
        else
        {
          print "&nbsp;";
        }
      }
      else
      {
        print "<a href='javascript:display_entries($Data[$i][1], \"$Data[$i][0]\", \"$Start_Date[$j]\", \"$Dates[$j]\");'>";
        my $balance = $Data[$i][2][$j][0];
        if ($balance < 0)
        {
          $balance *= -1;
          $balance = sprintf "%.2f", $balance;
          print "<font color=\"red\">(";
        }
        else
        {
          print "<font color=\"black\">";
        }
        print commify($balance);
        if ($Data[$i][2][$j][0] < 0)  # print normally, no hyperlink
        {
          print ")</font>";
        }
        else
        {
          print "&nbsp;</font>";
        }
        print "</a>";
      }
      print "</font></td>";
    }
    print "</tr>\n";
  }

  # now if they wanted a total displayed, display it.
  if ($display_total)
  {
    print "<tr><td colspan=$max_columns>&nbsp;</td></tr>\n";
    print "<tr><td align=right width=$text_width%><font face='$font_str' size=$font_size_text><b>Total</b>&nbsp;&nbsp;</font></td>";
    for (my $j=0; $j < $max_columns; $j++)
    {
      my $width = ($data_width / $max_columns);
      print "<td align=right width=$width%><font face='$font_str' size=$font_size_data>";
      if ($j < $num_columns)
      {
        my $balance = $balance_total[$j];
        $balance = sprintf "%.2f", $balance;  # not being done at creation time to minimize time spent in loop.
        if ($balance < 0)
        {
          $balance *= -1;
          $balance = sprintf "%.2f", $balance;
          print "<font color=\"red\">(";
        }
        print "<b>" . commify($balance) . "</b>";
        if ($balance_total[$j] < 0)  # print normally, no hyperlink
        {
          print ")</font>";
        }
        else
        {
          print "&nbsp;";
        }
      }
      else
      {
        print "&nbsp;";
      }
      print "</font></td>";
    }
    print "</tr>\n";
  }

  print "</table>\n";
}

sub reports4AccountBalanceSheetValidate
{
  $report_name = "Accounts Balance Sheet";
  # check and make sure we have the settings needed.
  $num_columns = $max_columns;
  $show_by_sub_entities = 0;  # make sure it is turned off now until we decide we need it later.

  my ($i, @date_indexes);
  for ($i=1; $i <= $num_columns; $i++)
  {
    my $temp = "date" . $i;
    $$temp = $input{$temp};
    if (length $$temp != 0)
    {
      push @date_indexes, $i;
    }
  }
  if (scalar @date_indexes == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify at least one date to work with!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  else
  {
    foreach my $index (@date_indexes)
    {
      my $temp = "date" . $index;
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date '$$temp' is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
      push @Dates, $$temp;  # store the date to work with in the Dates array for future use.
    }

    $num_columns = scalar @Dates;  # remember how many entries we got from the user.
  }
  $date_range_string = ""; # each balance sheet report includes the date.

  # get the accounts the user selected.
  $accounts_selected = $input{'accounts'};
  if (length $accounts_selected == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select accounts to work with!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  # now we need to substitue the \0 with a ,
  $accounts_selected =~ s/\0/, /g;

  # get and verify that the months to display back value is valid
  $activity_start_point = $input{'activity_start_point'};
  if (length $activity_start_point == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select an Activity Start Point value!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  if ($activity_start_point <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid Activity Start Point given!</h1>\n";
    print "The Activity Start Point must be >= 1 month back!<br>$sys_admin";
    CleanUp();
  }
  $display_total = $input{'display_total'};
  if (length $display_total == 0 || ($display_total ne "YES" && $display_total ne "NO"))
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify if you want a Total displayed or not!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  $display_total = ($display_total eq "YES" ? 1 : 0);
}

sub reports4AccountBalanceSheetWork
{
  # @Data will have the following structure:
  # [account] = account_name, account_num, [dates]
  # [dates] = balance, number_of_entries - Each entry in the dates array will represent a date column.
  # The name and number will be sorted based upon the output desired by the user (name-number, number-name).
  # if Show zero balances is off, then any zero balance entries will not be included unless there are entries that exist.

  my @AccountTypes = ( 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18 );
  my @accounts_selected = split /, /, $accounts_selected;  # split out the accounts that were selected to work with.

  # Get the Local Accounts
  my @Accounts = $report_obj->GetLocalAccounts(\@AccountTypes);
  if ($report_obj->didErrorOccur())
  {
    PrintErrorHeader();
    print "<h1>Error:  Getting the Local Accounts failed!</h1>\n";
    print $report_obj->getErrorMessage();
    CleanUp();
  }

  # now I need to create a flat array without the Account Types in it.
  my @TempArray = ();
  for (my $i=0,$k=0; $i < scalar @Accounts; $i++)
  {
    for (my $j=0; $j < scalar @{$Accounts[$i]}; $j++)
    {
      @TempArray[$k++] = [ @{$Accounts[$i][$j]} ];
    }
  }

  @Accounts = @TempArray;

  my @SortedAccounts = ();
  # now we need to sort the list of accounts based upon whether the user wants name-number or number-name.
  if ($show_accounts_as) # name-number
  {
    @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[2] cmp $b->[2] || $a->[0] <=> $b->[0] } map { [ $_->[0], $_->[1], $_->[2] ] } @Accounts;
  }
  else  # number-name
  {
    @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[0] <=> $b->[0] || $a->[2] cmp $b->[2] } map { [ $_->[0], $_->[1], $_->[2] ] } @Accounts;
  }

  @Accounts = @SortedAccounts;

  # now get the balances for each account, and add the entries to the @Data array, based upon the show zero balances flag and the balance result.

  my @temp_data = ();
  for (my $i=0; $i < $num_columns; $i++)
  {
    my $date = $Dates[$i];
    @TempArray = $report_obj->GetAccountBalances(\@Accounts, $date);
    if ($report_obj->didErrorOccur())
    {
      PrintErrorHeader();
      print "<h1>Error:  Getting Account Balances failed!</h1>\n";
      print $report_obj->getErrorMessage();
      CleanUp();
    }

    $temp_data[$i] = [ @TempArray ];

    $balance_total[$i] = "0.00";
  }

  # now we walk through the @temp_data array and see if there are any entries we can ignore and put the rest in @Data.
  # also check to make sure that the account is one that was selected before we add it to @Data.

  my $index = 0;  # index into the Data array for all entries to make.
  for (my $i=0; $i < scalar @Accounts; $i++)
  {
    my $display_data = 0;
    for (my $j=0; $j < $num_columns; $j++)
    {
      if ($temp_data[$j][$i][0] ne "0.00")
      {
        $display_data = 1;
      }
      elsif ($temp_data[$j][$i][1] > 0)
      {
        $display_data = 1;
      }
      elsif ($show_zero_balances)
      {
        $display_data = 1;
      }
    } # end for loop through dates.

    if ($display_data)
    {
      # make sure this was a selected account.
      my $acct_num = $Accounts[$i][0];
      my $display_account = map { $_ =~ /$acct_num/ } @accounts_selected;
      if ($display_account)
      {
        # make the entry in @Data.
        my (@Entry, @tmp_Dates);

        for (my $j=0; $j < $num_columns; $j++)
        {
          $tmp_Dates[$j][0] = $temp_data[$j][$i][0];  # Account Balance
          $tmp_Dates[$j][1] = $temp_data[$j][$i][1];  # Number of Entries

          $balance_total[$j] += $temp_data[$j][$i][0];
        }

        $Entry[0] = $Accounts[$i][2];  # Account Name
        $Entry[1] = $Accounts[$i][0];  # Account Number
        $Entry[2] = [ @tmp_Dates ];  # Array of Date info

        $Data[$index++] = [ @Entry ];
      }
    }
  } # end for loop through accounts.
}

return 1;