#$Id: reports_bank_reconciliation.pm,v 1.1 2001/09/06 10:21:20 moreejt Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.
my @activity_total;
my $hr_size;
$hr_size=5;

sub reports3BankReconciliationJavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3BankReconciliationJavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that they have specified a complete date range
    var date1_start, date1_end;
    date1_start = doc.date1_from.value;
    date1_end   = doc.date1_to.value;

    if (date1_start.length == 0 && date1_end.length == 0)
    {
      msg += "You must specify the dates to work with!\\n";
    }
    else  // something is filled in, now verify that it is a complete range
    {
      if ((date1_start.length > 0 && date1_end.length == 0) || (date1_start.length == 0 && date1_end.length > 0))
      {
        msg += "You must specify a complete range of dates to work with!\\n";
      }
      else
      {
        if (date1_start.length > 0 && date1_end.length > 0) // check and make sure the dates are valid.
        {
          tmp = IsValidDateSyntax(date1_start);
          if (tmp.length > 0)
          {
            msg += "Date 1 From: " + tmp + "\\n";
          }
          tmp = IsValidDateSyntax(date1_end);
          if (tmp.length > 0)
          {
            msg += "Date 1 To: " + tmp + "\\n";
          }
        }
      }
    }
    // now verify that they have selected at least one account to work with.
    tmp = doc.accounts;
    var i, found=false;
    for (i=0; i < tmp.length; i++)
    {
      if (tmp.options[i].selected)
      {
        found = true;
      }
    }
    if (!found)
    {
      msg += "You must select an account to work with!\\n";
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3BankReconciliationJavaScript
{
  print "<script language=Javascript1.2>\n";

  my ($account_list, $j, $num);
  $accounts = $conn->exec("select acct_num from local_accounts_tb where sub_entity_code is null AND ledger_code = '$ledger_code' AND acct_num IN (SELECT number FROM account_tb WHERE type = 0)");
  if ($accounts->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error:  Accessing database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get list of Cash accounts used in debitcredit table.<br>$sys_admin";
    CleanUp();
  }
  if ($accounts->ntuples > 0)
  {
    $account_list = "(";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      $num = $accounts->getvalue($j, 0);
      $account_list .= $num;
      if ($j < $accounts->ntuples-1)
      {
        $account_list .= ", ";
      }
    }
    $account_list .= ")";

    $accounts = $conn->exec("select name, number from account_tb where number in $account_list ORDER BY name, number");
    if ($accounts->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get info for Cash accounts that were used in the debitcredit table (ordered by Name - Number).<br>List = $account_list<br>$sys_admin";
      CleanUp();
    }

    # now we create the Javascript array for the Name-Number list
    print "  function create_group(value, text)\n  {\n    this.value = value;\n    this.text = text;\n  }\n\n";
    print "  var Name_Number = new Array();\n";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      my $name = $accounts->getvalue($j, 0);
      my $number = $accounts->getvalue($j, 1);
      print "  Name_Number[$j] = new create_group(\"$number\", \"$name - $number\");\n";
    }

    $accounts = $conn->exec("select name, number from account_tb where number in $account_list ORDER BY number, name");
    if ($accounts->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error:  Accessing database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get info for Cash accounts that were used in the debitcredit table (ordered by Number - Name).<br>List = $account_list<br>$sys_admin";
      CleanUp();
    }

    # now we create the Javascript array for the Number-Name list
    print "\n  var Number_Name = new Array();\n";
    for ($j=0; $j < $accounts->ntuples; $j++)
    {
      my $name = $accounts->getvalue($j, 0);
      my $number = $accounts->getvalue($j, 1);
      print "  Number_Name[$j] = new create_group(\"$number\", \"$number - $name\");\n";
    }
  }

  print <<"END_OF_SCRIPT";

    function initialize()
    {
      Name_Number_Display();
      SelectAllAccounts();  // This is the default behaviour.
    }

    function SelectAllAccounts()
    {
      var i;
      for (i=0; i < document.customize_form.accounts.length; i++)
      {
        document.customize_form.accounts.options[i].selected = true;
      }
    }

    function ClearAllAccounts()
    {
      var i;
      for (i=0; i < document.customize_form.accounts.length; i++)
      {
        document.customize_form.accounts.options[i].selected = false;
      }
    }

    function Name_Number_Display()
    {
      // get a list of all items that are currently selected.
      var i, j;
      var items = new Array();

      for (i=0, j=0; i < document.customize_form.accounts.length; i++)
      {
        if (document.customize_form.accounts.options[i].selected)
        {
          items[j++] = document.customize_form.accounts.options[i].value;
        }
      }

      // now we clear the accounts select box.
      document.customize_form.accounts.options.length = 0;

      // fill it back in with the Name_Number Array of options.
      for (i=0; i < Name_Number.length; i++)
      {
        document.customize_form.accounts.options[i] = new Option(Name_Number[i].text, Name_Number[i].value);
      }

      // now walk through the items array and for every value in it, find the value in the accounts.options array and select it.
      for (i=0; i < items.length; i++)
      {
        for (j=0; j < document.customize_form.accounts.options.length; j++)
        {
          if (document.customize_form.accounts.options[j].value == items[i])
          {
            document.customize_form.accounts.options[j].selected = true;
          }
        }
      }
    }

    function Number_Name_Display()
    {
      // get a list of all items that are currently selected.
      var i, j;
      var items = new Array();

      for (i=0, j=0; i < document.customize_form.accounts.length; i++)
      {
        if (document.customize_form.accounts.options[i].selected)
        {
          items[j++] = document.customize_form.accounts.options[i].value;
        }
      }

      // now we clear the accounts select box.
      document.customize_form.accounts.options.length = 0;

      // fill it back in with the Number_Name Array of options.
      for (i=0; i < Number_Name.length; i++)
      {
        document.customize_form.accounts.options[i] = new Option(Number_Name[i].text, Number_Name[i].value);
      }

      // now walk through the items array and for every value in it, find the value in the accounts.options array and select it.
      for (i=0; i < items.length; i++)
      {
        for (j=0; j < document.customize_form.accounts.options.length; j++)
        {
          if (document.customize_form.accounts.options[j].value == items[i])
          {
            document.customize_form.accounts.options[j].selected = true;
          }
        }
      }
    }
  </script>
END_OF_SCRIPT

$OnLoadString = " onLoad=\"initialize();\"";
$name_Num_onclickString = " onClick=\"Name_Number_Display();\"";
$Num_name_onclickString = " onClick=\"Number_Name_Display();\"";
}

sub reports3BankReconciliationCustomizedFormItems
{
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">Date</font> - From&nbsp;<input type=text name=\"date1_from\" value=\"$date\" size=10 maxlength=10>&nbsp;&nbsp;To&nbsp;<input type=text name=\"date1_to\" value=\"$date\" size=10 maxlength=10>&nbsp;<input type=button name=\"row1_clear\" value=\"Clear\" onClick=\"document.customize_form.date1_from.value='';document.customize_form.date1_to.value='';\"></td></tr>
END_OF_FORM
  print <<"END_OF_FORM";
  <tr><td align=center><font color=\"$menu_fgcolor\">All Accounts&nbsp;</font><input type=radio name=\"all_accounts\" value=\"YES\" checked onClick=\"SelectAllAccounts();\">&nbsp;&nbsp;&nbsp;<font color=\"$menu_fgcolor\">Choose Accounts&nbsp;</font><input type=radio name=\"all_accounts\" value=\"NO\" onClick=\"ClearAllAccounts();\"></td></tr>
  <tr><td align=center><select name=\"accounts\" multiple width=200 size=\"6\"></select></td></tr>
END_OF_FORM
}

sub reports4BankReconciliationJavaScript
{
  print "<script language=Javascript1.2>\n";
  print <<"END_OF_SCRIPT";
  function display_entries(Acct_Num, Acct_Name, Start_Date, End_Date)
  {
    document.Dummy_form.account_value.value = Acct_Name + "|" + Acct_Num;
    document.Dummy_form.from_search_date.value = Start_Date;
    document.Dummy_form.to_search_date.value = End_Date;
    document.Dummy_form.submit();

    return false;
  }
END_OF_SCRIPT
  print "</script>\n";
}

sub reports4BankReconciliationDisplayForm
{
  # @Data will have the following structure:
  # [account] = account_name, account_num, beginning_balance, ending_balance, debits, credits

  # create the header string to be displayed in the printable version of the report.
  my $header_string = "<center><table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor='$body_bgcolor'><tr><td width=35%>Ledger <font color='$ledger_color'>$ledger_name</font>";
  $header_string .= "</td><td align=center width=30%><h3>$custom_title</h3></td><td align=right>$date</td></tr>";
  if (length $date_range_string > 0)
  {
    $header_string .= "<tr><td width=35%><br></td><td align=center width=30%>$date_range_string</td><td><br></td></tr>";
  }
  $header_string .= "</table><br>";

  # create the dummy form that will be used to submit the detailed view data from.
  my $time = `/bin/date +%s`;
  chomp $time;

  print "<form name=\"Dummy_form\" method=post action=\"$site_dir/cgi-bin/register_display.cgi\" target=\"report_win_$time\">\n";
  print "<input type=hidden name=\"account_value\" value=\"\">\n";
  print "<input type=hidden name=\"register_select_submit\" value=\"\">\n";
  print "<input type=hidden name=\"account_select\" value=\"\">\n";
  print "<input type=hidden name=\"ledger_db\" value=\"$ledger_db\">\n";
  print "<input type=hidden name=\"from_search_date\" value=\"-1\">\n";
  print "<input type=hidden name=\"to_search_date\" value=\"-1\">\n";
  print "</form>\n";

  # in this report, we have a total of 7 columns we are going to display.
  $max_columns = 7;

  # start a table that will be 100% of the available window.
  print "<table border=0 width=100% cellpadding=0 cellspacing=0>\n";

  # print the date headers.
  print "<tr><td align=left colspan=\"$max_columns\">From&nbsp;$Dates[0][0]&nbsp;to&nbsp;$Dates[0][1]</td></tr>\n";
  print "<tr><td colspan=$max_columns>&nbsp;</td></tr>\n";
  # create the headers
  my $width = (100-$text_width-12)/4;
  print "<tr><td align=left width=$text_width%><font size=$font_size_text face='$font_str'>Accounts</font></td><td align=right width=$width%><font size=$font_size_text face='$font_str'>Beginning Balance&nbsp;</font></td><td align=right width=$width%><font size=$font_size_text face='$font_str'>Deposits&nbsp;</font></td><td align=right width=$width%><font size=$font_size_text face='$font_str'>Payments&nbsp;</font></td><td rowspan=\"" . ((scalar @Data)+4) . "\" width=1% background=\"$site_dir/images/black_pixel.jpg\"><br></td><td align=right width=$width%><font size=$font_size_text face='$font_str'>Ending Balance&nbsp;</font></td><td align=center width=12%>&nbsp;</td></tr>\n";
  print "<tr><td align=left colspan=4><hr size=$hr_size noshade></td><td align=left><hr size=$hr_size noshade></td><td>&nbsp;</td></tr>\n";

  for (my $i=0; $i < scalar @Data; $i++)
  {
    print "<tr><td align=left width=$text_width%><a href='javascript:display_entries($Data[$i][1], \"$Data[$i][0]\", \"$Dates[0][0]\", \"$Dates[0][1]\");'><font size=$font_size_text face='$font_str' color=\"black\">";
    if ($show_accounts_as)
    {
      print "$Data[$i][0] - $Data[$i][1]";
    }
    else
    {
      print "$Data[$i][1] - $Data[$i][0]";
    }
    print "</font></a></td>";
    for (my $j=0; $j < 4; $j++)
    {
      my $width = ($data_width - 12 / 4);
      print "<td align=right width=$width%><font face='$font_str' size=$font_size_data>";
      my $activity = $Data[$i][$j+2];

      # update the grand total for this column.
      $activity_total[0][$j] += $activity;
      $activity_total[0][$j] = sprintf "%.2f", $activity_total[0][$j];

      if ($activity < 0)
      {
        $activity *= -1;
        $activity = sprintf "%.2f", $activity;
        print "<font color=\"red\">(";
      }
      else
      {
        print "<font color=\"black\">";
      }
      print commify($activity);
      if ($Data[$i][$j+2] < 0)  # print normally, no hyperlink
      {
        print ")</font>";
      }
      else
      {
        print "&nbsp;</font>";
      }
      print "</td>";
    }

    # see if the beginning_balance + debits + credits = ending_balance
    my $beginning_balance = $Data[$i][2];
    my $ending_balance = $Data[$i][5];
    my $debits = $Data[$i][3];
    my $credits = $Data[$i][4];

    my $trial_balance = $beginning_balance + $debits + $credits;
    $trial_balance = sprintf "%.2f", $trial_balance;
    print "<td align=left width=10%>&nbsp;<img src=\"$site_dir/images/";
    if ($trial_balance ne $ending_balance)
    {
      print "red_x.gif";
    }
    else
    {
      print "green_check.gif";
    }
    print "\"></td>";
    print "</tr>\n";  # end of header row or total entry
  }

  # now display the Total line and do the overall check.
  # display an underline via an <hr>
  print "<tr><td align=left colspan=4><hr size=$hr_size noshade></td><td align=left><hr size=$hr_size noshade></td><td>&nbsp;</td></tr>\n";
  print "<tr><td align=right width=$text_width%><font face='$font_str' size=$font_size_text><b>Total</b>&nbsp;&nbsp;</font></td>";
  for (my $j=0; $j < 4; $j++)
  {
    my $width = ($data_width - 12 / 4);
    print "<td align=right width=$width%><font face='$font_str' size=$font_size_data>";
    my $activity = $activity_total[0][$j];
    $activity = sprintf "%.2f", $activity;  # not being done at creation time to minimize time spent in loop.
    if ($activity < 0)
    {
      $activity *= -1;
      $activity = sprintf "%.2f", $activity;
      print "<font color=\"red\">(";
    }
    print "<b>" . commify($activity) . "</b>";
    if ($activity_total[0][$j] < 0)  # print normally, no hyperlink
    {
      print ")</font>";
    }
    else
    {
      print "&nbsp;";
    }
    print "</font></td>";
  }
  # now check and make sure everything balances.
  # see if the beginning_balance + debits + credits = ending_balance
  my $beginning_balance = $activity_total[$i][0];
  my $ending_balance = $activity_total[$i][3];
  my $debits = $activity_total[$i][1];
  my $credits = $activity_total[$i][2];

  my $trial_balance = $beginning_balance + $debits + $credits;
  $trial_balance = sprintf "%.2f", $trial_balance;
  print "<td align=left width=10%>&nbsp;<img src=\"$site_dir/images/";
  if ($trial_balance ne $ending_balance)
  {
    print "red_x.gif";
  }
  else
  {
    print "green_check.gif";
  }
  print "\"></td>";
  print "</tr>\n";

  print "</table>\n";
}

sub reports4BankReconciliationValidate
{
  $report_name = "Bank Reconciliation";
  # check and make sure we have the settings needed.
  $num_columns = 1;

  my ($i, @date_indexes);
  for ($i=1; $i <= $num_columns; $i++)
  {
    my $temp = "date" . $i . "_from";
    $$temp = $input{$temp};
    my $temp2 = "date" . $i . "_to";
    $$temp2 = $input{$temp2};
    if (length $$temp != 0 && length $$temp2 != 0)
    {
      push @date_indexes, $i;
    }
  }
  if (scalar @date_indexes == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must specify at least one date range to work with!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  else
  {
    foreach my $index (@date_indexes)
    {
      my @Entry = ();
      my $temp = "date" . $index . "_from";
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date $index From = '$$temp' is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
      $Entry[0] = $$temp;

      $temp = "date" . $index . "_to";
      $$temp = $input{$temp};
      if (!IsValidDateSyntax($$temp))
      {
        PrintErrorHeader();
        print "<h1>Error:  Date $index To = '$$temp' is invalid!</h1>\nClose this window to fix the problem.\n";
        CleanUp();
      }
      $Entry[1] = $$temp;

      $Dates[++$#Dates] = [ @Entry ];  # store the dates to work with in the Dates array for future use.
    }

    $num_columns = scalar @Dates;  # remember how many entries we got from the user.
  }
  $date_range_string = ""; # each balance sheet report includes the date.

  # get the accounts the user selected.
  $accounts_selected = $input{'accounts'};
  if (length $accounts_selected == 0)
  {
    PrintErrorHeader();
    print "<h1>Error:  You must select accounts to work with!</h1>\n";
    print "Close this window and try again.<br>";
    CleanUp();
  }
  # now we need to substitue the \0 with a ,
  $accounts_selected =~ s/\0/, /g;
}

sub reports4BankReconciliationWork
{
  # @Data will have the following structure:
  # [account] = account_name, account_num, starting_balance, ending_balance, debits, credits

  my @AccountTypes = ( 0 );
  my @accounts_selected = split /, /, $accounts_selected;  # split out the accounts that were selected to work with.

  # Get the Local Accounts
  my @Accounts = $report_obj->GetLocalAccounts(\@AccountTypes);
  if ($report_obj->didErrorOccur())
  {
    PrintErrorHeader();
    print "<h1>Error:  Getting the Local Cash Accounts failed!</h1>\n";
    print $report_obj->getErrorMessage();
    CleanUp();
  }

  # now I need to create a flat array without the Account Types in it.
  my @TempArray = ();
  for (my $i=0,$k=0; $i < scalar @Accounts; $i++)
  {
    for (my $j=0; $j < scalar @{$Accounts[$i]}; $j++)
    {
      @TempArray[$k++] = [ @{$Accounts[$i][$j]} ];
    }
  }

  @Accounts = @TempArray;

  my @SortedAccounts = ();
  # now we need to sort the list of accounts based upon whether the user wants name-number or number-name.
  if ($show_accounts_as) # name-number
  {
    @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[2] cmp $b->[2] || $a->[0] <=> $b->[0] } map { [ $_->[0], $_->[1], $_->[2] ] } @Accounts;
  }
  else  # number-name
  {
    @SortedAccounts = map { [ $_->[0], $_->[1], $_->[2] ] } sort { $a->[0] <=> $b->[0] || $a->[2] cmp $b->[2] } map { [ $_->[0], $_->[1], $_->[2] ] } @Accounts;
  }

  @Accounts = @SortedAccounts;

  # now get the beginning and ending balance values and the debit and credit amounts for each account, and add the entries to the @Data array.

  my @temp_data = ();
  for (my $i=0; $i < $num_columns; $i++)
  {
    my $start_date = $Dates[$i][0];
    my $end_date = $Dates[$i][1];
    @TempArray = $report_obj->GetAccountBalances(\@Accounts, $start_date);
    if ($report_obj->didErrorOccur())
    {
      PrintErrorHeader();
      print "<h1>Error:  Getting Beginning Account Balances failed!</h1>\n";
      print $report_obj->getErrorMessage();
      CleanUp();
    }

    $temp_data[$i][0] = [ @TempArray ];

    @TempArray = $report_obj->GetAccountBalances(\@Accounts, $end_date);
    if ($report_obj->didErrorOccur())
    {
      PrintErrorHeader();
      print "<h1>Error:  Getting Ending Account Balances failed!</h1>\n";
      print $report_obj->getErrorMessage();
      CleanUp();
    }

    $temp_data[$i][1] = [ @TempArray ];

    @TempArray = $report_obj->AccountActivitySplit(\@Accounts, $start_date, $end_date, 2);  # exclude the start date and include the end date.
    if ($report_obj->didErrorOccur())
    {
      PrintErrorHeader();
      print "<h1>Error:  Getting Account Debits and Credits failed!</h1>\n";
      print $report_obj->getErrorMessage();
      CleanUp();
    }

    $temp_data[$i][2] = [ @TempArray ];

    $activity_total[$i][0] = "0.00";  # the totals for the different columns.
    $activity_total[$i][1] = "0.00";
    $activity_total[$i][2] = "0.00";
    $activity_total[$i][3] = "0.00";
  }

  # check to make sure that the account is one that was selected before we add it to @Data.

  my $index = 0;  # index into the Data array for all entries to make.
  for (my $i=0; $i < scalar @Accounts; $i++)
  {
    # make sure this was a selected account.
    my $acct_num = $Accounts[$i][0];
    my $display_account = map { $_ =~ /$acct_num/ } @accounts_selected;
    if ($display_account)
    {
      # make the entry in @Data.
      my (@Entry);

      $Entry[0] = $Accounts[$i][2];  # Account Name
      $Entry[1] = $Accounts[$i][0];  # Account Number
      $Entry[2] = $temp_data[0][0][$i][0];  # Beginning Balance
      $Entry[3] = $temp_data[0][2][$i][0];  # Debits
      $Entry[4] = $temp_data[0][2][$i][1];  # Credits
      if ($Entry[4] != 0)
      {
        $Entry[4] *= -1;
      }
      $Entry[5] = $temp_data[0][1][$i][0];  # Ending Balance
      #print "<!-- Entry #$i: Name='$Entry[0]', Number='$Entry[1]', Beginning Bal='$Entry[2]', Debits='$Entry[3]', Credits='$Entry[4]', Ending Bal='$Entry[5]' -->\n";

      $Data[$index++] = [ @Entry ];
    }
  } # end for loop through accounts.
}

return 1;