#$Id: reports_federal_941.pm,v 1.4 2003/10/14 22:42:08 pattieja Exp $
#This package is released under the GNU General Public License.
#You should have recieved a copy of the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

use Payroll::US::FICA;
use Payroll::US::Medicare;

sub reports3Federal941JavaScriptValidation
{
  print <<"END_OF_SCRIPT";
  function reports3Federal941JavaScriptValidation(doc)
  {
    var msg = "";
    var tmp = "";

    // verify that any values they have entered are valid values
    var pattern = /^(-?(([0-9]+)|(([0-9]+\.[0-9]+)|(\.[0-9]+))))\$/;
    if (doc.federal_over_under_payment_amount.value.length != 0)
    {
      if (!pattern.test(doc.federal_over_under_payment_amount.value))
      {
        msg += "Over/Under Payment contains an invalid numeric value! (" + doc.federal_over_under_payment_amount.value + ")\\n";
      }
    }
    if (doc.federal_other_adjustments_amount.value.length != 0)
    {
      if (!pattern.test(doc.federal_other_adjustments_amount.value))
      {
        msg += "FITW Other Adjustments contains an invalid numeric value! (" + doc.federal_other_adjustments_amount.value + ")\\n";
      }
    }
    if (doc.FICA_MEDICARE_sick_pay_amount.value.length != 0)
    {
      if (!pattern.test(doc.FICA_MEDICARE_sick_pay_amount.value))
      {
        msg += "FICA/MEDICARE Sick Pay contains an invalid numeric value! (" + doc.FICA_MEDICARE_sick_pay_amount.value + ")\\n";
      }
    }
    if (doc.FICA_MEDICARE_other_adjustments_amount.value.length != 0)
    {
      if (!pattern.test(doc.FICA_MEDICARE_other_adjustments_amount.value))
      {
        msg += "FICA/MEDICARE Other Adjustments contains an invalid numeric value! (" + doc.FICA_MEDICARE_other_adjustments_amount.value + ")\\n";
      }
    }

    return msg;
  }
END_OF_SCRIPT
}

sub reports3Federal941CustomizedFormItems
{
  my %known_years;
  my $temp_year;
  my $salary_account_num;
  my $salary_account_name;
  my $federal_account_num;
  my $federal_account_name;
  my $FICA_account_num;
  my $FICA_account_name;
  my $MEDICARE_account_num;
  my $MEDICARE_account_name;
  my $AEIC_account_num;
  my $AEIC_account_name;
  my $counter;

  print <<"END_OF_FORM";
  <tr><td><hr width=90%></td></tr>
  <tr><td align=center><font color=\"$menu_fgcolor\">Salary Expense Account:&nbsp;</font>
END_OF_FORM
  # get the salary expense account from the database and display to the user
  # Salary Expenses account type = 55
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 55 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the Salary Expense account(s) from the global database for the 941 federal report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No Salary Expense account(s) was(were) found for the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $salary_account_name = $result->getvalue($counter, 0);
    $salary_account_num = $result->getvalue($counter, 1);
    $salary_account_name =~ s/\ /&nbsp;/g;
    print "$salary_account_name&nbsp;-&nbsp;$salary_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"salary_expense_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $salary_account_num = $result->getvalue($counter, 1);
    print "$salary_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print "</td></tr>\n";
  print "<tr><td align=center><font color=\"$menu_fgcolor\">FITW Account:&nbsp;</font>\n";
  # get the federal income account from the database and display to the user
  # FITW Liability account type = 24
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 24 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the FITW account(s) from the global database for the 941 federal report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No FITW account(s) was(were) found for the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $federal_account_name = $result->getvalue($counter, 0);
    $federal_account_num = $result->getvalue($counter, 1);
    $federal_account_name =~ s/\ /&nbsp;/g;
    print "$federal_account_name&nbsp;-&nbsp;$federal_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"FITW_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $federal_account_num = $result->getvalue($counter, 1);
    print "$federal_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print "</td></tr>\n";
  print "<tr><td align=center><font color=\"$menu_fgcolor\">FICA Account:&nbsp;</font>\n";
  # get the FICA account from the database and display to the user
  # FICA Liability account type = 26
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 26 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the FICA account(s) from the global database for the 941 federal report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No FICA account(s) was(were) found for the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $FICA_account_name = $result->getvalue($counter, 0);
    $FICA_account_num = $result->getvalue($counter, 1);
    $FICA_account_name =~ s/\ /&nbsp;/g;
    print "$FICA_account_name&nbsp;-&nbsp;$FICA_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"FICA_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $FICA_account_num = $result->getvalue($counter, 1);
    print "$FICA_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print "</td></tr>\n";
  print "<tr><td align=center><font color=\"$menu_fgcolor\">MEDICARE Account:&nbsp;</font>\n";
  # get the MEDICARE account from the database and display to the user
  # Mcare Liability account type = 27
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 27 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the MEDICARE account(s) from the global database for the 941 federal report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No MEDICARE account(s) was(were) found for the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $MEDICARE_account_name = $result->getvalue($counter, 0);
    $MEDICARE_account_num = $result->getvalue($counter, 1);
    $MEDICARE_account_name =~ s/\ /&nbsp;/g;
    print "$MEDICARE_account_name&nbsp;-&nbsp;$MEDICARE_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"MEDICARE_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $MEDICARE_account_num = $result->getvalue($counter, 1);
    print "$MEDICARE_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print "</td></tr>\n";
  print "<tr><td align=center><font color=\"$menu_fgcolor\">AEIC Account:&nbsp;</font>\n";
  # get the AEIC account from the database and display to the user
  # AEIC account type = 28
  $result = $conn->exec("select name, number from account_tb where number in (select acct_num from local_accounts_tb where ledger_code = '$ledger_code') and type = 28 order by name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>1040: Tried to get the AEIC account(s) from the global database for the 941 federal report.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "1041: No AEIC account(s) was(were) found the ledger.<br>It does not look like this report has been setup.<br>$sys_admin";
    print "</td></tr></table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $AEIC_account_name = $result->getvalue($counter, 0);
    $AEIC_account_num = $result->getvalue($counter, 1);
    $AEIC_account_name =~ s/\ /&nbsp;/g;
    print "$AEIC_account_name&nbsp;-&nbsp;$AEIC_account_num\n";
    if ($counter < $result->ntuples - 1)
    {
      print "<br>";
    }
  }
  print "<input type=hidden name=\"AEIC_account_num\" value=\"";
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $AEIC_account_num = $result->getvalue($counter, 1);
    print "$AEIC_account_num";
    if ($counter < $result->ntuples - 1)
    {
      print ",";
    }
  }
  print "\">\n";
  print "</td></tr>\n";
  print <<"END_OF_FORM";
  <tr><td>
  <table border=0 width=100% cellspacing=0 cellpadding=2 bgcolor=\"$menu_bgcolor\">
  <tr><td colspan=2><hr width=90%></td></tr>
END_OF_FORM
  # get the known years that have data on which to do the payroll report for federal 941
  $result = $conn->exec("select start_date, end_date from known_years_tb where ledger_code = '$ledger_code'");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the known working years for use in the federal 941 report.<br>$sys_admin";
    print "</table>\n";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    print "<h1>Error: No records returned!</h1>\n";
    print "No known years were returned.<br>No data is available for this report.<br>$sys_admin";
    print "</table>\n";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_year = $result->getvalue($counter, 0);
    $temp_year =~ s/\-/\//g;
    $temp_year = `date -d $temp_year +%Y`;
    if (not exists $known_years{$temp_year})
    {
      $known_years{$temp_year} = 0;
    }

    $temp_year = $result->getvalue($counter, 1);
    $temp_year =~ s/\-/\//g;
    $temp_year = `date -d $temp_year +%Y`;
    if (not exists $known_years{$temp_year})
    {
      $known_years{$temp_year} = 0;
    }
  }
  print "<tr><td align=right><font color=\"$menu_fgcolor\">Year:&nbsp;</font>\n";
  print "<select name=\"federal_year\">\n";
  foreach $temp_year (sort {$known_years{$a} <=> $known_years{$b}} keys %known_years)
  {
    print "<option>" . $temp_year . "\n";
  }
  print "</select>\n";
  print "</td><td align=left><font color=\"$menu_fgcolor\">Quarter:&nbsp;</font>\n";
  print "<select name=\"federal_quarter\">\n";
  print "<option>1st\n";
  print "<option>2nd\n";
  print "<option>3rd\n";
  print "<option>4th\n";
  print "</select>\n";
  print "</td></tr>\n";
  print <<"END_OF_FORM";
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td align=right><font color=\"$menu_fgcolor\">Over/Under&nbsp;Payment:&nbsp;</td><td align=left></font><input type=text size=10 name=\"federal_over_under_payment_amount\" value=\"\">&nbsp;<font color=\"$menu_fgcolor\">Amount</font></td></tr>
  <tr><td align=right><font color=\"$menu_fgcolor\">Over:&nbsp;</font><input type=radio name=\"federal_over_under_radio\" value=\"over\" checked></td><td align=left><font color=\"$menu_fgcolor\">Under:&nbsp;</font><input type=radio name=\"federal_over_under_radio\" value=\"under\"></td></tr>
  <tr><td align=right><font color=\"$menu_fgcolor\">FITW<br>Other&nbsp;Adjustments:&nbsp;</font></td><td align=left><input type=text size=10 name=\"federal_other_adjustments_amount\" value=\"\">&nbsp;<font color=\"$menu_fgcolor\">Amount</font></td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  <tr><td align=right><font color=\"$menu_fgcolor\">FICA/MEDICARE<br>Sick&nbsp;Pay:&nbsp;</font></td><td align=left><input type=text size=10 name=\"FICA_MEDICARE_sick_pay_amount\" value=\"\">&nbsp;<font color=\"$menu_fgcolor\">Amount</font></td></tr>
  <tr><td align=right><font color=\"$menu_fgcolor\">FICA/MEDICARE<br>Other&nbsp;Adjustments:&nbsp;</font></td><td align=left><input type=text size=10 name=\"FICA_MEDICARE_other_adjustments_amount\" value=\"\">&nbsp;<font color=\"$menu_fgcolor\">Amount</font></td></tr>
  <tr><td colspan=2><hr width=90%></td></tr>
  </table>
  </td></tr>
  <tr><td><font color=\"$menu_fgcolor\">*Disclaimer: It is your responsibility to make sure the data is accurate!</font></td></tr>
END_OF_FORM
}

sub reports4Federal941Validate
{
  if (not exists $input{'custom_report_name'} || $input{'custom_report_name'} eq "")
  {
    $report_name = "Federal 941 Quarterly Payroll";
  }
  else
  {
    $report_name = $input{'custom_report_name'};
  }

  # check and see if they want to display by Sub-Entities or not.
  if (not exists $input{'show_by_sub_entities'})
  {
    PrintErrorHeader();
    print "<h1>Error:  Show by Sub-Entities must be set!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = $input{'show_by_sub_entities'};
  if (not ($show_by_sub_entities eq "YES" || $show_by_sub_entities eq "NO"))
  {
    PrintErrorHeader();
    print "<h1>Error:  Invalid value set for Show by Sub-Entities!</h1>\n";
    print "Value set was '$show_by_sub_entities'.<br>$sys_admin";
    CleanUp();
  }
  $show_by_sub_entities = ($show_by_sub_entities eq "YES" ? 1:0);

  # check to make sure the FITW, FICA, MEDICARE, and AEIC accounts exist
  if (not (exists $input{'FITW_account_num'} && exists $input{'FICA_account_num'} && exists $input{'MEDICARE_account_num'} && exists $input{'AEIC_account_num'} && exists $input{'salary_expense_account_num'}))
  {
    PrintErrorHeader();
    print "<h1>Error: Missing necessary account number form value!</h1>\n";
    print "Account number hidden value is missing.<br>$sys_admin";
    CleanUp();
  }
  # assign the accounts to their respective arrays
  $salary_expense_account_nums = $input{'salary_expense_account_num'};
  $FITW_account_nums = $input{'FITW_account_num'};
  $FICA_account_nums = $input{'FICA_account_num'};
  $MEDICARE_account_nums = $input{'MEDICARE_account_num'};
  $AEIC_account_nums = $input{'AEIC_account_num'};

  # make sure that year and quarter selects exist and set the federal_from and federal_to dates to the quarter selected
  # based on the calendar year (federal 941 reports are only based on calendar periods)
  if (not (exists $input{'federal_year'} && exists $input{'federal_quarter'}))
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value missing!</h1>\n";
    print "Year and/or Quarter select values missing.<br>$sys_admin";
    CleanUp();
  }
  # set the federal year
  $federal_year = $input{'federal_year'};
  # set the federal quarter based upon the value from the select
  if ($input{'federal_quarter'} eq "1st")
  {
    $federal_quarter = 1;
    # set the date range for the quarter selected
    $federal_from_date = "01-01-$federal_year";
    $federal_to_date = "03-31-$federal_year";
    $reverse_federal_to_date = $federal_year . "0331";
  }
  elsif ($input{'federal_quarter'} eq "2nd")
  {
    $federal_quarter = 2;
    # set the date range for the quarter selected
    $federal_from_date = "04-01-$federal_year";
    $federal_to_date = "06-30-$federal_year";
    $reverse_federal_to_date = $federal_year . "0630";
  }
  elsif ($input{'federal_quarter'} eq "3rd")
  {
    $federal_quarter = 3;
    # set the date range for the quarter selected
    $federal_from_date = "07-01-$federal_year";
    $federal_to_date = "09-30-$federal_year";
    $reverse_federal_to_date = $federal_year . "0930";
  }
  elsif ($input{'federal_quarter'} eq "4th")
  {
    $federal_quarter = 4;
    # set the date range for the quarter selected
    $federal_from_date = "10-01-$federal_year";
    $federal_to_date = "12-31-$federal_year";
    $reverse_federal_to_date = $federal_year . "1231";
  }
  else
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid value for federal quarter!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  # make sure amounts input are valid floating point values
  if (not exists $input{'federal_over_under_payment_amount'})
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value (federal over/under payment) missing!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (not exists $input{'federal_over_under_radio'})
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value (federal over/under radio) missing!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (not exists $input{'federal_other_adjustments_amount'})
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value (federal other adjustments) missing!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (not exists $input{'FICA_MEDICARE_sick_pay_amount'})
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value (FICA/MEDICARE sick pay) missing!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }
  if (not exists $input{'FICA_MEDICARE_other_adjustments_amount'})
  {
    PrintErrorHeader();
    print "<h1>Error: Necessary form value (FICA/MEDICARE other adjustments) missing!</h1>\n";
    print "$sys_admin";
    CleanUp();
  }

  $FITW_over_under_payment_amount = $input{'federal_over_under_payment_amount'};
  if ($FITW_over_under_payment_amount eq "")
  {
    $FITW_over_under_payment_amount = 0.00;
  }
  if (IsValidFloating($FITW_over_under_payment_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point value!</h1>\n";
    print "Over/Under payment contains an invalid number.<br>$sys_admin";
    CleanUp();
  }
  if ($input{'federal_over_under_radio'} eq "over")
  {
    if ($FITW_over_under_payment_amount != 0)
    {
      $FITW_over_under_payment_amount = (-1.0)*(abs($FITW_over_under_payment_amount));
    }
  }
  elsif ($input{'federal_over_under_radio'} eq "under")
  {
    $FITW_over_under_payment_amount = abs($FITW_over_under_payment_amount);
  }
  else
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid radio value!</h1>\n";
    print "The Over/Under payment radio button has an invalid value.<br>$sys_admin";
    CleanUp();
  }

  $FITW_other_adjustments_amount = $input{'federal_other_adjustments_amount'};
  if ($FITW_other_adjustments_amount eq "")
  {
    $FITW_other_adjustments_amount = 0.00;
  }
  if (IsValidFloating($FITW_other_adjustments_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point value!</h1>\n";
    print "FITW other adjustments contains an invalid number.<br>$sys_admin";
    CleanUp();
  }

  $FICA_MEDICARE_sick_pay_amount = $input{'FICA_MEDICARE_sick_pay_amount'};
  if ($FICA_MEDICARE_sick_pay_amount eq "")
  {
    $FICA_MEDICARE_sick_pay_amount = 0.00;
  }
  if (IsValidFloating($FICA_MEDICARE_sick_pay_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point value!</h1>\n";
    print "FICA/MEDICARE sick pay contains an invalid number.<br>$sys_admin";
    CleanUp();
  }

  $FICA_MEDICARE_other_adjustments_amount = $input{'FICA_MEDICARE_other_adjustments_amount'};
  if ($FICA_MEDICARE_other_adjustments_amount eq "")
  {
    $FICA_MEDICARE_other_adjustments_amount = 0.00;
  }
  if (IsValidFloating($FICA_MEDICARE_other_adjustments_amount) eq "")
  {
    PrintErrorHeader();
    print "<h1>Error: Invalid floating point value!</h1>\n";
    print "FICA/MEDICARE other adjustments contains an invalid number.<br>$sys_admin";
    CleanUp();
  }

  # set the order the name and numbers display in
  if (exists $input{'show_accounts_as'})
  {
    if ($input{'show_accounts_as'} eq "name-number")
    {
      $federal_display_order = "0";
    }
    elsif ($input{'show_accounts_as'} eq "number-name")
    {
      $federal_display_order = "1";
    }
    else
    {
      $federal_display_order = "0";
    }
  }
  else
  {
    $federal_display_order = "0";
  }
}

sub reports4Federal941Work
{
  my $counter;
  my $temp_sub_account_name;
  my $temp_sub_account_number;
  my %account_types;
  my %sub_account_nums;
  my $temp_account_num;
  my $temp_debit_increases;
  my $temp_quarter_salary_amount;
  my $temp_quarter_tips_amount;
  my $temp_total_salary_amount;
  my $temp_total_tips_amount;
  my $temp_previous_salary_amount;
  my $temp_previous_tips_amount;
  my $temp_FITW_amount;
  my $temp_date;
  my $temp_FICA_wages_amount;
  my $temp_FICA_tips_amount;
  my $temp_total_owed;
  my $temp_total;
  my $temp_aeic_total;
  my $temp_quarter_sub_account;
  my $temp_from_date;
  my $temp_to_date;
  my $temp_deposits_total;
  my $quarter_month1_from;
  my $quarter_month1_to;
  my $quarter_month2_from;
  my $quarter_month2_to;
  my $quarter_month3_from;
  my $quarter_month3_to;

  my $fica = Payroll::US::FICA->new();
  if ($fica->didErrorOccur())
  {
    PrintErrorHeader();
    print $fica->errorMessage();
    CleanUp();
  }

  my $medicare = Payroll::US::Medicare->new();
  if ($medicare->didErrorOccur())
  {
    PrintErrorHeader();
    print $medicare->errorMessage();
    CleanUp();
  }

  # get the FICA and the MEDICARE rates and caps from the Payroll modules
  ($FICA_rate, $FICA_cap) = $fica->rateCap($reverse_federal_to_date);
  if ($fica->didErrorOccur)
  {
    PrintErrorHeader();
    print $fica->errorMessage;
    CleanUp();
  }
  $FICA_rate *= 2.0;

  ($MEDICARE_rate, $MEDICARE_cap) = $medicare->rateCap($reverse_federal_to_date);
  if ($medicare->didErrorOccur)
  {
    PrintErrorHeader();
    print $medicare->errorMessage;
    CleanUp();
  }
  $MEDICARE_rate *= 2.0;

  # assign default values for the quarter sub-accounts
  $q1_sub_account_num = 1;
  $q2_sub_account_num = 2;
  $q3_sub_account_num = 3;
  $q4_sub_account_num = 4;

  # calculate the date one day less than the current quarter's beginning date
  if ($federal_quarter == 1)
  {
    $temp_date = "";
  }
  elsif ($federal_quarter == 2)
  {
    $temp_date = "03-31-$federal_year";
  }
  elsif ($federal_quarter == 3)
  {
    $temp_date = "06-30-$federal_year";
  }
  elsif ($federal_quarter == 4)
  {
    $temp_date = "09-30-$federal_year";
  }

  # calculate values for FITW summary table that contains the sub-accounts and their total salary amounts (wages, tips, etc.)
  # and the amount of federal income tax withholdings for the selected quarter
  #
  # retrieve all the sub-account names and numbers for the Employee sub-account type
  $result = $conn->exec("select sub_acc_name, sub_acc_number from sub_acc_tb where type = 20 order by sub_acc_name");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the Employee sub-account names and numbers.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to retrieve all Employee sub-account numbers for use with the account(s): $salary_expense_account_nums.<br>$sys_admin";
    CleanUp();
  }
  $number_of_employees = 0;
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_sub_account_name = $result->getvalue($counter, 0);
    $temp_sub_account_number = $result->getvalue($counter, 1);
    if ($temp_sub_account_number != $q1_sub_account_num && $temp_sub_account_number != $q2_sub_account_num && $temp_sub_account_number != $q3_sub_account_num && $temp_sub_account_number != $q4_sub_account_num)
    {
      $employee_amounts{$temp_sub_account_number} = [];
      $employee_amounts{$temp_sub_account_number}[0] = $temp_sub_account_name;
      $employee_amounts{$temp_sub_account_number}[1] = $temp_sub_account_number;
      # calculate the number of employees to use for the federal 941 report
      $number_of_employees++;
    }
  }
  # temporarily assign account types to account_types hash for the salary expense accounts
  $result = $conn->exec("select distinct account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where number in ($salary_expense_account_nums)) and account_tb.number in ($salary_expense_account_nums)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the account types for the salary_expense accounts list: $salary_expense_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the account types for the salary_expense accounts list.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # for every sub-account number in the employee_amounts hash, retrieve all the salary amounts for the selected quarter
  foreach $temp_sub_account_number (keys %employee_amounts)
  {
    $temp_quarter_salary_amount = 0.0;
    foreach $temp_account_num (keys %account_types)
    {
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_quarter_salary_amount += $result->getvalue(0, 0);
      }
      else
      {
        $temp_quarter_salary_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_quarter_salary_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $temp_quarter_salary_amount += $result->getvalue(0, 0);
      }
    }
    # assign the quarter salary amount to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[2] = $temp_quarter_salary_amount;
    # accumulate the total salary amount for all employees for the quarter
    $total_wages_tips += $temp_quarter_salary_amount;

    $temp_quarter_tips_amount = 0.0;
    # get the tips for the current quarter from the tips table
    $result = $conn->exec("select sum(amount) from tips_tb where employee_id = $temp_sub_account_number and ledger_code = '$ledger_code' and tip_date between '$federal_from_date' and '$federal_to_date'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing the database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get the tips for the employee: $temp_sub_account_number.<br>$sys_admin";
      CleanUp();
    }
    $temp_quarter_tips_amount = $result->getvalue(0, 0);
    # assign the quarter tips amount to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[3] = $temp_quarter_tips_amount;
    # add the tips to the total amount
    $total_wages_tips += $temp_quarter_tips_amount;

    # for every sub-account number in the employee_amounts hash, retrieve all the salary amounts for the period from the
    # beginning of the year to one less than the federal_from_date if the federal_from_date is not the beginning of the year
    # (January 1st)
    $temp_previous_salary_amount = 0.0;
    $temp_previous_tips_amount = 0.0;
    if ($federal_quarter != 1)
    {
      foreach $temp_account_num (keys %account_types)
      {
        $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '01-01-$federal_year' and '$temp_date' and ledger_code = '$ledger_code')");
        if ($result->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing the database failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
          CleanUp();
        }
        if ($account_types{$temp_account_num} eq "t")
        {
          $temp_previous_salary_amount += $result->getvalue(0, 0);
        }
        else
        {
          $temp_previous_salary_amount -= $result->getvalue(0, 0);
        }
        $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '01-01-$federal_year' and '$temp_date' and ledger_code = '$ledger_code')");
        if ($result->resultStatus != PGRES_TUPLES_OK)
        {
          PrintErrorHeader();
          print "<h1>Error: Accessing the database failed!</h1>\n";
          print $conn->errorMessage . "<br>Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
          CleanUp();
        }
        if ($account_types{$temp_account_num} eq "t")
        {
          $temp_previous_salary_amount -= $result->getvalue(0, 0);
        }
        else
        {
          $temp_previous_salary_amount += $result->getvalue(0, 0);
        }
      }
      # get the tips for previous quarters from the tips table
      $result = $conn->exec("select sum(amount) from tips_tb where employee_id = $temp_sub_account_number and ledger_code = '$ledger_code' and tip_date between '01-01-$federal_year' and '$temp_date'");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get the tips for the employee: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      $temp_previous_tips_amount = $result->getvalue(0, 0);
    }
    # assign the previous quarters' salary amounts to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[4] = $temp_previous_salary_amount;
    # add the previous quarters' tips amounts to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[4] += $temp_previous_tips_amount;

    # for every sub-account number in the employee_amounts hash, retrieve all the salary amounts for the period from the
    # beginning of the year to the federal_to_date if the federal_from_date is not the beginning of the year (January 1st)
    $temp_total_salary_amount = 0.0;
    $temp_total_tips_amount = 0.0;
    foreach $temp_account_num (keys %account_types)
    {
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '01-01-$federal_year' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_total_salary_amount += $result->getvalue(0, 0);
      }
      else
      {
        $temp_total_salary_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '01-01-$federal_year' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_total_salary_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $temp_total_salary_amount += $result->getvalue(0, 0);
      }
    }
    # get the tips for previous quarters from the tips table
    $result = $conn->exec("select sum(amount) from tips_tb where employee_id = $temp_sub_account_number and ledger_code = '$ledger_code' and tip_date between '01-01-$federal_year' and '$federal_to_date'");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing the database failed!</h1>\n";
      print $conn->errorMessage . "<br>Tried to get the tips for the employee: $temp_sub_account_number.<br>$sys_admin";
      CleanUp();
    }
    $temp_total_tips_amount = $result->getvalue(0, 0);
    # assign the total salary amount to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[5] = $temp_total_salary_amount;
    # add the total tips amount to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[5] += $temp_total_tips_amount;

    # calculate values for FICA and MEDICARE summary table that contains the sub-accounts and their under cap amounts for
    # FICA wages and FICA tips
    #
    # if the previous quarters' wages + tips exceeds the cap amount, set the current quarter's amount to 0
    if ($employee_amounts{$temp_sub_account_number}[4] >= $FICA_cap)
    {
      $temp_FICA_wages_amount = 0.0;
      $temp_FICA_tips_amount = 0.0;
    }
    else
    {
      if ($employee_amounts{$temp_sub_account_number}[5] >= $FICA_cap)
      {
        # how much of wages and/or tips should be used?
        if ($employee_amounts{$temp_sub_account_number}[4] + $employee_amounts{$temp_sub_account_number}[2] >= $FICA_cap)
        {
          $temp_FICA_wages_amount = $FICA_cap - $employee_amounts{$temp_sub_account_number}[4];
          $temp_FICA_tips_amount = 0.0;
        }
        else
        {
          $temp_FICA_wages_amount = $employee_amounts{$temp_sub_account_number}[2];
          $temp_FICA_tips_amount = $FICA_cap - ($employee_amounts{$temp_sub_account_number}[2] + $employee_amounts{$temp_sub_account_number}[4]);
        }
      }
      else
      {
        # use all of both wages and tips
        $temp_FICA_wages_amount = $employee_amounts{$temp_sub_account_number}[2];
        $temp_FICA_tips_amount = $employee_amounts{$temp_sub_account_number}[3];
      }
    }
    $employee_amounts{$temp_sub_account_number}[7] = $temp_FICA_wages_amount;
    $taxable_FICA_wages += $temp_FICA_wages_amount;
    $employee_amounts{$temp_sub_account_number}[8] = $temp_FICA_tips_amount;
    $taxable_FICA_tips += $temp_FICA_tips_amount;
  }

  # clear the account_types hash
  undef %account_types;
  # temporarily assign account types to account_types hash for the FITW payable accounts
  $result = $conn->exec("select account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where number in ($FITW_account_nums)) and account_tb.number in ($FITW_account_nums)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the account types for the FITW accounts list: $FITW_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the account types for the FITW accounts list.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # for every sub-account number in the employee_amounts hash, retrieve all the FITW amounts
  foreach $temp_sub_account_number (keys %employee_amounts)
  {
    $temp_FITW_amount = 0.0;
    foreach $temp_account_num (keys %account_types)
    {
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>FITW: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_FITW_amount += $result->getvalue(0, 0);
      }
      else
      {
        $temp_FITW_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>FITW: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_FITW_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $temp_FITW_amount += $result->getvalue(0, 0);
      }
    }
    # assign the federal income tax withholding amount to the employee amounts hash
    $employee_amounts{$temp_sub_account_number}[6] = $temp_FITW_amount;
    # accumulate the total withholding amount for all employees for the quarter
    $total_income_tax_withheld += $temp_FITW_amount;
  }

  # calculate adjustment of withheld income tax for preceding quarters of calendar year
  $adjusted_total_income_tax_withheld = $total_income_tax_withheld + $FITW_over_under_payment_amount;
  # calculate adjusted total of income tax withheld
  $adjusted_total_income_tax_withheld += $FITW_other_adjustments_amount;

  # calculate FICA tax : (FICA wages under cap + FICA tips under cap) * FICA_rate AND ROUND
  $tax_FICA_wages = sprintf("%.2f",$taxable_FICA_wages * $FICA_rate);
  $tax_FICA_tips = sprintf("%.2f",$taxable_FICA_tips * $FICA_rate);

  # calculate MEDICARE tax : (<selected quarter's wages> + <selected quarter's tips>) * MEDICARE_rate
  $tax_MEDICARE_wages_tips = $total_wages_tips * $MEDICARE_rate;

  # calculate total FICA and MEDICARE taxes
  $total_FICA_MEDICARE_taxes = $tax_FICA_wages + $tax_FICA_tips + $tax_MEDICARE_wages_tips;

  # calculate adjustment to FICA and MEDICARE taxes : FICA_MEDICARE_sick_pay + fractions_of_cents + FICA_MEDICARE_other_adjustments
  # clear the account_types hash
  undef %account_types;
  # temporarily assign account types to account_types hash for the FICA and MEDICARE payable accounts
  $result = $conn->exec("select account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where (number in ($FICA_account_nums) or number in ($MEDICARE_account_nums))) and (account_tb.number in ($FICA_account_nums) or account_tb.number in ($MEDICARE_account_nums))");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the account types for the FICA and MEDICARE payable accounts lists: $FICA_account_nums - $MEDICARE_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the account types for the FICA and MEDICARE payable accounts lists.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # get the owed total for FICA and MEDICARE taxes by summing the amounts for the employees from the payable accounts plus
  # the amounts for all sub-accounts that are not employees or quarters in the FICA and MEDICARE tables
  # get the distinct list of sub-account numbers that are not quarter sub-account numbers
  $result = $conn->exec("select distinct(sub_account_num) from debitcredit_tb where ledger_code = '$ledger_code' and (account_num in ($FICA_account_nums) or account_num in ($MEDICARE_account_nums)) and parent_num in (select ref_num from journal_entry_tb where ledger_code = '$ledger_code' and trans_date between '$federal_from_date' and '$federal_to_date') and (sub_account_num <> $q1_sub_account_num and sub_account_num <> $q2_sub_account_num and sub_account_num <> $q3_sub_account_num and sub_account_num <> $q4_sub_account_num)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get a list of distinct sub-account numbers for the FICA and MEDICARE accounts to be used for total withholdings.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get a list of distinct sub-account numbers for the FICA and MEDICARE accounts to be used for total withholdings.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_sub_account_number = $result->getvalue($counter, 0);
    $sub_account_nums{$temp_sub_account_number} = 0;
  }
  $temp_total_owed = 0.0;
  foreach $temp_sub_account_number (keys %sub_account_nums)
  {
    $temp_total = 0.0;
    foreach $temp_account_num (keys %account_types)
    {
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>FICA_MEDICARE: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_total += $result->getvalue(0, 0);
      }
      else
      {
        $temp_total -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>FICA_MEDICARE: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_total -= $result->getvalue(0, 0);
      }
      else
      {
        $temp_total += $result->getvalue(0, 0);
      }
    }
    # increment the total owed
    $temp_total_owed += $temp_total;
  }
  # make sure that there is a total greater than 0
  if ($temp_total_owed > 0)
  {
    # calculate fractions of cents : owed_total - FICA_MEDICARE_total
    $fractions_of_cents = $temp_total_owed - $total_FICA_MEDICARE_taxes;
  }
  else
  {
    $fractions_of_cents = 0.0;
  }

  # calculate adjusted total of FICA and MEDICARE taxes
  $adjustment_FICA_MEDICARE_amount = $FICA_MEDICARE_sick_pay_amount + $fractions_of_cents + $FICA_MEDICARE_other_adjustments_amount;

  $adjusted_total_FICA_MEDICARE_taxes = $total_FICA_MEDICARE_taxes + $adjustment_FICA_MEDICARE_amount;

  # calculate total taxes : <FITW taxes> + <FICA_MEDICARE taxes>
  $total_taxes_amount = $adjusted_total_income_tax_withheld + $adjusted_total_FICA_MEDICARE_taxes;

  # calculate advance earned income credit payments
  # clear the account_types hash
  undef %account_types;
  # temporarily assign account types to account_types hash for the advance earned income credit accounts
  $result = $conn->exec("select account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where number in ($AEIC_account_nums)) and account_tb.number in ($AEIC_account_nums)");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the account types for the Advance EIC accounts list: $AEIC_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the account types for the Advance EIC accounts list.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # get the total for advance earned income credit payments by summing the amounts for the employees from the accounts
  $advance_EIC_payments = 0.0;
  foreach $temp_sub_account_number (keys %employee_amounts)
  {
    $temp_aeic_total = 0.0;
    foreach $temp_account_num (keys %account_types)
    {
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>AEIC: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_aeic_total += $result->getvalue(0, 0);
      }
      else
      {
        $temp_aeic_total -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$federal_from_date' and '$federal_to_date' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>AEIC: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $temp_aeic_total -= $result->getvalue(0, 0);
      }
      else
      {
        $temp_aeic_total += $result->getvalue(0, 0);
      }
    }
    # increment the total aeic payments
    $advance_EIC_payments += $temp_aeic_total;
  }

  # calculate net taxes
  $net_taxes_amount = $total_taxes_amount - $advance_EIC_payments;

  # calculate total deposits for the selected quarter
  # search the FITW, FICA, MEDICARE accounts for the sub-account number matching the selected quarter with the date range of
  # 1 month before the quarter started to 2 months after the quarter ended; sum all amounts returned based on the account
  # type debit_increases value
  if ($federal_quarter == 1)
  {
    $temp_quarter_sub_account = $q1_sub_account_num;
  }
  elsif ($federal_quarter == 2)
  {
    $temp_quarter_sub_account = $q2_sub_account_num;
  }
  elsif ($federal_quarter == 3)
  {
    $temp_quarter_sub_account = $q3_sub_account_num;
  }
  else
  {
    $temp_quarter_sub_account = $q4_sub_account_num;
  }
  $temp_from_date = $federal_from_date;
  $temp_to_date = $federal_to_date;
  # substitute all "-"'s for "/"'s so the date command works properly with the given date format
  $temp_to_date =~ s/\-/\//g;
  # replace the to date with the date three months after the dates in the temp date strings
  $temp_to_date = `date -d "$temp_to_date 3 months" +%m-%d-%Y`;
  # clear the account_types hash
  undef %account_types;
  # temporarily assign account types to account_types hash for the FITW, FICA, MEDICARE accounts
  $result = $conn->exec("select account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where (number in ($FITW_account_nums) or number in ($FICA_account_nums) or number in ($MEDICARE_account_nums))) and (account_tb.number in ($FITW_account_nums) or account_tb.number in ($FICA_account_nums) or account_tb.number in ($MEDICARE_account_nums))");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Tried to get the account types for the FITW, FICA, MEDICARE accounts lists: $FITW_account_nums - $FICA_account_nums - $MEDICARE_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Tried to get the account types for the FITW, FICA, MEDICARE accounts lists.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # get the sum of all amounts returned from the FITW, FICA, MEDICARE accounts according to their debit_increases value for
  # the selected quarter for all deposits
  $temp_deposits_total = 0.0;
  $total_deposits_for_quarter = 0.0;
  foreach $temp_account_num (keys %account_types)
  {
    $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_quarter_sub_account and parent_num in (select ref_num from journal_entry_tb where trans_date between '$temp_from_date' and '$temp_to_date' and ledger_code = '$ledger_code')");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing the database failed!</h1>\n";
      print $conn->errorMessage . "<br>FITW,FICA,MEDICARE: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_quarter_sub_account.<br>$sys_admin";
      CleanUp();
    }
    if ($account_types{$temp_account_num} eq "f")
    {
      $temp_deposits_total += $result->getvalue(0, 0);
    }
    else
    {
      $temp_deposits_total -= $result->getvalue(0, 0);
    }
    $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_quarter_sub_account and parent_num in (select ref_num from journal_entry_tb where trans_date between '$temp_from_date' and '$temp_to_date' and ledger_code = '$ledger_code')");
    if ($result->resultStatus != PGRES_TUPLES_OK)
    {
      PrintErrorHeader();
      print "<h1>Error: Accessing the database failed!</h1>\n";
      print $conn->errorMessage . "<br>FITW,FICA,MEDICARE: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_quarter_sub_account.<br>$sys_admin";
      CleanUp();
    }
    if ($account_types{$temp_account_num} eq "f")
    {
      $temp_deposits_total -= $result->getvalue(0, 0);
    }
    else
    {
      $temp_deposits_total += $result->getvalue(0, 0);
    }
  }
  # increment the total deposits
  $total_deposits_for_quarter = $temp_deposits_total;

  # calculate balance due
  $balance_due_amount = $net_taxes_amount - $total_deposits_for_quarter;

  # determine if overpayment has occurred
  $overpayment_amount = -1;
  if ($total_deposits_for_quarter > $net_taxes_amount)
  {
    #overpayment has occurred
    $overpayment_amount = $total_deposits_for_quarter - $net_taxes_amount;
  }

  # calculate values for monthly federal tax liability summary
  $quarter_month1_from = $federal_from_date;
  $quarter_month1_to = $federal_from_date;
  $quarter_month1_to =~ s/\-/\//g;
  $quarter_month1_to = `date -d "$quarter_month1_to 1 month -1 day" +%m-%d-%Y`;
  $quarter_month2_from = $quarter_month1_to;
  $quarter_month2_from =~ s/\-/\//g;
  $quarter_month2_from = `date -d "$quarter_month2_from +1 day" +%m-%d-%Y`;
  $quarter_month2_to = $quarter_month2_from;
  $quarter_month2_to =~ s/\-/\//g;
  $quarter_month2_to = `date -d "$quarter_month2_to 1 month -1 day" +%m-%d-%Y`;
  $quarter_month3_from = $quarter_month2_to;
  $quarter_month3_from =~ s/\-/\//g;
  $quarter_month3_from = `date -d "$quarter_month3_from +1 day" +%m-%d-%Y`;
  $quarter_month3_to = $federal_to_date;
  # clear the account_types hash
  undef %account_types;
  # temporarily assign account types to account_types hash for the FITW, FICA, MEDICARE accounts
  $result = $conn->exec("select account_tb.number, acct_type_tb.debit_increases from account_tb, acct_type_tb where acct_type_tb.num in (select type from account_tb where (number in ($FITW_account_nums) or number in ($FICA_account_nums) or number in ($MEDICARE_account_nums))) and (account_tb.number in ($FITW_account_nums) or account_tb.number in ($FICA_account_nums) or account_tb.number in ($MEDICARE_account_nums))");
  if ($result->resultStatus != PGRES_TUPLES_OK)
  {
    PrintErrorHeader();
    print "<h1>Error: Accessing the database failed!</h1>\n";
    print $conn->errorMessage . "<br>Liability: Tried to get the account types for the FITW, FICA, MEDICARE accounts lists: $FITW_account_nums - $FICA_account_nums - $MEDICARE_account_nums.<br>$sys_admin";
    CleanUp();
  }
  if ($result->ntuples <= 0)
  {
    PrintErrorHeader();
    print "<h1>Error: No records returned!</h1>\n";
    print "Liability: Tried to get the account types for the FITW, FICA, MEDICARE accounts lists.<br>It does not appear that this report is setup.<br>$sys_admin";
    CleanUp();
  }
  for ($counter=0; $counter < $result->ntuples; $counter++)
  {
    $temp_account_num = $result->getvalue($counter, 0);
    $temp_debit_increases = $result->getvalue($counter, 1);
    $account_types{$temp_account_num} = $temp_debit_increases;
  }
  # get the sum of all amounts returned from the FITW, FICA, MEDICARE accounts according to their debit_increases value for
  # the selected quarter for all employees to determine the total liability for each month of the quarter
  $month_1_liability_amount = 0.0;
  $month_2_liability_amount = 0.0;
  $month_3_liability_amount = 0.0;
  $quarter_liability_amount = 0.0;
  foreach $temp_sub_account_number (keys %sub_account_nums)
  {
    foreach $temp_account_num (keys %account_types)
    {
      # month 1 liability
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month1_from' and '$quarter_month1_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_1_liability_amount += $result->getvalue(0, 0);
      }
      else
      {
        $month_1_liability_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month1_from' and '$quarter_month1_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_1_liability_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $month_1_liability_amount += $result->getvalue(0, 0);
      }
      # month 2 liability
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month2_from' and '$quarter_month2_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_2_liability_amount += $result->getvalue(0, 0);
      }
      else
      {
        $month_2_liability_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month2_from' and '$quarter_month2_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_2_liability_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $month_2_liability_amount += $result->getvalue(0, 0);
      }
      # month 3 liability
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = true and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month3_from' and '$quarter_month3_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of debits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_3_liability_amount += $result->getvalue(0, 0);
      }
      else
      {
        $month_3_liability_amount -= $result->getvalue(0, 0);
      }
      $result = $conn->exec("select sum(amount) from debitcredit_tb where dorc = false and ledger_code = '$ledger_code' and account_num = $temp_account_num and sub_account_num = $temp_sub_account_number and parent_num in (select ref_num from journal_entry_tb where trans_date between '$quarter_month3_from' and '$quarter_month3_to' and ledger_code = '$ledger_code')");
      if ($result->resultStatus != PGRES_TUPLES_OK)
      {
        PrintErrorHeader();
        print "<h1>Error: Accessing the database failed!</h1>\n";
        print $conn->errorMessage . "<br>Liability: Tried to get the sum of credits for the selected quarter for the sub-account: $temp_sub_account_number.<br>$sys_admin";
        CleanUp();
      }
      if ($account_types{$temp_account_num} eq "t")
      {
        $month_3_liability_amount -= $result->getvalue(0, 0);
      }
      else
      {
        $month_3_liability_amount += $result->getvalue(0, 0);
      }
    }
  }
  $quarter_liability_amount = $month_1_liability_amount + $month_2_liability_amount + $month_3_liability_amount;
}

sub reports4Federal941DisplayForm
{
  my $counter;
  my $temp_sub_account_number;
  my $temp_amount;

  # display the quarter and the range of dates for the quarter
  print "<center><font size=$font_size_text><b>Quarter: $federal_quarter</b></font></center>\n";
  print "<center><font size=$font_size_text>From:&nbsp;<font color=blue>$federal_from_date</font>&nbsp;&nbsp;To:&nbsp;<font color=blue>$federal_to_date</font></font></center>\n";
  print "<br>\n";
  print "<table border=0 cellspacing=0 cellpadding=2 width=75%>\n";
  print "<tr>\n";
  print "<th align=left><font size=$font_size_text>Sub-Accounts<sub>(<i>Employees</i>)</sub></font></th><th align=right><font size=$font_size_text>Salary Amount</font></th><th align=right><font size=$font_size_text>FITW Amount</font></th>\n";
  print "</tr>\n";
  if ($federal_display_order eq "0")
  {
    foreach $temp_sub_account_number (keys %employee_amounts)
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $employee_amounts{$temp_sub_account_number}[0] . "&nbsp;-&nbsp;" . $employee_amounts{$temp_sub_account_number}[1] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      $temp_amount = $employee_amounts{$temp_sub_account_number}[2] + $employee_amounts{$temp_sub_account_number}[3];
      if ($temp_amount < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($temp_amount)));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($temp_amount)));
      }
      print "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[6] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[6])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[6])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  else
  {
    foreach $temp_sub_account_number (sort {$a <=> $b} keys %employee_amounts)
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $employee_amounts{$temp_sub_account_number}[1] . "&nbsp;-&nbsp;" . $employee_amounts{$temp_sub_account_number}[0] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      $temp_amount = $employee_amounts{$temp_sub_account_number}[2] + $employee_amounts{$temp_sub_account_number}[3];
      if ($temp_amount < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($temp_amount)));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($temp_amount)));
      }
      print "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[6] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[6])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[6])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  print "<tr><td colspan=3><hr></td></tr>\n";
  # display the total amount for salaries and FITW
  print "<tr>\n";
  print "<td align=left><font size=$font_size_data><b>Total</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($total_wages_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  print "</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($total_income_tax_withheld < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_income_tax_withheld)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_income_tax_withheld)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # display a space between the table entries
  print "<tr><td colspan=3><br></td></tr>\n";

  # 1. display the number of employees in the current quarter
  print "<tr>\n";
  print "<td align=left colspan=2><font size=$font_size_text><b>1.</b> Number of employees in quarter</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  print commify($number_of_employees) . "&nbsp;&nbsp;";
  print "</font></td>\n";
  print "</tr>\n";

  # 2. display the total salaries of all employees
  print "<tr>\n";
  print "<td align=left colspan=2><font size=$font_size_text><b>2.</b> Total wages and tips</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($total_wages_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 3. display the total income tax withheld for all employees
  print "<tr>\n";
  print "<td align=left colspan=2><font size=$font_size_text><b>3.</b> Total income tax withheld</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($total_income_tax_withheld < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_income_tax_withheld)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_income_tax_withheld)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 4. display the adjustments to withheld income tax for preceding quarters of the calendar year
  print "<tr>\n";
  print "<td align=left colspan=2><font size=$font_size_text><b>4.</b> Adjustment of withheld income tax for preceding quarters</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if (($FITW_over_under_payment_amount + $FITW_other_adjustments_amount) < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs(($FITW_over_under_payment_amount + $FITW_other_adjustments_amount))));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs(($FITW_over_under_payment_amount + $FITW_other_adjustments_amount))));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 5. display the adjusted total for income tax withheld
  print "<tr>\n";
  print "<td align=left colspan=2><font size=$font_size_text><b>5.</b> Adjusted total of income tax withheld</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($adjusted_total_income_tax_withheld < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($adjusted_total_income_tax_withheld)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($adjusted_total_income_tax_withheld)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # display a space between the table entries
  print "<tr><td colspan=3><br></td></tr>\n";

  # display table for wages and tips under cap
  print "<tr>\n";
  print "<th align=left><font size=$font_size_text>Sub-Accounts<sub>(<i>Employees</i>)</sub></font></th><th align=right><font size=$font_size_text>Wages<sub>(<i>Under Cap</i>)</sub></font></th><th align=right><font size=$font_size_text>Tips<sub>(<i>Under Cap</i>)</sub></font></th>\n";
  print "</tr>\n";
  if ($federal_display_order eq "0")
  {
    foreach $temp_sub_account_number (keys %employee_amounts)
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $employee_amounts{$temp_sub_account_number}[0] . "&nbsp;-&nbsp;" . $employee_amounts{$temp_sub_account_number}[1] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[7] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[7])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[7])));
      }
      print "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[8] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[8])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[8])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  else
  {
    foreach $temp_sub_account_number (sort {$a <=> $b} keys %employee_amounts)
    {
      print "<tr>\n";
      print "<td><font size=$font_size_data>" . $employee_amounts{$temp_sub_account_number}[1] . "&nbsp;-&nbsp;" . $employee_amounts{$temp_sub_account_number}[0] . "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[7] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[7])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[7])));
      }
      print "</font></td>\n";
      print "<td align=right><font size=$font_size_data>";
      if ($employee_amounts{$temp_sub_account_number}[8] < 0)
      {
        printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[8])));
      }
      else
      {
        printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($employee_amounts{$temp_sub_account_number}[8])));
      }
      print "</font></td>\n";
      print "</tr>\n";
    }
  }
  print "<tr><td colspan=3><hr></td></tr>\n";
  # display the total amount for taxable FICA wages and tips
  print "<tr>\n";
  print "<td align=left><font size=$font_size_data><b>Total</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($taxable_FICA_wages < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($taxable_FICA_wages)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($taxable_FICA_wages)));
  }
  print "</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($taxable_FICA_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($taxable_FICA_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($taxable_FICA_tips)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # display a space between the table entries
  print "<tr><td colspan=3><br></td></tr>\n";

  #  6. display taxable social security
  # 6a. display taxable social security wages    6b. display wages tax
  # 6c. display taxable social security tips     6c. display tips tax
  print "<tr>\n";
  print "<td><font size=$font_size_text><b>6.</b> Taxable social security wages</font></td>\n";
  print "<td align=right colspan=2 width=50%><table border=1 cellspacing=0 cellpadding=2 width=100%>\n";
  print "<tr>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>6a.</b></font></td>\n";
  print "<td align=right width=50%><font size=$font_size_data>";
  if ($taxable_FICA_wages < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($taxable_FICA_wages)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($taxable_FICA_wages)));
  }
  print "</font></td><td align=center width=6%><font size=$font_size_data>&nbsp;&#215;&nbsp;$FICA_rate&nbsp;=&nbsp;</font></td>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>6b.</b></font></td>\n";
  print "<td align=right width=40%><font size=$font_size_text>";
  if ($tax_FICA_wages < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($tax_FICA_wages)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($tax_FICA_wages)));
  }
  print "</font></td>\n";
  print "</tr>\n";
  print "</table></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td><font size=$font_size_text>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Taxable social security tips</font></td>\n";
  print "<td align=right colspan=2 width=50%><table border=1 cellspacing=0 cellpadding=2 width=100%>\n";
  print "<tr>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>6c.</b></font></td>\n";
  print "<td align=right width=50%><font size=$font_size_data>";
  if ($taxable_FICA_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($taxable_FICA_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($taxable_FICA_tips)));
  }
  print "</font></td><td align=center width=6%><font size=$font_size_data>&nbsp;&#215;&nbsp;$FICA_rate&nbsp;=&nbsp;</font></td>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>6d.</b></font></td>\n";
  print "<td align=right width=40%><font size=$font_size_text>";
  if ($tax_FICA_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($tax_FICA_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($tax_FICA_tips)));
  }
  print "</font></td>\n";
  print "</tr>\n";
  print "</table></td>\n";
  print "</tr>\n";

  #  7. display taxable medicare wages and tips  7a. <--
  # 7b. display wages and tips tax
  print "<tr>\n";
  print "<td><font size=$font_size_text><b>7.</b> Taxable Medicare wages and tips</font></td>\n";
  print "<td align=right colspan=2 width=50%><table border=1 cellspacing=0 cellpadding=2 width=100%>\n";
  print "<tr>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>7a.</b></font></td>\n";
  print "<td align=right width=50%><font size=$font_size_data>";
  if ($total_wages_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_wages_tips)));
  }
  print "</font></td><td align=center width=6%><font size=$font_size_data>&nbsp;&#215;&nbsp;$MEDICARE_rate&nbsp;=&nbsp;</font></td>\n";
  print "<td align=left width=2%><font size=$font_size_text><b>7b.</b></font></td>\n";
  print "<td align=right width=40%><font size=$font_size_text>";
  if ($tax_MEDICARE_wages_tips < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($tax_MEDICARE_wages_tips)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($tax_MEDICARE_wages_tips)));
  }
  print "</font></td>\n";
  print "</tr>\n";
  print "</table></td>\n";
  print "</tr>\n";

  # 8. display total social security and medicare taxes
  print "<tr>\n";
  print "<td colspan=2 align=left><font size=$font_size_text><b>8.</b> Total social security and Medicare taxes</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($total_FICA_MEDICARE_taxes < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_FICA_MEDICARE_taxes)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_FICA_MEDICARE_taxes)));
  }
  print "</font></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td colspan=2 align=left><font size=$font_size_text>Addendum: Total social security and Medicare taxes withheld</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if (($fractions_of_cents + $total_FICA_MEDICARE_taxes) < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs(($fractions_of_cents + $total_FICA_MEDICARE_taxes))));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs(($fractions_of_cents + $total_FICA_MEDICARE_taxes))));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 9. display adjustments for social security and medicare taxes : sick pay, fractions of cents, other adjustments
  print "<tr>\n";
  print "<td colspan=3><font size=$font_size_text><b>9.</b> Adjustment of social security and Medicare taxes</font></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td colspan=2 align=center><table cellspacing=0 cellpadding=2 border=1>\n";
  print "<tr>\n";
  print "<td><font size=$font_size_data>Sick Pay \$";
  if ($FICA_MEDICARE_sick_pay_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($FICA_MEDICARE_sick_pay_amount)));
  }
  else
  {
    printf "%s", commify(sprintf("%.2f", abs($FICA_MEDICARE_sick_pay_amount)));
  }
  print "</td><td><font size=$font_size_data>&#177;</font></td><td><font size=$font_size_data>Fractions of Cents \$";
  if ($fractions_of_cents < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($fractions_of_cents)));
  }
  else
  {
    printf "%s", commify(sprintf("%.2f", abs($fractions_of_cents)));
  }
  print "</font></td><td><font size=$font_size_data>&#177;</font></td><td><font size=$font_size_data>Other \$";
  if ($FICA_MEDICARE_other_adjustments_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($FICA_MEDICARE_other_adjustments_amount)));
  }
  else
  {
    printf "%s", commify(sprintf("%.2f", abs($FICA_MEDICARE_other_adjustments_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";
  print "</table></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($adjustment_FICA_MEDICARE_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($adjustment_FICA_MEDICARE_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($adjustment_FICA_MEDICARE_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 10. display adjusted total social security and medicare taxes
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>10.</b> Adjusted total of social security and Medicare taxes</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($adjusted_total_FICA_MEDICARE_taxes < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($adjusted_total_FICA_MEDICARE_taxes)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($adjusted_total_FICA_MEDICARE_taxes)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 11. display total taxes : line 5 + line 10
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>11. Total taxes</b></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($total_taxes_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_taxes_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_taxes_amount)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # 12. display advance earned income credit payments amount
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>12.</b> Advance earned income credit (EIC) payments made to employees</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($advance_EIC_payments < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($advance_EIC_payments)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($advance_EIC_payments)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 13. display net taxes : line 11 - line 12
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>13.</b> Net taxes</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($net_taxes_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($net_taxes_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($net_taxes_amount)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 14. display total deposits for quarter
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>14.</b> Total deposits from quarter</font></td>\n";
  print "<td align=right><font size=$font_size_text>";
  if ($total_deposits_for_quarter < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($total_deposits_for_quarter)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($total_deposits_for_quarter)));
  }
  print "</font></td>\n";
  print "</tr>\n";

  # 15. display balance due : line 13 - line 14
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>15. Balance due</b></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($balance_due_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($balance_due_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($balance_due_amount)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # 16. if overpayment has occurred (overpayment value != "-1"), display overpayment amount
  print "<tr>\n";
  print "<td colspan=2><font size=$font_size_text><b>16. Overpayment</b></font></td>\n";
  print "<td align=right><font size=$font_size_text><b>";
  if ($overpayment_amount < 0)
  {
    printf "<i>None</i>";
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($overpayment_amount)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";

  # display a space between the table entries
  print "<tr><td colspan=3><br></td></tr>\n";

  # 17. display table of monthly liability amounts for taxes
  print "<tr>\n";
  print "<td colspan=3>\n";
  print "<table border=1 width=100% cellspacing=0 cellpadding=2>\n";
  print "<tr>\n";
  print "<th colspan=4 align=left><font size=$font_size_text>17. Monthly Summary of Federal Tax Liability</font></th>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=center><font size=$font_size_data><b>(a)</b>&nbsp;First&nbsp;month&nbsp;liability</font></td>\n";
  print "<td align=center><font size=$font_size_data><b>(b)</b>&nbsp;Second&nbsp;month&nbsp;liability</font></td>\n";
  print "<td align=center><font size=$font_size_data><b>(c)</b>&nbsp;Third&nbsp;month&nbsp;liability</font></td>\n";
  print "<td align=center><font size=$font_size_data><b>(d)</b>&nbsp;Total&nbsp;liability&nbsp;for&nbsp;quarter</font></td>\n";
  print "</tr>\n";
  print "<tr>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($month_1_liability_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($month_1_liability_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($month_1_liability_amount)));
  }
  print "</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($month_2_liability_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($month_2_liability_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($month_2_liability_amount)));
  }
  print "</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($month_3_liability_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($month_3_liability_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($month_3_liability_amount)));
  }
  print "</b></font></td>\n";
  print "<td align=right><font size=$font_size_data><b>";
  if ($quarter_liability_amount < 0)
  {
    printf "<font color=red>(%s)</font>", commify(sprintf("%.2f", abs($quarter_liability_amount)));
  }
  else
  {
    printf "%s&nbsp;&nbsp;", commify(sprintf("%.2f", abs($quarter_liability_amount)));
  }
  print "</b></font></td>\n";
  print "</tr>\n";
  print "</table>\n";
  print "</td>\n";
  print "</tr>\n";

  print "</table>\n";
}

return 1;
