#!/usr/bin/perl
# report_display.cgi - This program is the reporting system.  It will either generate the create/edit report
# screens and handle all user input, or customize and then display any specified reports.
#$Id: report_display.cgi,v 1.56 2004/08/03 21:24:21 pcxuser Exp $
#This package is released under the GPL.  You should have recieved the GPL with it.
# Copyright (c) 2000 HLR http://www.pcxperience.org  All rights reserved.

# Program Modes:  Uses command
# command =
#	  = 'run_report_top' - Generates the interface to allow the user to customize and print the report and memorize the current settings.
#	  = 'run_report_bottom' - Actually displays the report based upon the current settings and user actions.

use strict;
use cgi_lib;
use custom;

my %errors;
%errors = ( 4000 => 'Eval of HTMLObject::FrameSet failed',
	       4001 => 'Invalid command specified',
	       4002 => 'Eval of HTMLObject::Normal failed',
	       4003 => 'command must be specified',
	       4004 => "Couldn't connect to Database",
	       4005 => "Parameter requires a value",
	       4006 => "Invalid Value for Parameter",
	       4007 => "DBI Preparation of SQL Statement Failed",
	       4008 => "DBI Execution of Statement Failed",
	       4009 => "DBI Error Occurred",
	       4018 => "Error opening file",
	       4028 => "Database Handle required",
	       4035 => "File Name required",
	       4036 => "Report Type required",
	     );
	
my %sql_statements;
%sql_statements = (  
			1067 => "SET datestyle TO 'POSTGRES,US'",
			   );

my %report_classes;
%report_classes = ( "custom" => "Custom", "cash" => "Cash Flow", "income" => "Income Statement", "balance" => "Balance Sheet", "acct_balance" => "Accounts Balance Sheet", "acct_activity" => "Accounts Activity Sheet" );
my @report_classes;
@report_classes = ( "custom", "cash", "income", "balance", "acct_balance", "acct_activity" );
my @account_type_levels;
@account_type_levels = ( "nothing", "accounts", "accounts, sub-accounts" );
my @account_levels;
@account_levels = ( "nothing", "sub-accounts" );
my @accounts_of_levels;
@accounts_of_levels = ( "nothing", "sub-accounts" );
my @sub_account_levels;
@sub_account_levels = ( "nothing", "accounts" );
my @sub_accounts_of_type_levels;
@sub_accounts_of_type_levels = ( "nothing", "accounts" );
my @sub_accounts_of_account_levels;
@sub_accounts_of_account_levels = ( "not available" );
my %regular_cell_types;
%regular_cell_types = ( "text" => "Text", "total" => "Total", "compare" => "Compare Rows", "account_type" => "Account Type", "account" => "Account", "sub_account" => "Sub Account", "accounts_of" => "Accounts of Account Type", "sub_accounts_of_type" => "Sub Accounts of Account Type", "sub_accounts_of_account" => "Sub Accounts of Account", "begin_account_type_balance" => "Beginning Account Type Balance", "end_account_type_balance" => "Ending Account Type Balance", "begin_account_balance" => "Beginning Account Balance", "end_account_balance" => "Ending Account Balance", "begin_sub_account_balance" => "Beginning Sub Account Balance", "end_sub_account_balance" => "Ending Sub Account Balance", "line" => "Line" );
my @regular_cell_types;
@regular_cell_types = ( "text", "total", "compare", "account_type", "account", "sub_account", "accounts_of", "sub_accounts_of_type", "sub_accounts_of_account", "begin_account_type_balance", "end_account_type_balance", "begin_account_balance", "end_account_balance", "line" ); # "begin_sub_account_balance", "end_sub_account_balance", (to be added later)
my %detailed_cell_types;
%detailed_cell_types = ( "text" => "Text", "line" => "Line", "detail" => "Detail" );
my @detailed_cell_types;
@detailed_cell_types = ( "text", "line", "detail" );
my @font_names;
@font_names = ( "helvetica" );
my %font_names;
%font_names = ( "helvetica" => "Helvetica" );
my @font_sizes;
@font_sizes = ( "+2", "+1", "+0", "-1", "-2" );
my %font_sizes;
%font_sizes = ( "+2" => "+2", "+1" => "+1", "+0" => "nothing", "-1" => "-1", "-2" => "-2" );
my @fg_colors;
@fg_colors = ( "black", "blue", "red" );
my %fg_colors;
%fg_colors = ( "black" => "Black", "blue" => "Blue", "red" => "Red" );
my @bg_colors;
@bg_colors = ( "white", "yellow", "pink" );
my %bg_colors;
%bg_colors = ( "white" => "White", "yellow" => "Yellow", "pink" => "Pink" );
my %column_names;
%column_names = ( 0 => "Zero", 1 => "One", 2 => "Two", 3 => "Three", 4 => "Four", 5 => "Five", 6 => "Six", 7 => "Seven", 8 => "Eight", 9 => "Nine", 10 => "Ten", 11 => "Eleven", 12 => "Twelve", 13 => "Thirteen", 14 => "Fourteen", 15 => "Fifteen", 16 => "Sixteen", 17 => "Seventeen", 18 => "Eighteen", 19 => "Nineteen", 20 => "Twenty", 21 => "Twenty One", 22 => "Twenty Two", 23 => "Twenty Three", 24 => "Twenty Four", 25 => "Twenty Five", 26 => "Twenty Six", 27 => "Twenty Seven", 28 => "Twenty Eight", 29 => "Twenty Nine", 30 => "Thirty" );
my @column_headers;
@column_headers = ( "sub_entities", "sub_accounts", "sub_account_types" );
my %column_headers;
%column_headers = ( "sub_entities" => "Sub Entities", "sub_accounts" => "Sub Accounts", "sub_account_types" => "Sub Account Types" );
my @negative_formats;
@negative_formats = ( "0", "1", "2" );
my %negative_formats;
%negative_formats = ( "0" => "<font color=\"red\">(xxx.xx)</font>", "1" => "<font color=\"red\">-</font>xxx.xx", "2" => "xxx.xx<font color=\"red\">-</font>" );
my $max_dates;
$max_dates = 4;   # the maximum number of columns that we are currently supporting in the reporting system.
my $min_underline_length;
$min_underline_length =  5;  # the min and max lengths that underlines can range within.
my $max_underline_length;
$max_underline_length = 25;
my $default_underline_length;
$default_underline_length = 15;
my %t_or_f;
%t_or_f = ( 0 => "false", 1 => "true", "true" => "true", "false" => "false" );  # a mapping that will allow us to map 0 to false and 1 to true for the sql statements.
my @account_formats;
@account_formats = ( "0", "1", "2", "3" );
my %account_formats;
%account_formats = ( "0" => "Name - Number", "1" => "Number - Name", "2" => "Name only", "3" => "Number only" );
my @precision_formats;
@precision_formats = ( "1", "10", "100", "1000", "10000", "100000", "1000000", "1000000000" );
my %precision_formats;
%precision_formats = ( "1" => "1", "10" => "10", "100" => "100", "1000" => "1,000", "10000" => "10,000", "100000" => "100,000", "1000000" => "1,000,000", "1000000000" => "1,000,000,000" );
my %precision_names;
%precision_names = ( "10" => "tens", "100" => "hundreds", "1000" => "thousands", "10000" => "ten-thousands", "100000" => "hundred-thousands", "1000000" => "millions", "1000000000" => "billions" );
my %true_false;
%true_false = ( "true" => 1, "false" => 0, 1 => 1, 0 => 0 );
# detailed view customization settings values
my @field_names;
@field_names = ( "account_name", "db.account_num", "db.amount", "db.cleared", "credit_amount", "je.trans_date", "debit_amount", "je.journal_code", "je.memo", "je.payee_payer", "je.ref_num", "je.remember", "sub_account_name", "db.sub_account_num", "db.sub_e_code" );
my %field_names;
%field_names = ( "account_name" => "Account Name", "je.ref_num" => "Reference Number", "je.journal_code" => "Journal Code", "je.trans_date" => "Date", "je.payee_payer" => "Payee-Payer", "je.memo" => "Memo", "je.remember" => "Remember", "db.sub_e_code" => "Sub-Entity Code", "db.account_num" => "Account Number", "sub_account_name" => "Sub-Account Name", "db.sub_account_num" => "Sub-Account Number", "db.amount" => "Amount", "credit_amount" => "Credit", "debit_amount" => "Debit", "db.cleared" => "Cleared" );

# detailed view display settings values
my @column_field_names;
@column_field_names = ( "Ref #", "Journal", "Date", "Payee-Payer", "Memo", "SbE", "Account", "Sub-account", "Cleared", "Debit", "Credit" );
my %header_map;
%header_map = ( "Ref #" => 0, "Journal" => 14, "Date" => 11, "Payee-Payer" => 12, "Memo" => 13, "SbE" => 1, "Account" => 3, "Sub-account" => 5, "Cleared" => 9, "Debit" => 7, "Credit" => 7 );

# commonly used compiled regular expressions
my $tripleAccountsRE = qr/^(account_type|account|accounts_of)$/;
my $tripleBeginAccountsRE = qr/^(begin_account_type_balance|begin_account_balance|begin_sub_account_balance)$/;
my $tripleEndAccountsRE = qr/^(end_account_type_balance|end_account_balance|end_sub_account_balance)$/;
my $singleQuoteRE = qr/\'/;
my $negativeOneRE = qr/^(-1)$/;
my $dotRE = qr/\./;

# regular view display settings values
my $font_underline_width;
$font_underline_width = 10;
my %hide_numbers;
%hide_numbers = {};
$hide_numbers{'account_type'} = {};
$hide_numbers{'account_type'}{'0'} = 1;

$hide_numbers{'accounts_of'} = {};
$hide_numbers{'accounts_of'}{'0'} = 1;

$hide_numbers{'begin_account_type_balance'} = {};
$hide_numbers{'begin_account_type_balance'}{'0'} = 1;

$hide_numbers{'end_account_type_balance'} = {};
$hide_numbers{'end_account_type_balance'}{'0'} = 1;

$hide_numbers{'sub_accounts_of_type'} = {};
$hide_numbers{'sub_accounts_of_type'}{'0'} = 1;
$hide_numbers{'sub_accounts_of_type'}{'1'} = 1;

use PortalWrapper; # The Portal Wrapper library.

my $portalObj;
$portalObj = PortalWrapper->new;
if ($portalObj->didErrorOccur)
{
  # begin the HTML Output
  print cgi_lib::PrintHeader();
  print "<html>\n";

  PrintErrorHeader();
  print $portalObj->errorMessage;
  CleanUp();
}
my $dbObj;
$dbObj = $portalObj->getDBInfo;
if (!defined $dbObj)
{
  if ($portalObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";

    PrintErrorHeader();
    print $portalObj->errorMessage;
    CleanUp();
  }
}
else
{
  if ($dbObj->didErrorOccur)
  {
    # begin the HTML Output
    print cgi_lib::PrintHeader();
    print "<html>\n";

    PrintErrorHeader();
    print $dbObj->errorMessage;
    CleanUp();
  }
}
$db_host = $dbObj->dbHost;
($db_name = $dbObj->dbName) =~ s/^(")([^"]+)(")$/$2/;
$db_user = $dbObj->dbUser;
$db_passwd = $dbObj->dbPasswd;

my $db_type;
$db_type = "Pg";
my $dsn;
$dsn = "dbi:$db_type:dbname=$db_name;host=$db_host";

my $email_address;
$email_address = "james\@pcxperience.com";  # JavaScript error messages should be sent here.

%input = ();
cgi_lib::ReadParse(*input);  # gather the data from the client

use HTMLObject::Base;
use HTMLObject::ReadCookie;	# the module used to read cookies sent to us from the client.
use Storable;		# the module that will allow me to dump data to disk and recover later.  The file names will be stored in the cookie.
use POSIX qw(tmpnam);	# the tmpnam function which will return a file name for a temporary file supposed to be unique.
use DBI;	# Using new Database engine for future compatibility.

# turn on debugging in Apache::DBI
#$Apache::DBI::DEBUG = 0;

my $cookies;
$cookies = HTMLObject::ReadCookie->new;

if (!exists $input{'command'})
{
  my_die("Error: Report.cgi - command missing", 4003, "Access Denied!");
}
else
{
  my $dbh;  # the handle of the database.
  # connect to the database.  The AutoCommit option will force transactions to be used.
  $dbh = DBI->connect($dsn, $db_user, $db_passwd, { RaiseError => 0, AutoCommit => 0 }) || my_db_die("DBI Error", 4004, "Database: $db_name\@$db_host");

  # force the database session to use Postgres/US convention date styles
  my $sth = $dbh->prepare( $sql_statements{1067} ) || my_db_die("Error: Report.cgi", 4007, "SQL Statement = '$sql_statements{1067}'");
  my $rc = $sth->execute() || my_db_die("Error: Report.cgi", 4008, "SQL Statement = '$sql_statements{1067}'");

  my $command = $input{'command'};
  if ($command eq "run_report_top")
  {
    eval ("use HTMLObject::Normal;");
    if ($@)
    {
      my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
    }

    my $doc = HTMLObject::Normal->new();

    $doc->setJavascriptErrorHandlerEmail(email => $email_address);

    use vars qw( $id $file_name $report_type );

    my @arguments = ( "id", "file_name", "report_type" );

    no strict 'refs';  # turn off the use of strict for symbolic references.

    foreach my $value (@arguments)
    {
      if (!exists $input{$value})
      { # error!
        $doc->doRequiredParameterError('run_report_top', $value);
      }
      if (length $input{$value} == 0)
      {
        my_die("Error: Report.cgi - run_report_top", 4005, "Parameter = '$value'");
      }
      elsif (!validateParameter($value, $input{$value}))
      {
        my_die("Error: Report.cgi - run_report_top", 4006, "$value = '$input{$value}'");
      }
      $$value = $input{$value};  # assign the value to this variable via a symbolic reference :).
    }

    use strict 'refs';  # turn strict checking back on.

    # gather the stored data from disk.
    # verify it exists still
    if (! -e $file_name)
    {
      my_die("Error:  Report.cgi - run_report_top", 4018, "Data File = '$file_name' does not exist!<br>\nClose this window and rerun the report in question.");
    }

    if ($report_type eq "r")
    {
      display_regular_report_top( dbh => $dbh, file_name => $file_name );
    }
    else
    {
      display_detailed_report_top( dbh => $dbh, file_name => $file_name );
    }
  }
  elsif ($command eq "run_report_bottom")
  {
    eval ("use HTMLObject::Normal;");
    if ($@)
    {
      my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
    }

    my $doc = HTMLObject::Normal->new();

    $doc->setJavascriptErrorHandlerEmail(email => $email_address);

    use vars qw( $report_type $file_name );

    my @arguments = ( "report_type", "file_name" );

    no strict 'refs';  # turn off the use of strict for symbolic references.

    foreach my $value (@arguments)
    {
      if (!exists $input{$value})
      { # error!
        $doc->doRequiredParameterError('run_report_top', $value);
      }
      if (length $input{$value} == 0)
      {
        my_die("Error: Report.cgi - run_report_top", 4005, "Parameter = '$value'");
      }
      elsif (!validateParameter($value, $input{$value}))
      {
        my_die("Error: Report.cgi - run_report_top", 4006, "$value = '$input{$value}'");
      }
      $$value = $input{$value};  # assign the value to this variable via a symbolic reference :).
    }

    use strict 'refs';  # turn strict checking back on.

    # verify the data file still exists
    if (! -e $file_name)
    {
      my_die("Error:  Report.cgi - run_report_bottom", 4018, "Data File = '$file_name' does not exist!<br>\nClose this window and rerun the report in question.");
    }

    if ($report_type eq "r")
    {
      display_regular_report( dbh => $dbh, file_name => $file_name, report_type => $report_type );
    }
    else
    {
      display_detailed_report( dbh => $dbh, file_name => $file_name, report_type => $report_type );
    }
  }
  else
  {
    my_die("Error: Report.cgi - Invalid command", 4001, "'$command' is invalid!");
  }

LEAVE_PROGRAM_EARLY:
  # disconnect from the database (if under mod_perl this will actually never happen. :)  )
  $dbh->disconnect || my_db_die ("DBI Error on Disconnect", 4009, "Database: $db_name\@$db_host");
}
exit;  # leave the program.

#****************************** Helper functions *****************************

# takes Title, Error Code, Custom Message
sub my_die
{
  my ($title, $code, $message) = @_;

  # close the database connection.
  #if (defined $dbh)
  #{
  #  $dbh->disconnect;
  #}

  my $doc = HTMLObject::Base->new();
  $doc->setErrorMessage(code => $code, message => $errors{$code});
  $doc->setError(code => $code);
  $doc->displayError(title => $title, message => "$message");
}

# takes Title, Error Code, Custom Message
sub my_db_die
{
  my ($title, $code, $message) = @_;
  my $error_str = $DBI::errstr;

  # close the database connection.
  #if (defined $dbh)
  #{
  #  $dbh->disconnect;
  #}

  my $doc = HTMLObject::Base->new();
  $doc->setErrorMessage(code => $code, message => $errors{$code});
  $doc->setError(code => $code);
  $doc->displayError(title => $title, message => "$message<br><br>\n$error_str");
}

###################### Data Gathering Functions converted from reports.pm to DBI structure #############################

# massage_data
# takes  : precision (defaults to 1), value
# returns: value (massaged into the specified precision).
sub massage_data
{
  my %arguments = ( precision => 1, @_, );
  my $precision = $arguments{'precision'};
  my $value = $arguments{'value'};

  if (length $value == 0)
  {
    # default to returning a zero value
    $value = 0.00;
  }

  if ($precision == 1)
  {
    $value = sprintf "%.2f", $value;
  }
  elsif ($precision < 0)
  {  # handle the special case where the user wants X number of decimal points other than 2.
    $precision =~ s/^-//;  # remove the -.
    $value = sprintf "%.*f", $precision, $value;
  }
  else
  {
    $value /= $precision;  # do the precision modification
    $value = sprintf "%.0f", $value;  # do any rounding needed
    $value = int($value);  # cast it to a whole number
  }

  return $value;
}

sub validateParameter
{
  # this function takes the name of the parameter and it's value and does the work of making sure that the value is valid for that parameter.
  my ($name, $value) = ( @_ );
  my $result = 1;

  if (length $name == 0)
  {
    $result = 0;
  }
  if (length $value == 0)
  {
    $result = 0;
  }

  if ($name eq "mode")
  {
    if ($value ne "edit" && $value ne "create")
    {
      $result = 0;
    }
  }
  elsif ($name eq "name")
  {
  }
  elsif ($name eq "original_name")
  {
  }
  elsif ($name eq "id")
  {
    if ($value < -1)
    {
      $result = 0;
    }
  }
  elsif ($name eq "report_class")
  {
    if (!exists $report_classes{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "report_type")
  {
    if ($value ne "r" && $value ne "d")
    {
      $result = 0;
    }
  }
  elsif ($name eq "column_variable")
  {
  }
  elsif ($name eq "column_variable_data")
  {
  }
  elsif ($name eq "date_range")
  {
    if ($value ne "true" && $value ne "false")
    {
      $result = 0;
    }
  }
  elsif ($name eq "display_dates")
  {
    if ($value ne "true" && $value ne "false")
    {
      $result = 0;
    }
  }
  elsif ($name eq "max_columns")
  {
    if ($value <= 0 || $value > $max_dates)
    {
      $result = 0;
    }
  }
  elsif ($name eq "min_columns")
  {
    if ($value <= 0 || $value > $max_dates)
    {
      $result = 0;
    }
  }
  elsif ($name eq "text_size")
  {
    if (!exists $font_sizes{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "text_font")
  {
    if (!exists $font_names{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "data_size")
  {
    if (!exists $font_sizes{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "data_font")
  {
    if (!exists $font_names{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "total_column")
  {
    if ($value ne "true" && $value ne "false")
    {
      $result = 0;
    }
  }
  elsif ($name eq "fg_color")
  {
    if (!exists $fg_colors{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "bg_color")
  {
    if (!exists $bg_colors{$value})
    {
      $result = 0;
    }
  }
  elsif ($name eq "underline_length")
  {
    if ($value < $min_underline_length || $value > $max_underline_length)
    {
      $result = 0;
    }
  }
  elsif ($name eq "dbh")
  {
  }
  elsif ($name eq "error_string")
  {
  }
  elsif ($name eq "rows")
  {
    my @rows = split /\n/, $value;
    if (scalar @rows == 0)
    {
      $result = 0;
    }
  }
  elsif ($name eq "file_name")
  {
  }
  elsif ($name eq "report_group")
  {
    if ($value ne "regular" && $value ne "detailed" && $value ne "memorized")
    {
      $result = 0;
    }
  }
  elsif ($name eq "new_report_name")
  {
  }
  elsif ($name eq "windowName")
  {
    $result = 0 if ($value !~ /^(edit_report_window)$/);
  }
  else
  {
    $result = 0;  # signal that an error occurred as we do not know anything about this variable.
  }

  return $result;
}

# display_regular_report_top
# takes  : dbh, filename
# returns: nothing
sub display_regular_report_top
{
  my %args = ( @_, );
  my $dbh = $args{'dbh'};
  my $file_name = $args{'file_name'};
  my $count;
  my $args_ref;
  my @data = ();

  if (length $dbh == 0)
  {
    my_die("Error: Report.cgi - display_regular_report_top", 4028, "The DB Handle is required at line " . __LINE__);
  }

  if (length $file_name == 0)
  {
    my_die("Error: Report.cgi - display_regular_report_top", 4035, "The filename is required at line " . __LINE__);
  }

  $args_ref = retrieve($file_name);
  %args = %{@{$args_ref}[0]};
  @data = @{@{$args_ref}[1]};
  my $id = $args{'id'};
  my $ledger = $args{'ledger'};
  my $max_display_level = $args{'max_display_level'};

  eval ("use HTMLObject::Normal;");
  if ($@)
  {
    my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
  }

  my $doc = HTMLObject::Normal->new();

  $doc->setJavascriptErrorHandlerEmail(email => $email_address);

  $doc->setFocus("body");
  $doc->setLinkDecorations();

  # set the overall font size to be smaller
  $doc->setStyleEntry(tag => "body", string => "font-size: smaller;");

  $doc->print(<<"END_OF_BODY");
  <center>
  <form method="post" name="run_form" action="$site_dir/cgi-bin/report_display.cgi" target="_top">
  <table border=1 width="90%" cellspacing=0 cellpadding=2 bgcolor="$menu_fgcolor">
    <tr>
      <td align="center"><a href="javascript: customize_report();">Customize</a> | <a href="javascript: display_report();">Re-display</a> | <a href="javascript: print_report();">Print</a> | <a href="javascript: reset_report();">Reset</a> | <a href="javascript: rerun_report();">Re-run</a> |
      <a href="javascript: expand_levels();">Show&nbsp;Level(s)</a>&nbsp;<select name="levels_select" onChange="expand_levels();">
        <option value="-1">All
        <option value="-2">Smart
END_OF_BODY
  for ($count=0; $count < $max_display_level + 1; $count++)
  {
    $doc->print("        <option value=\"$count\">$column_names{($count + 1)}\n");
  }
  $doc->print(<<"END_OF_BODY");
      </select> | <a href="javascript: memorize_report();">Memorize</a> | <a href="javascript: export_report();">Export</a>
      </td>
    </tr>
  </table>
  </form>
  </center>
END_OF_BODY

  my $onload_code = <<"END_OF_ONLOAD";
    var bottomWindowName = window.parent.name;  // get the frameset window name that opened this frame
    bottomWindowName += "_bottom";  // add "_bottom" to the window name
    bottom_win_ref = window.open("", bottomWindowName);
END_OF_ONLOAD

  my $onunload_code = <<"END_OF_ONUNLOAD";
    if (typeof customize_win_ref != "undefined" && customize_win_ref.closed == false)
    {
      customize_win_ref.close();
    }
END_OF_ONUNLOAD

  $doc->setOnload(code => $onload_code);
  $doc->setOnunload(code => $onunload_code);

  my $dates_entered = join ("|", @{$args{'dates_entered'}});

  $doc->setFocus("javascript");
  $doc->print(<<"END_OF_SCRIPT");

  var customize_win_ref;
  var bottom_win_ref;

  function reset_report()
  {
    var f = bottom_win_ref.document.run_form;
    var customize_window_open = false;

    // close the customization window if it is open
    if (typeof customize_win_ref != "undefined" && customize_win_ref.closed == false)
    {
      customize_window_open = true;
      customize_win_ref.close();
    }

    // reset the form values to their defaults
    f.account_format.value = "$args{'account_format'}";
    f.negative_format.value = "$args{'negative_format'}";
    f.fg_color.value = "$args{'fg_color'}";
    f.bg_color.value = "$args{'bg_color'}";
    f.text_font.value = "$args{'text_font'}";
    f.text_size.value = "$args{'text_size'}";
    f.data_font.value = "$args{'data_font'}";
    f.data_size.value = "$args{'data_size'}";
    f.total_column.value = "$args{'total_column'}";
    f.underline_length.value = "$args{'underline_length'}";
    f.border.value = "$args{'border'}";
    f.report_name.value = "$args{'report_name'}";
    f.reportWidth.value = "$args{reportWidth}";
    f.displayZeroRows.value = "$args{displayZeroRows}";

    // re-open the customization window if it was open
    if (customize_window_open == true)
    {
      customize_report();
    }

    // re-display the report
    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.report_command.value = "reset";
    f.command.value = "run_report_bottom";
    f.submit();
  }

  function rerun_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_customization.cgi";
    f.target = "_top";
    f.command.value = "run_report";
    f.submit();
  }

  function memorize_report()
  {
    var f = bottom_win_ref.document.run_form;
    // open the report window using the name of the window with "_memorize" tacked onto it so it associates the window with
    // the current report window to allow for multiple report windows to be open at the same time
    var top_window_name = window.parent.name;  // get the frameset window name that opened this frame
    top_window_name += "_memorize";  // add "_memorize" to the window name
    // open the memorization window
    memorize_win_ref = window.open("", top_window_name, "height=200,width=500,scrollbars", true);

    var bodyString = '<html>\\n';
    bodyString += '  <head>\\n';
    bodyString += '    <title>Memorize Report - '+f.report_name.value+'</title>\\n';
    bodyString += '  </head>\\n';
    bodyString += '  <body bgcolor=\\"white\\">\\n';
    bodyString += '  <center>\\n';
    bodyString += '  <form name=\\"memorize_form\\" action=\\"$site_dir/cgi-bin/report_customization.cgi\\">\\n';
    bodyString += '    <input type=hidden name=\\"command\\" value=\\"memorize_report\\">\\n';
    bodyString += '    <input type=hidden name=\\"id\\" value=\\"$id\\">\\n';
    bodyString += '    <input type=hidden name=\\"ledger\\" value=\\"$ledger\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_precision\\" value=\\"$args{'data_precision'}\\">\\n';
    bodyString += '    <input type=hidden name=\\"column_type\\" value=\\"$args{'column_type'}\\">\\n';
    bodyString += '    <input type=hidden name=\\"column_data\\" value=\\"$args{'column_data'}\\">\\n';
    bodyString += '    <input type=hidden name=\\"column_variable\\" value=\\"$args{'column_variable'}\\">\\n';
    bodyString += '    <input type=hidden name=\\"column_variable_data\\" value=\\"$args{'column_variable_data'}\\">\\n';
    bodyString += '    <input type=hidden name=\\"dates_entered\\" value=\\"$dates_entered\\">\\n';
    bodyString += '    <input type=hidden name=\\"account_format\\" value=\\"'+f.account_format.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"negative_format\\" value=\\"'+f.negative_format.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"fg_color\\" value=\\"'+f.fg_color.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"bg_color\\" value=\\"'+f.bg_color.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"text_font\\" value=\\"'+f.text_font.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"text_size\\" value=\\"'+f.text_size.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_font\\" value=\\"'+f.data_font.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_size\\" value=\\"'+f.data_size.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"total_column\\" value=\\"'+f.total_column.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"underline_length\\" value =\\"'+f.underline_length.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"report_type\\" value=\\"r\\">\\n';
    bodyString += '    <input type=hidden name=\\"report_class\\" value=\\"r\\">\\n';
    bodyString += '    <input type=hidden name=\\"file_name\\" value=\\"$file_name\\">\\n';
    bodyString += '    <input type=hidden name=\\"reportWidth\\" value=\\"'+f.reportWidth.value+'\\">\\n';
    bodyString += '  <h2>Memorize Report</h2>\\n';
    bodyString += '  <table width=\\"90%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color="$menu_fgcolor">Report&nbsp;Name:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><input type=text name="report_name" value="'+f.report_name.value+'" size="30"></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '  </table>\\n';
    bodyString += '  <input type=submit name=\\"memorize\\" value=\\"Memorize\\">&nbsp;<input type=reset value=\\"Reset\\">\\n';
    bodyString += '  </form>\\n';
    bodyString += '  </center>\\n';
    bodyString += '  </body>\\n';
    bodyString += '</html>';

    memorize_win_ref.document.open();
    memorize_win_ref.document.writeln(bodyString);
    memorize_win_ref.document.close();
  }

  function customize_report()
  {
    var f = bottom_win_ref.document.run_form;
    // open the report window using the name of the window with "_configure" tacked onto it so it associates the window with
    // the current report window to allow for multiple report windows to be open at the same time
    var top_window_name = window.parent.name;  // get the frameset window name that opened this frame
    top_window_name += "_configure";  // add "_configure" to the window name
    // open the customization window
    customize_win_ref = window.open("", top_window_name, "height=450,width=500,resizable,scrollbars", true);

    var bodyString = '<html>\\n';
    bodyString += '  <head>\\n';
    bodyString += '    <title>Customize Report - ' + f.report_name.value + '</title>\\n';
    bodyString += '  </head>\\n';
    bodyString += '  <body bgcolor=\\"white\\">\\n';
    bodyString += '  <center>\\n';
    bodyString += '  <form name=\\"customize_form\\" onSubmit=\\"return false;\\">\\n';
    bodyString += '  <h2>Customize Report</h2>\\n';
    bodyString += '  <table width=\\"90%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color="$menu_fgcolor">Report&nbsp;Name:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><input type=text name="report_name" value="' + f.report_name.value + '" size="30" onChange=\\"window.opener.report_name_change(this);\\"></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Show&nbsp;Accounts&nbsp;as:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><select name=\\"account_format\\" onChange=\\"window.opener.account_format_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @account_formats; $count++)
  {
    $doc->print("    bodyString += '          <option value=\\\"$account_formats[$count]\\\"';\n");
    $doc->print("    if (f.account_format.value == \"$account_formats[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$account_formats{$account_formats[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '      </select></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th colspan=2><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Negative&nbsp;Value&nbsp;Format:</font></font></th>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2 align=center>\\n';
    bodyString += '        <table width=\\"70%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_fgcolor\\">\\n';
    bodyString += '          <tr>\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '            <td><font size=\\\"-1\\\"><input type=radio name=\\\"negative_format\\\" value=\\\"-1\\\" onClick=\\\"window.opener.negative_format_click(this);\\\"';\n");
  $doc->print("    if (f.negative_format.value == \"-1\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' checked';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default</font></td>\\n';\n");
  for ($count=0; $count < scalar @negative_formats; $count++)
  {
    $doc->print("    bodyString += '            <td><font size=\\\"-1\\\"><input type=radio name=\\\"negative_format\\\" value=\\\"$negative_formats[$count]\\\" onClick=\\\"window.opener.negative_format_click(this);\\\"';\n");
    $doc->print("    if (f.negative_format.value == \"$negative_formats[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' checked';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>&nbsp;$negative_formats{$negative_formats[$count]}</font></td>\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '        <table border=0 width=\\"100%\\" cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Foreground&nbsp;Color:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"fg_color\\" onChange=\\"window.opener.fg_color_change(this);\\">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '                <option value=\\\"default\\\"';\n");
  $doc->print("    if (f.fg_color.value == \"default\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default\\n';\n");
  for ($count=0; $count < scalar @fg_colors; $count++)
  {
    $doc->print("    bodyString += '                <option value=\\\"$fg_colors[$count]\\\"';\n");
    $doc->print("    if (f.fg_color.value == \"$fg_colors[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$fg_colors{$fg_colors[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Background&nbsp;Color:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"bg_color\\" onChange=\\"window.opener.bg_color_change(this);\\">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '                <option value=\\\"default\\\"';\n");
  $doc->print("    if (f.bg_color.value == \"default\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default\\n';\n");
  for ($count=0; $count < scalar @bg_colors; $count++)
  {
    $doc->print("    bodyString += '                <option value=\\\"$bg_colors[$count]\\\"';\n");
    $doc->print("    if (f.bg_color.value == \"$bg_colors[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$bg_colors{$bg_colors[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '        <table width=\\"100%\\" border=0 cellspacing=0 cellpadding=2>\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Text&nbsp;Font:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"text_font\\" onChange=\\"window.opener.text_font_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_names; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_names[$count]\\\"';\n");
    $doc->print("    if (f.text_font.value == \"$font_names[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_names{$font_names[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Data&nbsp;Font:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"data_font\\" onChange=\\"window.opener.data_font_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_names; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_names[$count]\\\"';\n");
    $doc->print("    if (f.data_font.value == \"$font_names[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_names{$font_names[$count]}\\n';\n");
  }	
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Text&nbsp;Font&nbsp;Size:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"text_size\\" onChange=\\"window.opener.text_size_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_sizes; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_sizes[$count]\\\"';\n");
    $doc->print("    if (f.text_size.value == \"$font_sizes[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_sizes{$font_sizes[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Data&nbsp;Font&nbsp;Size:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"data_size\\" onChange=\\"window.opener.data_size_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_sizes; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_sizes[$count]\\\"';\n");
    $doc->print("    if (f.data_size.value == \"$font_sizes[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_sizes{$font_sizes[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2><hr width=\\"95%\\"></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '      <table border=0 width=\\"100%\\" cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '      <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Total Column:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><select name=\\"total_column\\" onChange=\\"window.opener.total_column_change(this);\\">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '        <option value=\\\"$t_or_f{'0'}\\\"';\n");
  $doc->print("    if (f.total_column.value == \"false\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>No\\n';\n");
  $doc->print("    bodyString += '        <option value=\\\"$t_or_f{'1'}\\\"';\n");
  $doc->print("    if (f.total_column.value == \"true\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Yes\\n';\n");
  $doc->print("    bodyString += '      </select></font></td>\\n';\n");
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '      <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Underline Length:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><select name=\\"underline_length\\" onChange=\\"window.opener.underline_length_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=$min_underline_length; $count <= $max_underline_length; $count++)
  {
    $doc->print("    bodyString += '        <option value=\\\"$count\\\"';\n");
    $doc->print("    if (f.underline_length.value == $count)\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$column_names{$count}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '      </select></font></td>\\n';
    bodyString += '    </table>\\n';
    bodyString += '    </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2><hr width=\\"95%\\"></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td align=center><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Border:</font></font>';
    bodyString += ' <input type=checkbox onClick=\\"window.opener.border_change(this);\\"';
    if (f.border.value == 1)
    {
      bodyString += ' checked';
    }
    bodyString += '></td>\\n';
    bodyString += '      <td align=\\"center\\"><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Printed Report Width:</font></font>';
    bodyString += ' <input type=\\"text\\" name=\\"reportWidth\\" size=\\"3\\" maxlength=\\"3\\" value=\\"'+f.reportWidth.value+'\\" onChange=\\"window.opener.reportWidthChange(this);\\">%</td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td align=center><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Display Zero Rows? </font></font>';
    bodyString += ' <input type=checkbox onClick=\\"window.opener.displayZeroRows_change(this);\\"';
    if (f.displayZeroRows.value == 1)
    {
      bodyString += ' checked';
    }
    bodyString += '></td>\\n';
    bodyString += '      <td align=\\"center\\">&nbsp;</td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '  </table>\\n';
    bodyString += '  <input type=button value=\\"Re-display Report\\" onClick=\\"window.opener.display_report();\\">\\n';
    bodyString += '  <input type=button value=\\"Close\\" onClick=\\"window.close();\\">\\n';
    bodyString += '  </form>\\n';
    bodyString += '  </center>\\n';
    bodyString += '  </body>\\n';
    bodyString += '</html>';

    customize_win_ref.document.open();
    customize_win_ref.document.writeln(bodyString);
    customize_win_ref.document.close();
  }

  function display_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.report_command.value = "display";
    f.command.value = "run_report_bottom";
    f.pageTop.value = bottom_win_ref.pageYOffset;
    f.submit();
  }

  function report_name_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.report_name.value = element.value;
  }

  function account_format_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.account_format.value = element.options[element.selectedIndex].value;
  }

  function negative_format_click(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.negative_format.value = element.value;
  }

  function fg_color_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.fg_color.value = element.options[element.selectedIndex].value;
  }

  function bg_color_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.bg_color.value = element.options[element.selectedIndex].value;
  }

  function text_font_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.text_font.value = element.options[element.selectedIndex].value;
  }

  function data_font_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.data_font.value = element.options[element.selectedIndex].value;
  }

  function text_size_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.text_size.value = element.options[element.selectedIndex].value;
  }

  function data_size_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.data_size.value = element.options[element.selectedIndex].value;
  }

  function total_column_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.total_column.value = element.options[element.selectedIndex].value;
  }

  function underline_length_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.underline_length.value = element.options[element.selectedIndex].value;
  }

  function border_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    if (element.checked == true)
    {
      f.border.value = "1";
    }
    else
    {
      f.border.value = "0";
    }
  }

  function displayZeroRows_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    if (element.checked == true)
    {
      f.displayZeroRows.value = "1";
    }
    else
    {
      f.displayZeroRows.value = "0";
    }
  }

  function reportWidthChange(element)
  {
    var f = bottom_win_ref.document.run_form;

    if (element.value < 0 || element.value > 100)
    {
      alert('Printed Report Width = "'+element.value+'" is invalid!  Setting to 55.');
      element.value = 55;
    }
    f.reportWidth.value = element.value;
  }

  function expand_levels()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.report_command.value = "expand";
    f.command.value = "run_report_bottom";
    f.level.value = document.run_form.levels_select.options[document.run_form.levels_select.selectedIndex].value;
    f.submit();
  }

  function print_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.command.value = "run_report_bottom";
    f.report_command.value = "print";
    f.submit();
  }

  function export_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.command.value = "run_report_bottom";
    f.report_command.value = "export";
    f.submit();
  }

END_OF_SCRIPT

  $doc->display();
}

# bool areAllColumnsZero(row)
#
# returns 1 if all the columns in the row are "empty",
# else returns 0.
# will return 0 if the total is not 0.
sub areAllColumnsZero
{
  my $row = shift;
  
  # immediate bail out check.
  return 0 if ($row->{total} != 0);
  
  return $row->{allColumnsZero} if (exists $row->{allColumnsZero});
  
  my $nonEmptyRows = 0;
  my $emptyRows = 0;
  if (exists $row->{values})
  {
    for (my $column=0; $column < scalar @{$row->{values}}; $column++)
    {
      my $valueCol = $row->{values}[$column];
      for (my $column2=0; $column2 < scalar @{$valueCol}; $column2++)
      {
        $nonEmptyRows++ if ($valueCol->[$column2] != 0);
        $emptyRows++ if ($valueCol->[$column2] == 0);
      }  
    }
  }
  
  $row->{allColumnsZero} = 1 if ($nonEmptyRows == 0 && $emptyRows == 0);
  $row->{allColumnsZero} = 1 if ($nonEmptyRows == 0 && $emptyRows > 0);
  $row->{allColumnsZero} = 0 if ($nonEmptyRows > 0 && $emptyRows >= 0);
  $row->{allColumnsZero} = 1 if ($row->{total} == 0);  # catchall case.
  
  return $row->{allColumnsZero};
}

# bool updateRowVisibility(row, displayZeroRows, cellType)
# determines if the given row should be visible or not
# and any directly descendant sub-rows.
# if we return 1, then continue processing,
# if we return 0, then you are not going to be seeing this row.
sub updateRowVisibility
{
  my $row = shift;
  my $displayZeroRows = shift;
  my $cellType = shift;
  my $total = $row->{'total'};

  if (!$displayZeroRows && $total == 0 && $cellType =~ /$tripleAccountsRE/)
  {
    # only set the row hidden, if all the columns are = 0.
    my $allColumnsZero = areAllColumnsZero($row);
    if ($allColumnsZero)
    {
      $row->{visible} = "false";
      return 0;
    }
  }
  return 1;
}

# bool updateSubRowVisibility(subRow, displayZeroRows, cellType)
# determines if the given sub-row should be visible or not.
# if we return 1, then continue processing,
# if we return 0, then you are not going to be seeing this row.
sub updateSubRowVisibility
{
  my $subRow = shift;
  my $displayZeroRows = shift;
  my $cellType = shift;
  my $total = $subRow->{'total'};
  if (!$displayZeroRows && $total == 0 && $cellType =~ /$tripleAccountsRE/)
  {
    # only set the row hidden, if all the columns = 0.
    my $allColumnsZero = areAllColumnsZero($subRow);
    if ($allColumnsZero)
    {
      $subRow->{'visible'} = "false";
      return 0;
    }
  }
  $subRow->{'visible'} = "true";
  
  return 1;
}

# void expandRow(row, displayZeroRows, level, subRow, debugStr)
# expand the specified row and take into account the displayZeroRows value
# if the user specifies subRow (which is an anonymous array) then we only expand
# the specified subRow values.  format of subRow is [ subRow, subRow, subRow ]
# where each entry is the value to expand under the previous entry.
# ex. row = Acct Receivable, subRow = [ 1500 ] would expand just the AR subrow.
# row = Current Liabilities, subRow = [ 2100, 4456 ] would attempt to expand
#     the AP then HLR sub-rows.
# If subRow is empty, then we default to expand all subrows under the row we
# are working with.
sub expandRow
{
  my $row = shift;
  my $displayZeroRows = shift;
  my $level = shift;
  my $subRow = shift;
  my $debugStr = shift;

  my $depth = $row->{'display_level'};
  my $cellType = $row->{'cell_type'};
  my $total = $row->{'total'};

  #${$debugStr} .= "cellType = '$cellType', depth = '$depth', total = '$total', level = '$level', subRow = [" . join(",", @{$subRow}) . "]<br>\n";

  # always show the base level for the row; a defined row of the report will always be shown no matter what its level
  # unless it has been defined as an invisible row
  # level = -2 will implement the Smart opening code.
  if ($row->{'show'} eq "1")
  {
    $row->{'visible'} = "true";
  }
  else
  {
    $row->{'visible'} = "false";
  }
  if (!updateRowVisibility($row, $displayZeroRows, $cellType))
  {
    return;
  }
  if ($level =~ /^(-2|-3)$/)
  {
    my $allColumnsZero = areAllColumnsZero($row);
    if ($cellType =~ /$tripleAccountsRE/ && !$allColumnsZero)
    {
      if (defined $row->{'sub_rows'})
      {
        # make sure that we open this row, even though all the entries under it may
        # not be openable!
        $row->{'sub_rows_visible'} = "true";
      }
      else
      {
        $row->{'sub_rows_visible'} = "false";
      }
    }
  }
  elsif ($level =~ /^(-4)$/)
  {
    if ($cellType =~ /$tripleAccountsRE/ && $total == 0)
    {
      if (!$displayZeroRows)
      {
        $row->{visible} = "false";
      }
      return;
    }
  }
  if (defined $row->{'sub_rows'})
  {
    foreach my $subCount (keys %{$row->{'sub_rows'}})
    {
      if (scalar @{$subRow} == 0 || ($subRow->[0] eq $subCount))
      {
        #${$debugStr} .= "expandingSubRow = '$subCount'<br>\n";
        my $currSubRow = $row->{'sub_rows'}{$subCount};
        expandSubRow($row, $currSubRow, $displayZeroRows, $level, $depth + 1, $cellType, $total, $subRow, $debugStr);
      }
    }
    # reloop over and make sure the sub_rows_visible flag is correct.
    my $subRowVisible = "false";
    foreach my $subCount (keys %{$row->{'sub_rows'}})
    {
      if ($row->{'sub_rows'}{$subCount}{'visible'} eq "true")
      {
        $subRowVisible = "true";
      }
    }
    if ($subRowVisible eq "false")
    {
      $row->{'sub_rows_visible'} = "false";
    }
  }
}

# void expandSubRow(parentRow, currSubRow, displayZeroRows, level, depth, cellType, total, subRow, debugStr)
sub expandSubRow
{
  my $parentRow = shift;
  my $currSubRow = shift;
  my $displayZeroRows = shift;
  my $level = shift;
  my $depth = shift;
  my $cellType = shift;
  my $total = shift;
  my $subRow = shift;
  my $debugStr = shift;

  my $displayChildren = 0;

  #${$debugStr} .= "&nbsp;&nbsp;&nbsp;&nbsp;subrow: $currSubRow->{item_name}";
  #foreach my $name (keys %{$currSubRow})
  #{
  #  ${$debugStr} .= ", $name:$currSubRow->{$name}";
  #}
  #${$debugStr} .= "<br>\n";

  #${$debugStr} .= "&nbsp;&nbsp;&nbsp; depth = '$depth', level = '$level', subRow = [" . join(",", @{$subRow}) . "]<br>\n";

  if (!updateSubRowVisibility($currSubRow, $displayZeroRows, $cellType))
  {
    return;
  }

  if ($level =~ /$negativeOneRE/ || $level >= $depth)
  {
    $parentRow->{'sub_rows_visible'} = "true";
    $currSubRow->{'visible'} = "true";
  }
  elsif ($level eq "-2")
  {
    if ($cellType =~ /$tripleAccountsRE/)
    {
      my $allColumnsZero = areAllColumnsZero($currSubRow);
      if (!$allColumnsZero)
      {
        if (defined $currSubRow->{'sub_rows'})
        {
          my $subTotal = $currSubRow->{'total'};
          my @items = keys %{$currSubRow->{'sub_rows'}};
          if ($subTotal != 0)
          {
            if (scalar @items > 1)
            {
              $parentRow->{'sub_rows_visible'} = "true";
              $currSubRow->{'visible'} = "true";
            }
            elsif (scalar @items == 1)
            {
              # if the sub account isn't -1, then open it.
              if ($items[0] ne "-1")
              {
                $parentRow->{'sub_rows_visible'} = "true";
                $currSubRow->{'visible'} = "true";
              }
              else
              {
                # make sure this sub_row is not opened.
                $currSubRow->{'sub_rows_visible'} = "false";
              }
            }
          }
          else
          {
            # make sure this sub_row is not opened.
            $currSubRow->{'sub_rows_visible'} = "false";
            if (!$displayZeroRows)
            {
              $currSubRow->{visible} = "false";
            }
          }
        }
        else
        {
          my $subTotal = $currSubRow->{'total'};
          my @items = keys %{$parentRow->{'sub_rows'}};
          if ($subTotal != 0)
          {
            if (scalar @items > 1)
            {
              $parentRow->{'sub_rows_visible'} = "true";
              $currSubRow->{'visible'} = "true";
              $displayChildren = 1;
            }
            elsif (scalar @items == 1)
            {
              # if the sub account isn't -1, then open it.
              if ($items[0] ne "-1")
              {
                $parentRow->{'sub_rows_visible'} = "true";
                $currSubRow->{'visible'} = "true";
                $displayChildren = 1;
              }
            }
          }
          else
          {
            if (!$displayZeroRows)
            {
              $currSubRow->{visible} = "false";
            }
          }
        }
      }
      else
      {
        # make sure it is closed.
        $currSubRow->{'sub_rows_visible'} = "false";
        if (!$displayZeroRows)
        {
          $currSubRow->{visible} = "false";
        }
      }
    }
    else
    {
      #$currSubRow->{'visible'} = "true";
    }
  }
  elsif ($level eq "-3")
  {
    $parentRow->{'sub_rows_visible'} = "true";
    $currSubRow->{visible} = "true";
    if (scalar @{$subRow} >= 1)
    {
      $currSubRow->{sub_rows_visible} = "true";
    }
    else
    {
      return;
    }
  }
  elsif ($level eq "-4")
  {
    if ($cellType =~ /$tripleAccountsRE/)
    {
      my $subTotal = $currSubRow->{'total'};
      if ($subTotal == 0)
      {
        if (!$displayZeroRows)
        {
          $currSubRow->{visible} = "false";
        }
        return;
      }
    }
  }
  else
  {
    # make sure the row is closed.
    if (scalar @{$subRow} == 0)
    {
      $parentRow->{'sub_rows_visible'} = "false";
      $currSubRow->{'visible'} = "false";
    }
    return;
  }
  if (defined $currSubRow->{'sub_rows'})
  {
    foreach my $subCount (keys %{$currSubRow->{'sub_rows'}})
    {
      if (scalar @{$subRow} <= 1 || ($subRow->[1] eq $subCount))
      {
        #${$debugStr} .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; expandingSubSubRow = '$subCount'<br>\n";
        my $nextSubRow = $currSubRow->{'sub_rows'}{$subCount};
        $displayChildren = expandSubSubRow($currSubRow, $nextSubRow, $displayZeroRows, $level, $depth + 1, $cellType, $total, $displayChildren, $subRow, $debugStr);
      }
    }
    # reloop over and make sure that the sub_rows_visible flag is correct.
    my $subRowSubRowVisible = "false";
    foreach my $subCount (keys %{$currSubRow->{'sub_rows'}})
    {
      if ($currSubRow->{'sub_rows'}{$subCount}{'visible'} eq "true")
      {
        $subRowSubRowVisible = "true";
      }
    }
    if ($subRowSubRowVisible eq "false")
    {
      $currSubRow->{'sub_rows_visible'} = "false";
    }
  }
}

# displayChildren expandSubSubRow(@data, row_count, displayZeroRows, level, depth, cellType, total, sub_depth1, sub_count1, sub_depth2, sub_count2, displayChildren, subRow, debugStr)
sub expandSubSubRow
{
  my $parentSubRow = shift;
  my $currSubRow = shift;
  my $displayZeroRows = shift;
  my $level = shift;
  my $depth = shift;
  my $cellType = shift;
  my $total = shift;
  my $displayChildren = shift;
  my $subRow = shift;
  my $debugStr = shift;

  #${$debugStr} .= "&nbsp;&nbsp;&nbsp;&nbsp;subrow: $currSubRow->{item_name}";
  #foreach my $name (keys %{$currSubRow})
  #{
  #  ${$debugStr} .= ", $name:$currSubRow->{$name}";
  #}
  #${$debugStr} .= "<br>\n";

  #${$debugStr} .= "&nbsp;&nbsp;&nbsp; depth = '$depth', level = '$level', subRow = [" . join(",", @{$subRow}) . "]<br>\n";

  if (!updateSubRowVisibility($currSubRow, $displayZeroRows, $cellType))
  {
    return $displayChildren;
  }

  my $subTotal = $currSubRow->{'total'};
  if ($level =~ /$negativeOneRE/ || $level >= $depth)
  {
    $parentSubRow->{'sub_rows_visible'} = "true";
    $currSubRow->{'visible'} = "true";
  }
  elsif ($level eq "-2")
  {
    if ($cellType =~ /$tripleAccountsRE/ && $total != 0)
    {
      if (defined $currSubRow->{'sub_rows'})
      {
        $subTotal = $currSubRow->{'total'};
        my @items = keys %{$currSubRow->{'sub_rows'}};
        if ($subTotal != 0)
        {
          if (scalar @items > 1)
          {
            $parentSubRow->{'sub_rows_visible'} = "true";
            $currSubRow->{'visible'} = "true";
            $displayChildren = 1;
          }
          elsif (scalar @items == 1)
          {
            # if the sub account isn't -1, then open it.
            if ($items[0] ne "-1")
            {
              $parentSubRow->{'sub_rows_visible'} = "true";
              $currSubRow->{'visible'} = "true";
              $displayChildren = 1;
            }
            else
            {
              # don't open this sub_row
              $currSubRow->{'sub_rows_visible'} = "false";
            }
          }
        }
        else
        {
          # make sure we don't display this entry
          $currSubRow->{'sub_rows_visible'} = "false";
        }
      }
      else
      {
        my @items = keys %{$parentSubRow->{'sub_rows'}};
        if ($total != 0)
        {
          if (scalar @items > 1)
          {
            $parentSubRow->{'sub_rows_visible'} = "true";
            $currSubRow->{'visible'} = "true";
            $displayChildren = 1;
          }
          elsif (scalar @items == 1)
          {
            # if the sub account isn't -1, then open it.
            if ($items[0] ne "-1")
            {
              $parentSubRow->{'sub_rows_visible'} = "true";
              $currSubRow->{'visible'} = "true";
              $displayChildren = 1;
            }
            else
            {
              $currSubRow->{'sub_rows_visible'} = "false";
            }
          }
        }
        else
        {
          $currSubRow->{'sub_rows_visible'} = "false";
          $currSubRow->{'visible'} = "false";
        }
      }
    }
  }
  elsif ($level eq "-3")
  {
    $parentSubRow->{sub_rows_visible} = "true";
    $currSubRow->{visible} = "true";
    if (scalar @{$subRow} >= 2)
    {
      $currSubRow->{sub_rows_visible} = "true";
    }
    else
    {
      return $displayChildren;
    }
  }
  elsif ($level eq "-4")
  {
    if ($cellType =~ /$tripleAccountsRE/)
    {
      my $subTotal = $currSubRow->{'total'};
      if ($subTotal == 0)
      {
        if (!$displayZeroRows)
        {
          $currSubRow->{visible} = "false";
        }
        return $displayChildren;
      }
    }
  }
  else
  {
    # make sure the sub-row is closed
    if (scalar @{$subRow} == 0)
    {
      $parentSubRow->{'sub_rows_visible'} = "false";
      $currSubRow->{'visible'} = "false";
    }
    return $displayChildren;
  }
  if (defined $currSubRow->{'sub_rows'})
  {
    foreach my $subCount (keys %{$currSubRow->{'sub_rows'}})
    {
      if (scalar @{$subRow} <= 2 || ($subRow->[2] eq $subCount))
      {
        #${$debugStr} .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; expandingSubSubSubRow = '$subCount'<br>\n";
        my $nextSubRow = $currSubRow->{'sub_rows'}{$subCount};
        $displayChildren = expandSubSubSubRow($currSubRow, $nextSubRow, $displayZeroRows, $level, $depth + 1, $cellType, $displayChildren, $debugStr);
      }
    }
    # reloop over and make sure the sub_rows_visible flag is correct.
    my $subRowSubRowSubRowVisible = "false";
    foreach my $subCount (keys %{$currSubRow->{'sub_rows'}})
    {
      if ($currSubRow->{'sub_rows'}{$subCount}{'visible'} eq "true")
      {
        $subRowSubRowSubRowVisible = "true";
      }
    }
    if ($subRowSubRowSubRowVisible eq "false")
    {
      $currSubRow->{'sub_rows_visible'} = "false";
    }
  }

  return $displayChildren;
}

# void expandSubSubSubRow(parentSubRow, currSubRow, displayZeroRows, level, depth, cellType, displayChildren)
sub expandSubSubSubRow
{
  my $parentSubRow = shift;
  my $currSubRow = shift;
  my $displayZeroRows = shift;
  my $level = shift;
  my $depth = shift;
  my $cellType = shift;
  my $displayChildren = shift;
  my $debugStr = shift;

  if (!updateSubRowVisibility($currSubRow, $displayZeroRows, $cellType))
  {
    return;
  }

  if ($level =~ /^(-1|-3|-4)$/ || $level >= $depth)
  {
    $parentSubRow->{'sub_rows_visible'} = "true";
    $currSubRow->{'visible'} = "true";
  }
  elsif ($level eq "-2")
  {
    if ($displayChildren)
    {
      $parentSubRow->{'sub_rows_visible'} = "true";
      $currSubRow->{'visible'} = "true";
    }
    else
    {
      $currSubRow->{'visible'} = "false";
    }
  }
  else
  {
    #${$debugStr} .= "sub-sub-row: $currSubRow->{item_name}, depth = '$depth', level = '$level' reached!<br>\n";
    # make sure the sub-sub-row is closed
    $parentSubRow->{'sub_rows_visible'} = "false";
    $currSubRow->{'visible'} = "false";
  }
}

# display_regular_report
# takes  : dbh, filename
# returns: nothing
sub display_regular_report
{
  my %args = ( @_, );
  my $dbh = $args{'dbh'};
  my $file_name = $args{'file_name'};
  my $report_type = $args{'report_type'};
  my $args_ref;
  my @data = ();
  my @store_data = ();
  my $debugStr = "";

  if (length $dbh == 0)
  {
    my_die("Error: Report.cgi - display_regular_report", 4028, "The DB Handle is required at line " . __LINE__);
  }

  if (length $file_name == 0)
  {
    my_die("Error: Report.cgi - display_regular_report", 4035, "The filename is required at line " . __LINE__);
  }

  if (length $report_type == 0)
  {
    my_die("Error: Report.cgi - display_regular_report", 4036, "The report type is required at line " . __LINE__);
  }

  $args_ref = retrieve($file_name);
  %args = %{@{$args_ref}[0]};
  @data = @{@{$args_ref}[1]};
  my $elapsedTime = @{$args_ref}[2];
  my $id = $args{'id'};
  my $ledger = $args{'ledger'};

  # set to store original settings before any modifications to them take place
  $store_data[0] = { %args };
  $store_data[2] = $elapsedTime;

  # update our displayZeroRows flag.
  $args{displayZeroRows} = (exists $input{displayZeroRows} ? $input{displayZeroRows} : $args{displayZeroRows});

  if (exists $input{'report_command'} && $input{'report_command'} !~ /^(print|export)$/)
  {
    my $level = $input{'level'};
    my $row = $input{'row'};
    (my $sub_row1, my $sub_row2, my $sub_row3) = split /\|/, $input{'sub_row'}, 3;

    if ($input{'report_command'} eq "open")
    {
      if ($sub_row1 == -1)
      {
        if (defined $data[$row])
        {
          expandRow($data[$row], $args{displayZeroRows}, -3, [], \$debugStr);
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 eq "" && $sub_row3 eq "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1})
        {
          expandRow($data[$row], $args{displayZeroRows}, -3, [ $sub_row1 ], \$debugStr);
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 ne "" && $sub_row3 eq "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2})
        {
          expandRow($data[$row], $args{displayZeroRows}, -3, [ $sub_row1, $sub_row2 ], \$debugStr);
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 ne "" && $sub_row3 ne "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2}{'sub_rows'}{$sub_row3})
        {
          expandRow($data[$row], $args{displayZeroRows}, -3, [ $sub_row1, $sub_row2, $sub_row3 ], \$debugStr);
        }
      }
    }
    elsif ($input{'report_command'} eq "close")
    {
      if ($sub_row1 == -1)
      {
        if (defined $data[$row])
        {
          $data[$row]{'sub_rows_visible'} = "false";
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 eq "" && $sub_row3 eq "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1})
        {
          $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows_visible'} = "false";
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 ne "" && $sub_row3 eq "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2})
        {
          $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2}{'sub_rows_visible'} = "false";
        }
      }
      elsif ($sub_row1 ne "" && $sub_row2 ne "" && $sub_row3 ne "")
      {
        if (defined $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2}{'sub_rows'}{$sub_row3})
        {
          $data[$row]{'sub_rows'}{$sub_row1}{'sub_rows'}{$sub_row2}{'sub_rows'}{$sub_row3}{'sub_rows_visible'} = "false";
        }
      }
    }
    if ($input{'report_command'} eq "reset")
    {
      $level = "-4";
      for (my $rowCount=0; $rowCount < scalar @data; $rowCount++)
      {
        my $row = $data[$rowCount];
        # always show the base level for the row; a defined row of the report will always be shown no matter what its level
        # unless it has been defined as an invisible row
        if ($row->{'show'} eq "1")
        {
          $row->{'visible'} = "true";
        }
        else
        {
          $row->{'visible'} = "false";
        }
        if (defined $row->{'sub_rows'})
        {
          foreach my $subCount1 (keys %{$row->{'sub_rows'}})
          {
            my $subRow1 = $row->{sub_rows}{$subCount1};
            if ($subRow1->{'initial_state'} eq "o")
            {
              $row->{'sub_rows_visible'} = "true";
              $subRow1->{'visible'} = "true";
            }
            else
            {
              $row->{'sub_rows_visible'} = "false";
              $subRow1->{'visible'} = "false";
            }
            if (defined $subRow1->{'sub_rows'})
            {
              foreach my $subCount2 (keys %{$subRow1->{'sub_rows'}})
              {
                my $subRow2 = $subRow1->{sub_rows}{$subCount2};
                if ($subRow2->{'initial_state'} eq "o")
                {
                  $subRow1->{'sub_rows_visible'} = "true";
                  $subRow2->{'visible'} = "true";
                }
                else
                {
                  $subRow1->{'sub_rows_visible'} = "false";
                  $subRow2->{'visible'} = "false";
                }
                if (defined $subRow2->{'sub_rows'})
                {
                  foreach my $subCount3 (keys %{$subRow2->{'sub_rows'}})
                  {
                    my $subRow3 = $subRow2->{sub_rows}{$subCount3};
                    if ($subRow3->{'initial_state'} eq "o")
                    {
                      $subRow2->{'sub_rows_visible'} = "true";
                      $subRow3->{'visible'} = "true";
                    }
                    else
                    {
                      $subRow2->{'sub_rows_visible'} = "false";
                      $subRow3->{'visible'} = "false";
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    $level = "-4" if ($input{report_command} eq "display");
    if ($input{'report_command'} =~ /^(expand|display|reset)$/)
    {
      # if we are displaying and the user has specified !displayZeroRows then we need to toggle visibility.
      for (my $rowCount=0; $rowCount < scalar @data; $rowCount++)
      {
        my $row = $data[$rowCount];
        expandRow($row, $args{displayZeroRows}, $level, [], \$debugStr);
      }
    }
  }

  # store the (potentially) re-arranged data back to the same file; store before modifying original arguments but after
  # modifying opened and closed levels
  $store_data[1] = [ @data ];
  store(\@store_data, $file_name);

  my $max_display_level = $args{'max_display_level'};

  eval ("use HTMLObject::Normal;");
  if ($@)
  {
    my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
  }

  my $doc = HTMLObject::Normal->new();

  $doc->print("Debug Info:<br>\n${debugStr}") if (${debugStr});

  $doc->setJavascriptErrorHandlerEmail(email => $email_address);

  my @arguments = ( "report_name", "account_format", "negative_format", "default_fg_color", "default_bg_color", "fg_color", "bg_color", "data_font", "data_size", "text_font", "text_size", "total_column", "underline_length", "border", "pageTop", "reportWidth" );

  foreach my $value (@arguments)
  {
    if (exists $input{$value})
    {
      if (length $input{$value} == 0 && ($value ne "headers" && $value ne "sorted_by" && $value ne "sorted_order"))
      {
        my_die("Error: Report.cgi - display_detailed_report", 4005, "Parameter = '$value'");
      }
      if ($value eq "pageTop" && $input{$value} < 0)
      {
        $input{$value} = 0;
      }
      $args{$value} = $input{$value};  # override the arguments passed in with the values from the web page.
    }
    else
    {
      if ($value eq "pageTop")
      {
        $args{$value} = 0;
      }
    }
  }

  my $fgColor;
  my $bgColor;

  if ($args{'fg_color'} eq "default")
  {
    $fgColor = $args{'default_fg_color'};
  }
  else
  {
    $fgColor = $args{'fg_color'};
  }
  if ($args{'bg_color'} eq "default")
  {
    $bgColor = $args{'default_bg_color'};
  }
  else
  {
    $bgColor = $args{'bg_color'};
  }

  my $with_links = "true";
  if ($input{'report_command'} =~ /^(print|export)$/)
  {
    $with_links = "false";
  }
  
  my $withUnderlines = 1;
  if ($input{report_command} eq "export")
  {
    $withUnderlines = 0;
  }

  # display the ledger name and the current date
  my $current_date = `/bin/date +%m-%d-%Y`;
  chomp $current_date;

  $doc->setTitle("$args{'ledger_name'} - $args{'report_name'} - run on $current_date");

  $doc->setFocus("body");
  $doc->setLinkDecorations();

  my $tableWidth = $args{reportWidth};

  if ($with_links eq "true")  # only output the time if not printing
  {
    $doc->print("<font size=\"-1\">Report took <b>$elapsedTime</b> seconds to gather data...</font><br>\n");
    $tableWidth = "100";
  }

  $doc->print(<<"END_OF_BODY");
  <center>
  <form method=post name="run_form" action="$site_dir/cgi-bin/report_display.cgi" onSubmit="document.run_form.pageTop.value=window.pageYOffset; return true;">
  <input type=hidden name="command" value="run_report_bottom">
  <input type=hidden name="report_type" value="$report_type">
  <input type=hidden name="file_name" value="$file_name">
  <input type=hidden name="report_command" value="">
  <input type=hidden name="report_name" value="$args{'report_name'}">
  <input type=hidden name="account_format" value="$args{'account_format'}">
  <input type=hidden name="negative_format" value="$args{'negative_format'}">
  <input type=hidden name="fg_color" value="$args{'fg_color'}">
  <input type=hidden name="bg_color" value="$args{'bg_color'}">
  <input type=hidden name="text_font" value="$args{'text_font'}">
  <input type=hidden name="text_size" value="$args{'text_size'}">
  <input type=hidden name="data_font" value="$args{'data_font'}">
  <input type=hidden name="data_size" value="$args{'data_size'}">
  <input type=hidden name="total_column" value="$args{'total_column'}">
  <input type=hidden name="underline_length" value="$args{'underline_length'}">
  <input type=hidden name="border" value="$args{'border'}">
  <input type=hidden name="level" value="">
  <input type=hidden name="row" value="">
  <input type=hidden name="sub_row" value="">
  <input type=hidden name="pageTop" value="0">
  <input type="hidden" name="reportWidth" value="$args{reportWidth}">
  <input type="hidden" name="displayZeroRows" value="$args{displayZeroRows}">
  <table border="$args{'border'}" cellspacing=0 cellpadding=1 bgcolor="$bgColor" width="$tableWidth%">
    <tr>
END_OF_BODY
  my @column_data = split /,/, $args{'column_data'};
  my @column_data_names = split /\|/, $args{'column_data_names'};
  my %name_num;
  foreach my $name_value (@column_data_names)
  {
    (my $column_name, my $column_num) = split " - ", $name_value;
    $name_num{$column_num} = $column_name;
  }

  for (my $count=0; $count < scalar @column_data; $count++)
  {
    if ($column_data[$count] eq "<non_sub_entity>")
    {
      $column_data[$count] = "";
    }
  }

  my $colSpan = (($args{'total_column'} eq "true" ? 1 : 0) + (($max_display_level == -1 && $args{'column_type'} ne "nothing") ? 1 : $max_display_level + 1) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1))));
  $doc->print(<<"END_OF_BODY");
      <td colspan="$colSpan">
        <table border="0" cellspacing="0" cellpadding="0" bgcolor="$bgColor" width="100%">
          <tr>
            <td align="center" valign="top" width="100%"><font size="$args{'text_size'}" face="$args{'text_font'}" color="$fgColor"><b>$args{'report_name'}</b></font></td>
          </tr>
        </table>
      </td>
END_OF_BODY
  #$doc->print("      <td align=left valign=top><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"$fgColor\"><font color=\"$args{'ledger_color'}\">$args{'ledger_name'}</font></font></td>\n");
  #$doc->print("      <td align=right valign=top colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + (($max_display_level == -1 && $args{'column_type'} ne "nothing") ? 1 : $max_display_level + 1) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1))) - 1) . "><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"$fgColor\">$current_date</font></td>\n");
  #$doc->print("    </tr>\n");

  #$doc->print("    <tr>\n");
  #$doc->print("      <td align=center valign=top colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + (($max_display_level == -1 && $args{'column_type'} ne "nothing") ? 1 : $max_display_level + 1) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"$fgColor\"><b>$args{'report_name'}</b><br><br></font></td>\n");
  #$doc->print(<<"END_OF_BODY");
  #  </tr>
#END_OF_BODY
  if ($args{'data_precision'} > 1)
  {
    $doc->print("    <tr>\n");
    $doc->print("      <td align=right valign=top colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + (($max_display_level == -1 && $args{'column_type'} ne "nothing") ? 1 : $max_display_level + 1) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><font size=\"$args{'data_size'}\" face=\"$args{'data_font'}\" color=\"$fgColor\">(In <i>$precision_names{$args{'data_precision'}}</i>)</font></td>\n");
    $doc->print("    </tr>\n");
  }
  $doc->print(<<"END_OF_BODY");
    <tr>
    <tr>
      <td colspan="$colSpan">&nbsp;</td>
    </tr>
END_OF_BODY
  if (($max_display_level == -1 && $args{'column_type'} ne "nothing") || $max_display_level > -1)
  {
    $doc->print("      <td colspan=" . (($max_display_level + 1 == 0 && $args{'column_type'} eq "nothing") ? 1 : $max_display_level + 1) . "><br></td>\n");
  }
  for (my $header_count=0; $header_count < scalar @{$args{'dates_entered'}}; $header_count++)
  {
    (my $date1, my $date2) = split /,/, $args{'dates_entered'}[$header_count];
    $doc->print("      <td align=right valign=top");
    if (scalar @column_data > 0)
    {
      $doc->print(" colspan=" . (scalar @column_data));
    }
    $doc->print("><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"$fgColor\">$date1");
    if ($date2 ne "")
    {
      $doc->print(" to&nbsp;$date2");  # removed the <br> and replaced with &nbsp; also, the 'to' goes with the bottom date if it wraps
    }
    $doc->print("</font></td>\n");
  }
  if ($args{'total_column'} eq "true")
  {
    $doc->print("      <td align=center valign=top><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"$fgColor\"><b>Row&nbsp;Total</b></font></td>\n");
  }
  $doc->print(<<"END_OF_BODY");
    </tr>
END_OF_BODY
  if ($args{'column_type'} ne "nothing")
  {
    $doc->print("    <tr>\n");
    $doc->print("      <td align=right valign=top");
    if ($max_display_level > -1)
    {
      $doc->print(" colspan=" . ($max_display_level + 1));
    }
    $doc->print(" nowrap><font size=\"$args{'data_size'}\" face=\"$args{'data_font'}\" color=\"$fgColor\">$column_headers{$args{'column_type'}}:</font></td>\n");
    for (my $header_count=0; $header_count < scalar @{$args{'dates_entered'}}; $header_count++)
    {
      for (my $column_count=0; $column_count < scalar @column_data; $column_count++)
      {
        $name_num{$column_data[$column_count]} =~ s/\</\&lt\;/g;
        $name_num{$column_data[$column_count]} =~ s/\>/\&gt\;/g;
        $doc->print("      <td align=center valign=top><font size=\"$args{'data_size'}\" face=\"$args{'data_font'}\" color=\"$fgColor\">");
        my $hide_number = 0;
        if ($args{'column_type'} eq "sub_account_types")
        {
          $hide_number = 1;
        }
        $doc->print(format_account(hide_number => $hide_number, account_format => $args{'account_format'}, name => $name_num{$column_data[$column_count]}, code => $column_data[$column_count]));
        $doc->print("</font></td>\n");
      }
    }
    if ($args{'total_column'} eq "true")
    {
      $doc->print("      <td><br></td>\n");
    }
    $doc->print("    </tr>\n");
  }

  my $error_occurred = 0;

  for (my $row_count=0; $row_count < scalar @data; $row_count++)
  {
    my $row = $data[$row_count];
    my $row_fg_color;
    my $row_bg_color;
    my $text_font = $args{'text_font'};
    my $text_size = $args{'text_size'};
    my $data_font = $args{'data_font'};
    my $data_size = $args{'data_size'};
    my $cell_type = $row->{'cell_type'};
    my $negative_format;
    my $underline_length = $args{'underline_length'};
    my $account_format = $args{'account_format'};
    my $rowVisible = $row->{visible};
    my $rowBold = $row->{bold};
    my $rowDrillable = $row->{drillable};
    my $rowTotal = $row->{total};

    if ($args{'fg_color'} eq "default")
    {
      $row_fg_color = $row->{'fg_color'};
    }
    else
    {
      $row_fg_color = $args{'fg_color'};
    }

    if ($args{'bg_color'} eq "default")
    {
      $row_bg_color = $row->{'bg_color'};
    }
    else
    {
      $row_bg_color = $args{'bg_color'};
    }

    if ($args{'negative_format'} == -1)
    {
      $negative_format = $row->{'negative_format'};
    }
    else
    {
      $negative_format = $args{'negative_format'};
    }

    if ($cell_type eq "text")
    {
      if ($rowVisible eq "true")
      {
        $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
        $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . "><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
        for (my $skip_count=0; $skip_count < $row->{'display_level'}; $skip_count++)
        {
          $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
        }
        if ($rowBold eq "1")
        {
          $doc->print("<b>");
        }
        if ($row->{'cell_text'} ne "")
        {
          $doc->print("$row->{'cell_text'}");
        }
        else
        {
          $doc->print("&nbsp;");
        }
        if ($rowBold eq "1")
        {
          $doc->print("</b>");
        }
        $doc->print("</font></td>\n");
        $doc->print("      <td colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><br></td>\n");
        $doc->print("    </tr>\n");
      }
    }
    elsif ($cell_type eq "line")
    {
      if ($rowVisible eq "true")
      {
        $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
        $doc->print("      <td colspan=" . (($max_display_level + 1) + ($args{'total_column'} eq "true" ? 1 : 0) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
        for (my $skip_count=0; $skip_count < $row->{'display_level'}; $skip_count++)
        {
          $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
        }
        $doc->print("<hr noshade width=\"100%\"></font></td>\n");
        $doc->print("    </tr>\n");
      }
    }
    elsif ($cell_type eq "total" || $cell_type eq "compare")
    {
      if ($rowVisible eq "true")
      {
        $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
        $doc->print("      <td colspan=" . ($max_display_level + 1) . "><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
        for (my $skip_count=0; $skip_count < $row->{'display_level'}; $skip_count++)
        {
          $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
        }
        if ($rowBold eq "1")
        {
          $doc->print("<b>");
        }
        if ($row->{'cell_text'} ne "")
        {
          $doc->print("$row->{'cell_text'}");
        }
        else
        {
          $doc->print("&nbsp;");
        }
        if ($rowBold eq "1")
        {
          $doc->print("</b>");
        }
        $doc->print("</font></td>\n");
        for (my $value_count=0; $value_count < scalar @{$row->{'values'}}; $value_count++)
        {
          my $valueCol = $row->{values}[$value_count];
          for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
          {
            $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
            if ($rowBold eq "1")
            {
              $doc->print("<b>");
            }
            if ($valueCol->[$value_count2] < 0)
            {
              if ($row->{underline} == 1 && $withUnderlines)
              {
                $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
              }
              else
              {
                $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
              }
            }
            else
            {
              if ($cell_type eq "total")
              {
                if ($row->{underline} == 1 && $withUnderlines)
                {
                  $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
                else
                {
                  $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
              }
              else
              {
                if ($row->{result_type} eq "result_formula")
                {
                  if ($row->{underline} == 1 && $withUnderlines)
                  {
                    $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                  }
                  else
                  {
                    $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                  }
                }
                else
                {
                  $doc->print($valueCol->[$value_count2]);
                }
              }
            }
            if ($rowBold eq "1")
            {
              $doc->print("</b>");
            }
            #$doc->print("<br>\n" . $row->{'debug_formula'}[$value_count][$value_count2]);
            $doc->print("</font></td>\n");
          }
        }
        if ($args{'total_column'} eq "true")
        {
          $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
          if ($rowBold eq "1")
          {
            $doc->print("<b>");
          }
          if ($rowTotal < 0)
          {
            if ($row->{underline} == 1 && $withUnderlines)
            {
              $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
            }
            else
            {
              $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
            }
          }
          else
          {
            if ($cell_type eq "total")
            {
              if ($row->{underline} == 1 && $withUnderlines)
              {
                $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
              else
              {
                $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
            }
            else
            {
              if ($row->{result_type} eq "result_formula")
              {
                if ($row->{underline} == 1 && $withUnderlines)
                {
                  $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
                }
                else
                {
                  $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
                }
              }
              else
              {
                $doc->print("&nbsp;");
              }
            }
          }
          if ($rowBold eq "1")
          {
            $doc->print("</b>");
          }
          $doc->print("</font></td>\n");
        }
        $doc->print("    </tr>\n");
      }
    }
    else
    {
      sub sort_name_num
      {
        my %account_hash = %{ $_[0] };

        if ($account_format == 0 || $account_format == 2)
        {
          return $account_hash{$a}{'cell_text'} cmp $account_hash{$b}{'cell_text'};
        }
        elsif ($account_format == 1 || $account_format == 3)
        {
          return $a <=> $b;
        }
      }

      if (exists $row->{'error'} && $row->{'error'} == 1)
      {
        $error_occurred = 1;
      }

      if ($rowVisible eq "true")
      {
        $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
        $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
        for (my $skip_count=0; $skip_count < $row->{'display_level'}; $skip_count++)
        {
          $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
        }
        if (defined $row->{'sub_rows'} && $with_links eq "true")
        {
          my $open_close;
          if ($row->{'sub_rows_visible'} eq "true")
          {
            $open_close = "close";
          }
          else
          {
            $open_close = "open";
          }
          $doc->print("<a href=\"javascript: document.run_form.report_command.value = '$open_close'; document.run_form.row.value = '$row_count'; document.run_form.sub_row.value = '-1'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.pageTop.value=window.pageYOffset; document.run_form.submit();\"><img src=\"$site_dir/images/");
          if ($row->{'sub_rows_visible'} eq "true")
          {
            $doc->print("minus.gif\" alt=\"Collapse\"");
          }
          else
          {
            $doc->print("plus.gif\" alt =\"Expand\"");
          }
          $doc->print(" border=0></a>&nbsp;");
        }
        if ($rowBold eq "1")
        {
          $doc->print("<b>");
        }
        if ($cell_type =~ /$tripleBeginAccountsRE/)
        {
          $doc->print("Beginning Balance for:&nbsp;");
        }
        elsif ($cell_type =~ /$tripleEndAccountsRE/)
        {
          $doc->print("Ending Balance for:&nbsp;");
        }
        my $hide_number = 0;
        if (exists $hide_numbers{$cell_type}{'0'})
        {
          $hide_number = 1;
        }
        $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $row->{'cell_text'}, code => $row->{'item_name'}));
        if (exists $row->{'error'} && $row->{'error'} == 1)
        {
          $doc->print("<font color=\"red\"><sup>+</sup></font>");
        }
        if ($rowBold eq "1")
        {
          $doc->print("</b>");
        }
        $doc->print("</font></td>\n");

        # first sub-level sub_row
        if (defined $row->{'sub_rows'} && $row->{'sub_rows_visible'} eq "true")
        {
          $doc->print("      <td colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><br></td>\n");
          foreach my $sub_count1 (sort { sort_name_num($row->{'sub_rows'}) } keys %{$row->{'sub_rows'}})
          {
            my $subRow1 = $row->{sub_rows}{$sub_count1};
            next if ($subRow1->{visible} eq "false");
            $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
            $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
            for (my $skip_count=0; $skip_count < $subRow1->{'display_level'}; $skip_count++)
            {
              $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
            }
            if (defined $subRow1->{'sub_rows'} && $with_links eq "true")
            {
              my $open_close;
              if ($subRow1->{'sub_rows_visible'} eq "true")
              {
                $open_close = "close";
              }
              else
              {
                $open_close = "open";
              }
              $doc->print("<a href=\"javascript: document.run_form.report_command.value = '$open_close'; document.run_form.row.value = '$row_count'; document.run_form.sub_row.value = '$sub_count1'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.pageTop.value=window.pageYOffset; document.run_form.submit();\"><img src=\"$site_dir/images/");
              if ($subRow1->{'sub_rows_visible'} eq "true")
              {
                $doc->print("minus.gif\" alt=\"Collapse\"");
              }
              else
              {
                $doc->print("plus.gif\" alt =\"Expand\"");
              }
              $doc->print(" border=0></a>&nbsp;");
            }
            if ($rowBold eq "1")
            {
              $doc->print("<b>");
            }
            if ($cell_type =~ /$tripleBeginAccountsRE/)
            {
              $doc->print("Beginning Balance for:&nbsp;");
            }
            elsif ($cell_type =~ /$tripleEndAccountsRE/)
            {
              $doc->print("Ending Balance for:&nbsp;");
            }
            my $hide_number = 0;
            if (exists $hide_numbers{$cell_type}{'1'})
            {
              $hide_number = 1;
            }
            $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow1->{'cell_text'}, code => $subRow1->{'item_name'}));
            if ($rowBold eq "1")
            {
              $doc->print("</b>");
            }
            $doc->print("</font></td>\n");

            # second sub-level sub_row
            if (defined $subRow1->{'sub_rows'} && $subRow1->{'sub_rows_visible'} eq "true")
            {
              $doc->print("      <td colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><br></td>\n");
              foreach my $sub_count2 (sort { sort_name_num($subRow1->{'sub_rows'}) } keys %{$subRow1->{'sub_rows'}})
              {
                my $subRow2 = $subRow1->{'sub_rows'}{$sub_count2};
                next if ($subRow2->{visible} eq "false");
                $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
                $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
                for (my $skip_count=0; $skip_count < $subRow2->{'display_level'}; $skip_count++)
                {
                  $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
                }
                if (defined $subRow2->{'sub_rows'} && $with_links eq "true")
                {
                  my $open_close;
                  if ($subRow2->{'sub_rows_visible'} eq "true")
                  {
                    $open_close = "close";
                  }
                  else
                  {
                    $open_close = "open";
                  }
                  $doc->print("<a href=\"javascript: document.run_form.report_command.value = '$open_close'; document.run_form.row.value = '$row_count'; document.run_form.sub_row.value = '$sub_count1|$sub_count2'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.pageTop.value=window.pageYOffset; document.run_form.submit();\"><img src=\"$site_dir/images/");
                  if ($subRow2->{'sub_rows_visible'} eq "true")
                  {
                    $doc->print("minus.gif\" alt=\"Collapse\"");
                  }
                  else
                  {
                    $doc->print("plus.gif\" alt =\"Expand\"");
                  }
                  $doc->print(" border=0></a>&nbsp;");
                }
                if ($rowBold eq "1")
                {
                  $doc->print("<b>");
                }
                if ($cell_type =~ /$tripleBeginAccountsRE/)
                {
                  $doc->print("Beginning Balance for:&nbsp;");
                }
                elsif ($cell_type =~ /$tripleEndAccountsRE/)
                {
                  $doc->print("Ending Balance for:&nbsp;");
                }
                my $hide_number = 0;
                if (exists $hide_numbers{$cell_type}{'2'})
                {
                  $hide_number = 1;
                }
                $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow2->{'cell_text'}, code => $subRow2->{'item_name'}));
                if ($rowBold eq "1")
                {
                  $doc->print("</b>");
                }
                $doc->print("</font></td>\n");

                # third sub-level sub_row
                if (defined $subRow2->{'sub_rows'} && $subRow2->{'sub_rows_visible'} eq "true")
                {
                  $doc->print("      <td colspan=" . (($args{'total_column'} eq "true" ? 1 : 0) + ((scalar @{$args{'dates_entered'}}) * ((scalar @column_data > 0 ? scalar @column_data : 1)))) . "><br></td>\n");
                  foreach my $sub_count3 (sort { sort_name_num($subRow2->{'sub_rows'}) } keys %{$subRow2->{'sub_rows'}})
                  {
                    my $subRow3 = $subRow2->{sub_rows}{$sub_count3};
                    next if ($subRow3->{visible} eq "false");
                    $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
                    $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
                    for (my $skip_count=0; $skip_count < $subRow3->{'display_level'}; $skip_count++)
                    {
                      $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
                    }
                    if (defined $subRow3->{'sub_rows'} && $with_links eq "true")
                    {
                      my $open_close;
                      if ($subRow3->{'sub_rows_visible'} eq "true")
                      {
                        $open_close = "close";
                      }
                      else
                      {
                        $open_close = "open";
                      }
                      $doc->print("<a href=\"javascript: document.run_form.report_command.value = '$open_close'; document.run_form.row.value = '$row_count'; document.run_form.sub_row.value = '$sub_count1|$sub_count2|$sub_count3'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.pageTop.value=window.pageYOffset; document.run_form.submit();\"><img src=\"$site_dir/images/");
                      if ($subRow3->{'sub_rows_visible'} eq "true")
                      {
                        $doc->print("minus.gif\" alt=\"Collapse\"");
                      }
                      else
                      {
                        $doc->print("plus.gif\" alt =\"Expand\"");
                      }
                      $doc->print(" border=0></a>&nbsp;");
                    }
                    if ($rowBold eq "1")
                    {
                      $doc->print("<b>");
                    }
                    if ($cell_type =~ /$tripleBeginAccountsRE/)
                    {
                      $doc->print("Beginning Balance for:&nbsp;");
                    }
                    elsif ($cell_type =~ /$tripleEndAccountsRE/)
                    {
                      $doc->print("Ending Balance for:&nbsp;");
                    }
                    my $hide_number = 0;
                    if (exists $hide_numbers{$cell_type}{'3'})
                    {
                      $hide_number = 1;
                    }
                    $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow3->{'cell_text'}, code => $subRow3->{'item_name'}));
                    if ($rowBold eq "1")
                    {
                      $doc->print("</b>");
                    }
                    $doc->print("</font></td>\n");
                    for (my $value_count=0; $value_count < scalar @{$subRow3->{'values'}}; $value_count++)
                    {
                      my $valueCol = $subRow3->{values}[$value_count];
                      for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
                      {
                        $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow3->{'display_level'} * 1.5) . "em;\">");
                        if ($rowDrillable && $subRow3->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                        {
                          (my $tmp_sql_clause = $subRow3->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                          my $hide_number = 0;
                          if (exists $hide_numbers{$cell_type}{'3'})
                          {
                            $hide_number = 1;
                          }
                          $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow3->{'cell_text'}, code => $subRow3->{'item_name'})) . "');\">");
                        }
                        $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                        if ($rowBold eq "1")
                        {
                          $doc->print("<b>");
                        }
                        if ($valueCol->[$value_count2] < 0)
                        {
                          $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                        }
                        else
                        {
                          $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                        }
                        if ($rowBold eq "1")
                        {
                          $doc->print("</b>");
                        }
                        if (exists $subRow3->{'error'} && $subRow3->{'error'} == 1)
                        {
                          $doc->print("<font color=\"red\"><sup>*</sup></font>");
                        }
                        $doc->print("</font>");
                        if ($rowDrillable && $subRow3->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                        {
                          $doc->print("</a>");
                        }
                        $doc->print("</td>\n");
                      }
                    }
                    if ($args{'total_column'} eq "true")
                    {
                      $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow3->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                      if ($rowBold eq "1")
                      {
                        $doc->print("<b>");
                      }
                      if ($subRow3->{'total'} < 0)
                      {
                        $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow3->{'total'})))));
                      }
                      else
                      {
                        $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow3->{'total'})))));
                      }
                      if ($rowBold eq "1")
                      {
                        $doc->print("</b>");
                      }
                      $doc->print("</font></td>\n");
                    }
                    $doc->print("    </tr>\n");
                  }

                  $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
                  $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
                  for (my $skip_count=0; $skip_count < $subRow2->{'display_level'}; $skip_count++)
                  {
                    $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
                  }
                  if ($rowBold eq "1")
                  {
                    $doc->print("<b>");
                  }
                  if ($cell_type =~ /$tripleBeginAccountsRE/)
                  {
                    $doc->print("Beginning Balance for:&nbsp;");
                  }
                  elsif ($cell_type =~ /$tripleEndAccountsRE/)
                  {
                    $doc->print("Ending Balance for:&nbsp;");
                  }
                  my $hide_number = 0;
                  if (exists $hide_numbers{$cell_type}{'2'})
                  {
                    $hide_number = 1;
                  }
                  $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow2->{'cell_text'}, code => $subRow2->{'item_name'}));
                  if ($rowBold eq "1")
                  {
                    $doc->print("</b>");
                  }
                  $doc->print("&nbsp;Total:");
                  $doc->print("</font></td>\n");
                  for (my $value_count=0; $value_count < scalar @{$subRow2->{'values'}}; $value_count++)
                  {
                    my $valueCol = $subRow2->{values}[$value_count];
                    for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
                    {
                      $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow2->{'display_level'} * 1.5) . "em;\">");
                      if ($rowDrillable && $subRow2->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                      {
                        (my $tmp_sql_clause = $subRow2->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                        my $hide_number = 0;
                        if (exists $hide_numbers{$cell_type}{'2'})
                        {
                          $hide_number = 1;
                        }
                        $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow2->{'cell_text'}, code => $subRow2->{'item_name'})) . "');\">");
                      }
                      $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                      if ($rowBold eq "1")
                      {
                        $doc->print("<b>");
                      }
                      if ($valueCol->[$value_count2] < 0)
                      {  # putting this back to format_value
                        $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                      }
                      else
                      {  # putting this back to format_value
                        $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                      }
                      if ($rowBold eq "1")
                      {
                        $doc->print("</b>");
                      }
                      $doc->print("</font>");
                      if ($rowDrillable && $subRow2->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                      {
                        $doc->print("</a>");
                      }
                      $doc->print("</font></td>\n");
                    }
                  }
                  if ($args{'total_column'} eq "true")
                  {
                    $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow2->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                    if ($rowBold eq "1")
                    {
                      $doc->print("<b>");
                    }
                    if ($subRow2->{'total'} < 0)
                    {
                      $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow2->{'total'})))));
                    }
                    else
                    {
                      $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow2->{'total'})))));
                    }
                    if ($rowBold eq "1")
                    {
                      $doc->print("</b>");
                    }
                    $doc->print("</font></td>\n");
                  }
                  $doc->print("    </tr>\n");
                } # end third sub-level sub_row
                else
                {
                  for (my $value_count=0; $value_count < scalar @{$subRow2->{'values'}}; $value_count++)
                  {
                    my $valueCol = $subRow2->{values}[$value_count];
                    for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
                    {
                      $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow2->{'display_level'} * 1.5) . "em;\">");
                      if ($rowDrillable && $subRow2->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                      {
                        (my $tmp_sql_clause = $subRow2->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                        my $hide_number = 0;
                        if (exists $hide_numbers{$cell_type}{'2'})
                        {
                          $hide_number = 1;
                        }
                        $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow2->{'cell_text'}, code => $subRow2->{'item_name'})) . "');\">");
                      }
                      $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                      if ($rowBold eq "1")
                      {
                        $doc->print("<b>");
                      }
                      if ($valueCol->[$value_count2] < 0)
                      {
                        $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                      }
                      else
                      {
                        $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                      }
                      if ($rowBold eq "1")
                      {
                        $doc->print("</b>");
                      }
                      if (exists $subRow2->{'error'} && $subRow2->{'error'} == 1)
                      {
                        $doc->print("<font color=\"red\"><sup>*</sup></font>");
                      }
                      $doc->print("</font>");
                      if ($rowDrillable && $subRow2->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                      {
                        $doc->print("</a>");
                      }
                      $doc->print("</td>\n");
                    }
                  }
                  if ($args{'total_column'} eq "true")
                  {
                    $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow2->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                    if ($rowBold eq "1")
                    {
                      $doc->print("<b>");
                    }
                    if ($subRow2->{'total'} < 0)
                    {
                      $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow2->{'total'})))));
                    }
                    else
                    {
                      $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow2->{'total'})))));
                    }
                    if ($rowBold eq "1")
                    {
                      $doc->print("</b>");
                    }
                    $doc->print("</font></td>\n");
                  }
                  $doc->print("    </tr>\n");
                }
              }

              $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
              $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
              for (my $skip_count=0; $skip_count < $subRow1->{'display_level'}; $skip_count++)
              {
                $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
              }
              if ($rowBold eq "1")
              {
                $doc->print("<b>");
              }
              if ($cell_type =~ /$tripleBeginAccountsRE/)
              {
                $doc->print("Beginning Balance for:&nbsp;");
              }
              elsif ($cell_type =~ /$tripleEndAccountsRE/)
              {
                $doc->print("Ending Balance for:&nbsp;");
              }
              my $hide_number = 0;
              if (exists $hide_numbers{$cell_type}{'1'})
              {
                $hide_number = 1;
              }
              $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow1->{'cell_text'}, code => $subRow1->{'item_name'}));
              if ($rowBold eq "1")
              {
                $doc->print("</b>");
              }
              $doc->print("&nbsp;Total:");
              $doc->print("</font></td>\n");
              for (my $value_count=0; $value_count < scalar @{$subRow1->{'values'}}; $value_count++)
              {
                my $valueCol = $subRow1->{values}[$value_count];
                for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
                {
                  $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow1->{'display_level'} * 1.5) . "em;\">");
                  if ($rowDrillable && $subRow1->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                  {
                    (my $tmp_sql_clause = $subRow1->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                    my $hide_number = 0;
                    if (exists $hide_numbers{$cell_type}{'1'})
                    {
                      $hide_number = 1;
                    }
                    $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow1->{'cell_text'}, code => $subRow1->{'item_name'})) . "');\">");
                  }
                  $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                  if ($rowBold eq "1")
                  {
                    $doc->print("<b>");
                  }
                  if ($withUnderlines)
                  {
                    if ($valueCol->[$value_count2] < 0)
                    {
                      $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                    }
                    else
                    {
                      $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                    }
                  }
                  else
                  {
                    if ($valueCol->[$value_count2] < 0)
                    {
                      $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                    }
                    else
                    {
                      $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                    }
                  }
                  if ($rowBold eq "1")
                  {
                    $doc->print("</b>");
                  }
                  $doc->print("</font>");
                  if ($subRow1->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                  {
                    $doc->print("</a>");
                  }
                  $doc->print("</td>\n");
                }
              }
              if ($args{'total_column'} eq "true")
              {
                $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow1->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                if ($rowBold eq "1")
                {
                  $doc->print("<b>");
                }
                if ($withUnderlines)
                {
                  if ($subRow1->{'total'} < 0)
                  {
                    $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                  }
                  else
                  {
                    $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                  }
                }
                else
                {
                  if ($subRow1->{'total'} < 0)
                  {
                    $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                  }
                  else
                  {
                    $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                  }
                }
                if ($rowBold eq "1")
                {
                  $doc->print("</b>");
                }
                $doc->print("</font></td>\n");
              }
              $doc->print("    </tr>\n");
            } # end second sub-level sub_row
            else
            {
              for (my $value_count=0; $value_count < scalar @{$subRow1->{'values'}}; $value_count++)
              {
                my $valueCol = $subRow1->{values}[$value_count];
                for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
                {
                  $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow1->{'display_level'} * 1.5) . "em;\">");
                  if ($rowDrillable && $subRow1->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                  {
                    (my $tmp_sql_clause = $subRow1->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                    my $hide_number = 0;
                    if (exists $hide_numbers{$cell_type}{'1'})
                    {
                      $hide_number = 1;
                    }
                    $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $subRow1->{'cell_text'}, code => $subRow1->{'item_name'})) . "');\">");
                  }
                  $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                  if ($rowBold eq "1")
                  {
                    $doc->print("<b>");
                  }
                  if ($valueCol->[$value_count2] < 0)
                  {
                    $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                  }
                  else
                  {
                    $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                  }
                  if ($rowBold eq "1")
                  {
                    $doc->print("</b>");
                  }
                  if (exists $subRow1->{'error'} && $subRow1->{'error'} == 1)
                  {
                    $doc->print("<font color=\"red\"><sup>*</sup></font>");
                  }
                  $doc->print("</font>");
                  if ($rowDrillable && $subRow1->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
                  {
                    $doc->print("</a>");
                  }
                  $doc->print("</td>\n");
                }
              }
              if ($args{'total_column'} eq "true")
              {
                $doc->print("      <td align=right valign=top style=\"padding-right: " . ($subRow1->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
                if ($rowBold eq "1")
                {
                  $doc->print("<b>");
                }
                if ($subRow1->{'total'} < 0)
                {
                  $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                }
                else
                {
                  $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($subRow1->{'total'})))));
                }
                if ($rowBold eq "1")
                {
                  $doc->print("</b>");
                }
                $doc->print("</font></td>\n");
              }
              $doc->print("    </tr>\n");
            }
          }

          $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
          $doc->print("      <td align=left colspan=" . ($max_display_level + 1) . " nowrap><font size=\"$text_size\" face=\"$text_font\" color=\"$row_fg_color\">");
          for (my $skip_count=0; $skip_count < $row->{'display_level'}; $skip_count++)
          {
            $doc->print("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;");
          }
          if ($rowBold eq "1")
          {
            $doc->print("<b>");
          }
          if ($cell_type =~ /$tripleBeginAccountsRE/)
          {
            $doc->print("Beginning Balance for:&nbsp;");
          }
          elsif ($cell_type =~ /$tripleEndAccountsRE/)
          {
            $doc->print("Ending Balance for:&nbsp;");
          }
          my $hide_number = 0;
          if (exists $hide_numbers{$cell_type}{'0'})
          {
            $hide_number = 1;
          }
          $doc->print(format_account(hide_number => $hide_number, account_format => $account_format, name => $row->{'cell_text'}, code => $row->{'item_name'}));
          if ($rowBold eq "1")
          {
            $doc->print("</b>");
          }
          $doc->print("&nbsp;Total:");
          $doc->print("</font></td>\n");
          for (my $value_count=0; $value_count < scalar @{$row->{'values'}}; $value_count++)
          {
            my $valueCol = $row->{values}[$value_count];
            for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
            {
              $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\">");
              if ($rowDrillable && $row->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
              {
                (my $tmp_sql_clause = $row->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                my $hide_number = 0;
                if (exists $hide_numbers{$cell_type}{'0'})
                {
                  $hide_number = 1;
                }
                $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $row->{'cell_text'}, code => $row->{'item_name'})) . "');\">");
              }
              $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
              if ($rowBold eq "1")
              {
                $doc->print("<b>");
              }
              if ($withUnderlines)
              {
                if ($valueCol->[$value_count2] < 0)
                {
                  $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
                else
                {
                  $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
              }
              else
              {
                if ($valueCol->[$value_count2] < 0)
                {
                  $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
                else
                {
                  $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
                }
              }
              if ($rowBold eq "1")
              {
                $doc->print("</b>");
              }
              $doc->print("</font>");
              if ($rowDrillable && $row->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
              {
                $doc->print("</a>");
              }
              $doc->print("</td>\n");
            }
          }
          if ($args{'total_column'} eq "true")
          {
            $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
            if ($rowBold eq "1")
            {
              $doc->print("<b>");
            }
            if ($withUnderlines)
            {
              if ($rowTotal < 0)
              {
                $doc->print(formatUnderlineValue(underlineLength => $underline_length, negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
              else
              {
                $doc->print(formatUnderlineValue(underlineLength => $underline_length, value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
            }
            else
            {
              if ($rowTotal < 0)
              {
                $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
              else
              {
                $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
              }
            }
            if ($rowBold eq "1")
            {
              $doc->print("</b>");
            }
            $doc->print("</font></td>\n");
          }
          $doc->print("    </tr>\n");
        } # end first sub-level sub_row
        else
        {
          for (my $value_count=0; $value_count < scalar @{$row->{'values'}}; $value_count++)
          {
            my $valueCol = $row->{values}[$value_count];
            for (my $value_count2=0; $value_count2 < scalar @{$valueCol}; $value_count2++)
            {
              $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\">");
              if ($rowDrillable && $row->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
              {
                (my $tmp_sql_clause = $row->{'sql_clause'}[$value_count][$value_count2]) =~ s/$singleQuoteRE/\\\'/g;
                my $hide_number = 0;
                if (exists $hide_numbers{$cell_type}{'0'})
                {
                  $hide_number = 1;
                }
                $doc->print("<a href=\"javascript: drill_value('$tmp_sql_clause', '$row->{'drill_report'}', '" . (format_account(hide_number => $hide_number, account_format => $account_format, name => $row->{'cell_text'}, code => $row->{'item_name'})) . "');\">");
              }
              $doc->print("<font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
              if ($rowBold eq "1")
              {
                $doc->print("<b>");
              }
              if ($valueCol->[$value_count2] < 0)
              {
                $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
              }
              else
              {
                $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($valueCol->[$value_count2])))));
              }
              if ($rowBold eq "1")
              {
                $doc->print("</b>");
              }
              if (exists $row->{'error'} && $row->{'error'} == 1)
              {
                $doc->print("<font color=\"red\"><sup>*</sup></font>");
              }
              $doc->print("</font>");
              if ($rowDrillable && $row->{'sql_clause'}[$value_count][$value_count2] ne "invalid" && $with_links eq "true")
              {
                $doc->print("</a>");
              }
              $doc->print("</td>\n");
            }
          }
          if ($args{'total_column'} eq "true")
          {
            $doc->print("      <td align=right valign=top style=\"padding-right: " . ($row->{'display_level'} * 1.5) . "em;\"><font size=\"$data_size\" face=\"$data_font\" color=\"$row_fg_color\">");
            if ($rowBold eq "1")
            {
              $doc->print("<b>");
            }
            if ($rowTotal < 0)
            {
              $doc->print(format_value(negative_format => $negative_format, sign => "-", value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
            }
            else
            {
              $doc->print(format_value(value => commify(massage_data(precision => $args{'data_precision'}, value => abs($rowTotal)))));
            }
            if ($rowBold eq "1")
            {
              $doc->print("</b>");
            }
            $doc->print("</font></td>\n");
          }
          $doc->print("    </tr>\n");
        }
      }
    }
  }

  $doc->print(<<"END_OF_BODY");
  </table>
  </form>
  </center>
END_OF_BODY
  if ($error_occurred)
  {
    $doc->print("<font color=\"red\"><b><sup>+</sup>:&nbsp;&nbsp;An error occurred while processing the report for this row.</b></font><br>\n");
    $doc->print("<font color=\"red\"><b><sup>*</sup>:&nbsp;&nbsp;This value contains invalid data.&nbsp;&nbsp;Most likely, the column modifier is not allowed or invalid.</b></font>\n");
  }

  $doc->setFocus("javascript");
  $doc->print(<<"END_OF_SCRIPT");

  function drill_value(sql_clause, report_id, title)
  {
    var bodyString = '';
    var date_obj = new Date();
    var detailed_win_ref;
    var detailed_win_name = "report_" + date_obj.getTime().toString();

    bodyString += '<html>\\n';
    bodyString += '<body bgcolor="$body_bgcolor">\\n';
    bodyString += '  <form method=post name="detailed_report_form" action="$site_dir/cgi-bin/report_customization.cgi">\\n';
    bodyString += '  <!-- Values for drillable reports -->\\n';
    bodyString += '  <input type=hidden name="command" value="run_report">\\n';
    bodyString += '  <input type=hidden name="report_type" value="d">\\n';
    bodyString += '  <input type=hidden name="id" value="' + report_id + '">\\n';
    bodyString += '  <input type=hidden name="report_name" value="$args{'report_name'} (' + title + ') - Drill Report">\\n';
    bodyString += '  <input type=hidden name="ledger" value="$args{'ledger'}">\\n';
    bodyString += '  <input type=hidden name="account_format" value="$args{'account_format'}">\\n';
    bodyString += '  <input type=hidden name="negative_format" value="$args{'negative_format'}">\\n';
    bodyString += '  <input type=hidden name="underline_length" value="$args{'underline_length'}">\\n';
    bodyString += '  <input type=hidden name="total_column" value="$args{'total_column'}">\\n';
    bodyString += '  <input type=hidden name="fg_color" value="$args{'fg_color'}">\\n';
    bodyString += '  <input type=hidden name="bg_color" value="$args{'bg_color'}">\\n';
    bodyString += '  <input type=hidden name="text_font" value="$args{'text_font'}">\\n';
    bodyString += '  <input type=hidden name="text_size" value="$args{'text_size'}">\\n';
    bodyString += '  <input type=hidden name="data_font" value="$args{'data_font'}">\\n';
    bodyString += '  <input type=hidden name="data_size" value="$args{'data_size'}">\\n';
    bodyString += '  <input type=hidden name="default_fg_color" value="$args{'default_fg_color'}">\\n';
    bodyString += '  <input type=hidden name="default_bg_color" value="$args{'default_bg_color'}">\\n';
    bodyString += '  <input type=hidden name="data_precision" value="1">\\n';
    bodyString += '  <input type=hidden name="sorted_by" value="Ref #">\\n';
    bodyString += '  <input type=hidden name="sorted_order" value="a">\\n';
    bodyString += '  <input type=hidden name="subtotal" value="false">\\n';
    bodyString += '  <input type=hidden name="subtotal_type" value="d">\\n';
    bodyString += '  <input type=hidden name="sql_statement" value="' + sql_clause + '">\\n';
    bodyString += '  <input type=hidden name="windowName" value="' + detailed_win_name + '">\\n';
    bodyString += '  <input type="hidden" name="reportWidth" value="100">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '  <input type=hidden name=\"headers\" value=\"");
  $doc->print("" . join("|", @column_field_names));
  $doc->print("\">\\n';\n");
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '  </form>\\n';
    bodyString += '</body>\\n';
    bodyString += '</html>\\n';

    detailed_win_ref = window.open("", detailed_win_name, "resizable,scrollbars,status");

    detailed_win_ref.document.open();
    detailed_win_ref.document.writeln(bodyString);
    detailed_win_ref.document.close();

    detailed_win_ref.document.detailed_report_form.submit();
  }
END_OF_SCRIPT

  if ($input{'report_command'} eq "print")
  {
    my $onload_code = <<"END_OF_ONLOAD";
    if ((navigator.appName.indexOf("Microsoft") != -1 && parseInt(navigator.appVersion, 10) <= 4) || parseInt(navigator.appVersion < 4))
    {
      alert("This browser does not support automatic printing of the document.\\nPlease print the document manually.");
    }
    else
    {
      window.print();
    }
END_OF_ONLOAD

    $doc->setOnload( code => $onload_code);
  }
  else
  {
    my $onloadCode = <<"END_OF_ONLOAD";
window.scrollTo(0, $args{pageTop});
END_OF_ONLOAD

    $doc->setOnload(code => $onloadCode);
  }

  $doc->display();
}

# display_detailed_report_top
# takes  : dbh, filename
# returns: nothing
sub display_detailed_report_top
{
  my %args = ( @_, );
  my $dbh = $args{'dbh'};
  my $file_name = $args{'file_name'};
  my $args_ref;
  my @data = ();
  my $count;

  if (length $dbh == 0)
  {
    my_die("Error: Report.cgi - display_detailed_report_top", 4028, "The DB Handle is required at line " . __LINE__);
  }

  if (length $file_name == 0)
  {
    my_die("Error: Report.cgi - display_detailed_report_top", 4035, "The filename is required at line " . __LINE__);
  }

  $args_ref = retrieve($file_name);
  %args = %{@{$args_ref}[0]};
  @data = @{@{$args_ref}[1]};
  my $id = $args{'id'};
  my $ledger = $args{'ledger'};

  my $report_name = $args{'report_name'};

  eval ("use HTMLObject::Normal;");
  if ($@)
  {
    my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
  }

  my $doc = HTMLObject::Normal->new();

  $doc->setJavascriptErrorHandlerEmail(email => $email_address);

  $doc->setFocus("body");
  $doc->setLinkDecorations();

  # set the overall font size to be smaller
  $doc->setStyleEntry(tag => "body", string => "font-size: smaller;");

  $doc->print(<<"END_OF_BODY");
  <center>
  <form method=post name="run_form" action="$site_dir/cgi-bin/report_display.cgi" target="_top">
  <table border=1 width="90%" cellspacing=0 cellpadding=2 bgcolor="$menu_fgcolor">
    <tr>
      <td align=center><a href="javascript: customize_report();">Customize&nbsp;Report</a> |
END_OF_BODY
  $doc->print("      <input type=checkbox name=\"subtotal\" value=\"true\" onClick=\"bottom_win_ref.document.run_form.subtotal.value = this.checked.toString();\"");
  if ($args{'subtotal'} eq "true")
  {
    $doc->print(" checked");
  }
  $doc->print(">Subtotal |");
  $doc->print("&nbsp; <input type=radio name=\"subtotal_type\" value=\"balance\" onClick=\"bottom_win_ref.document.run_form.subtotal_type.value = 'd';\"");
  if ($args{'subtotal_type'} eq "d" || $args{'subtotal_type'} ne "b")
  {
    $doc->print(" checked");
  }
  $doc->print(">Balance or");
  $doc->print(" <input type=radio name=\"subtotal_type\" value=\"sum\" onClick=\"bottom_win_ref.document.run_form.subtotal_type.value = 'b';\"");
  if ($args{'subtotal_type'} eq "b")
  {
    $doc->print(" checked");
  }
  $doc->print(">Sum |");
  $doc->print(<<"END_OF_BODY");
      <a href="javascript: display_report();">Re-display&nbsp;Report</a> |
      <a href="javascript: print_report();">Print</a> |
      <a href="javascript: memorize_report();">Memorize&nbsp;Report</a> |
      <a href="javascript: reset_report();">Reset&nbsp;Report</a> |
      <a href="javascript: rerun_report();">Re-run&nbsp;Report</a>
      </td>
    </tr>
  </table>
  </form>
  </center>
END_OF_BODY

  my $onload_code = <<"END_OF_ONLOAD";
    var bottomWindowName = window.parent.name;  // get the frameset window name that opened this frame
    bottomWindowName += "_bottom";  // add "_bottom" to the window name
    bottom_win_ref = window.open("", bottomWindowName);
END_OF_ONLOAD

  my $onunload_code = <<"END_OF_ONUNLOAD";
    if (typeof customize_win_ref != "undefined" && customize_win_ref.closed == false)
    {
      customize_win_ref.close();
    }
END_OF_ONUNLOAD

  $doc->setOnload(code => $onload_code);
  $doc->setOnunload(code => $onunload_code);

  $doc->setFocus("javascript");
  $doc->print(<<"END_OF_SCRIPT");

  var customize_win_ref;
  var bottom_win_ref;

  function reset_report()
  {
    var f = bottom_win_ref.document.run_form;
    var customize_window_open = false;

    // close the customization window if it is open
    if (typeof customize_win_ref != "undefined" && customize_win_ref.closed == false)
    {
      customize_window_open = true;
      customize_win_ref.close();
    }

    // reset the form values to their defaults
    f.sorted_by.value = "$args{'sorted_by'}";
    f.sorted_order.value = "$args{'sorted_order'}";
    f.account_format.value = "$args{'account_format'}";
    f.negative_format.value = "$args{'negative_format'}";
    f.fg_color.value = "$args{'fg_color'}";
    f.bg_color.value = "$args{'bg_color'}";
    f.text_font.value = "$args{'text_font'}";
    f.text_size.value = "$args{'text_size'}";
    f.data_font.value = "$args{'data_font'}";
    f.data_size.value = "$args{'data_size'}";
    f.headers.value = "$args{'headers'}";
    f.subtotal.value = "$args{'subtotal'}";
    f.subtotal_type.value = "$args{'subtotal_type'}";
    f.report_name.value = "$report_name";
    f.reportWidth.value = "$args{reportWidth}";

    // re-open the customization window if it was open
    if (customize_window_open == true)
    {
      customize_report();
    }

    if ("$args{'subtotal'}" == "false")
    {
      window.document.run_form.subtotal.checked = false;
    }
    else if ("$args{'subtotal'}" == "true")
    {
      window.document.run_form.subtotal.checked = true;
    }
    if ("$args{'subtotal_type'}" == "d")
    {
      window.document.run_form.subtotal_type[0].checked = true;
    }
    else if ("$args{'subtotal_type'}" == "b")
    {
      window.document.run_form.subtotal_type[1].checked = true;
    }

    // re-display the report
    display_report();
  }

  function rerun_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_customization.cgi";
    f.target = "_top";
    f.command.value = "run_report";
    f.submit();
  }

  function memorize_report()
  {
    var f = bottom_win_ref.document.run_form;
    // open the report window using the name of the window with "_memorize" tacked onto it so it associates the window with
    // the current report window to allow for multiple report windows to be open at the same time
    var top_window_name = window.parent.name;  // get the frameset window name that opened this frame
    top_window_name += "_memorize";  // add "_memorize" to the window name
    // open the memorization window
    memorize_win_ref = window.open("", top_window_name, "height=200,width=500,scrollbars", true);

    var bodyString = '<html>\\n';
    bodyString += '  <head>\\n';
    bodyString += '    <title>Memorize Report - '+f.report_name.value+'</title>\\n';
    bodyString += '  </head>\\n';
    bodyString += '  <body bgcolor=\\"white\\">\\n';
    bodyString += '  <center>\\n';
    bodyString += '  <form name=\\"memorize_form\\" action=\\"$site_dir/cgi-bin/report_customization.cgi\\">\\n';
    bodyString += '    <input type=hidden name=\\"command\\" value=\\"memorize_report\\">\\n';
    bodyString += '    <input type=hidden name=\\"id\\" value=\\"$id\\">\\n';
    bodyString += '    <input type=hidden name=\\"ledger\\" value=\\"$ledger\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_precision\\" value=\\"1\\">\\n';
    bodyString += '    <input type=hidden name=\\"sorted_by\\" value=\\"'+f.sorted_by.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"sorted_order\\" value=\\"'+f.sorted_order.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"account_format\\" value=\\"'+f.account_format.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"negative_format\\" value=\\"'+f.negative_format.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"fg_color\\" value=\\"'+f.fg_color.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"bg_color\\" value=\\"'+f.bg_color.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"text_font\\" value=\\"'+f.text_font.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"text_size\\" value=\\"'+f.text_size.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_font\\" value=\\"'+f.data_font.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"data_size\\" value=\\"'+f.data_size.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"headers\\" value=\\"'+f.headers.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"sql_statement\\" value=\\"'+f.sql_statement.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"report_type\\" value=\\"d\\">\\n';
    bodyString += '    <input type=hidden name=\\"report_class\\" value=\\"d\\">\\n';
    bodyString += '    <input type=hidden name=\\"file_name\\" value=\\"$file_name\\">\\n';
    bodyString += '    <input type=hidden name=\\"subtotal\\" value=\\"'+f.subtotal.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"subtotal_type\\" value=\\"'+f.subtotal_type.value+'\\">\\n';
    bodyString += '    <input type=hidden name=\\"reportWidth\\" value=\\"'+f.reportWidth.value+'\\">\\n';
    bodyString += '  <h2>Memorize Report</h2>\\n';
    bodyString += '  <table width=\\"90%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color="$menu_fgcolor">Report&nbsp;Name:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><input type=text name="report_name" value="'+f.report_name.value+'" size="30"></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '  </table>\\n';
    bodyString += '  <input type=submit name=\\"memorize\\" value=\\"Memorize\\">&nbsp;<input type=reset value=\\"Reset\\">\\n';
    bodyString += '  </form>\\n';
    bodyString += '  </center>\\n';
    bodyString += '  </body>\\n';
    bodyString += '</html>';

    memorize_win_ref.document.open();
    memorize_win_ref.document.writeln(bodyString);
    memorize_win_ref.document.close();
  }

  function customize_report()
  {
    var f = bottom_win_ref.document.run_form;
    var column_field_names = new Array();

    // open the report window using the name of the window with "_configure" tacked onto it so it associates the window with
    // the current report window to allow for multiple report windows to be open at the same time
    var top_window_name = window.parent.name;  // get the frameset window name that opened this frame
    top_window_name += "_configure";  // add "_configure" to the window name
    // open the customization window
    customize_win_ref = window.open("", top_window_name, "height=450,width=500,resizable,scrollbars", true);

END_OF_SCRIPT
  for (my $column_count=0; $column_count < scalar @column_field_names; $column_count++)
  {
    $doc->print("    column_field_names[$column_count] = \"$column_field_names[$column_count]\";\n");
  }
  $doc->print(<<"END_OF_SCRIPT");

    var bodyString = '<html>\\n';
    bodyString += '  <head>\\n';
    bodyString += '    <title>Customize Report - ' + f.report_name.value + '</title>\\n';
    bodyString += '  </head>\\n';
    bodyString += '  <body bgcolor=\\"white\\">\\n';
    bodyString += '  <center>\\n';
    bodyString += '  <form name=\\"customize_form\\" onSubmit=\\"return false;\\">\\n';
    bodyString += '  <h2>Customize Report</h2>\\n';
    bodyString += '  <table width=\\"90%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color="$menu_fgcolor">Report&nbsp;Name:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><input type=text name="report_name" value="' + f.report_name.value + '" size="30" onChange=\\"window.opener.report_name_change(this);\\"></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Show&nbsp;Accounts&nbsp;as:</font></font></th>\\n';
    bodyString += '      <td align=left><font size=\\"-1\\"><select name=\\"account_format\\" onChange=\\"window.opener.account_format_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @account_formats; $count++)
  {
    $doc->print("    bodyString += '          <option value=\\\"$account_formats[$count]\\\"';\n");
    $doc->print("    if (f.account_format.value == \"$account_formats[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$account_formats{$account_formats[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '      </select></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <th colspan=2><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Negative&nbsp;Value&nbsp;Format:</font></font></th>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2 align=center>\\n';
    bodyString += '        <table width=\\"70%\\" border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_fgcolor\\">\\n';
    bodyString += '          <tr>\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '            <td><font size=\\\"-1\\\"><input type=radio name=\\\"negative_format\\\" value=\\\"-1\\\" onClick=\\\"window.opener.negative_format_click(this);\\\"';\n");
  $doc->print("    if (f.negative_format.value == \"-1\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' checked';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default</font></td>\\n';\n");
  for ($count=0; $count < scalar @negative_formats; $count++)
  {
    $doc->print("    bodyString += '            <td><font size=\\\"-1\\\"><input type=radio name=\\\"negative_format\\\" value=\\\"$negative_formats[$count]\\\" onClick=\\\"window.opener.negative_format_click(this);\\\"';\n");
    $doc->print("    if (f.negative_format.value == \"$negative_formats[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' checked';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>&nbsp;$negative_formats{$negative_formats[$count]}</font></td>\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '        <table border=0 width=\\"100%\\" cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\">\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Foreground&nbsp;Color:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"fg_color\\" onChange=\\"window.opener.fg_color_change(this);\\">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '                <option value=\\\"default\\\"';\n");
  $doc->print("    if (f.fg_color.value == \"default\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default\\n';\n");
  for ($count=0; $count < scalar @fg_colors; $count++)
  {
    $doc->print("    bodyString += '                <option value=\\\"$fg_colors[$count]\\\"';\n");
    $doc->print("    if (f.fg_color.value == \"$fg_colors[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$fg_colors{$fg_colors[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Background&nbsp;Color:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"bg_color\\" onChange=\\"window.opener.bg_color_change(this);\\">\\n';
END_OF_SCRIPT
  $doc->print("    bodyString += '                <option value=\\\"default\\\"';\n");
  $doc->print("    if (f.bg_color.value == \"default\")\n");
  $doc->print("    {\n");
  $doc->print("      bodyString += ' selected';\n");
  $doc->print("    }\n");
  $doc->print("    bodyString += '>Default\\n';\n");
  for ($count=0; $count < scalar @bg_colors; $count++)
  {
    $doc->print("    bodyString += '                <option value=\\\"$bg_colors[$count]\\\"';\n");
    $doc->print("    if (f.bg_color.value == \"$bg_colors[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$bg_colors{$bg_colors[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '        <table width=\\"100%\\" border=0 cellspacing=0 cellpadding=2>\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Text&nbsp;Font:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"text_font\\" onChange=\\"window.opener.text_font_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_names; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_names[$count]\\\"';\n");
    $doc->print("    if (f.text_font.value == \"$font_names[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_names{$font_names[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Data&nbsp;Font:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"data_font\\" onChange=\\"window.opener.data_font_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_names; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_names[$count]\\\"';\n");
    $doc->print("    if (f.data_font.value == \"$font_names[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_names{$font_names[$count]}\\n';\n");
  }	
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Text&nbsp;Font&nbsp;Size:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"text_size\\" onChange=\\"window.opener.text_size_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_sizes; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_sizes[$count]\\\"';\n");
    $doc->print("    if (f.text_size.value == \"$font_sizes[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_sizes{$font_sizes[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '            <th align=right><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Data&nbsp;Font&nbsp;Size:</font></font></th>\\n';
    bodyString += '            <td align=left><font size=\\"-1\\"><select name=\\"data_size\\" onChange=\\"window.opener.data_size_change(this);\\">\\n';
END_OF_SCRIPT
  for ($count=0; $count < scalar @font_sizes; $count++)
  {
    $doc->print("    bodyString += '              <option value=\\\"$font_sizes[$count]\\\"';\n");
    $doc->print("    if (f.data_size.value == \"$font_sizes[$count]\")\n");
    $doc->print("    {\n");
    $doc->print("      bodyString += ' selected';\n");
    $doc->print("    }\n");
    $doc->print("    bodyString += '>$font_sizes{$font_sizes[$count]}\\n';\n");
  }
  $doc->print(<<"END_OF_SCRIPT");
    bodyString += '            </select></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2><hr width=\\"95%\\"></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td align=center colspan=2><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\"><b>Display Columns</b></font></font></td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=2>\\n';
    bodyString += '        <table border=0 cellspacing=0 cellpadding=2 bgcolor=\\"$menu_bgcolor\\" width=\\"100%\\">\\n';
    bodyString += '          <tr>\\n';
    bodyString += '            <td align=center><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Hide<br><select name=\\"hide_columns\\" multiple size=\\"5\\" width=\\"150\\">\\n';

    var headers_list = f.headers.value.split("|");
    var bMatchFound = false;
    for (var count=0; count < column_field_names.length; count++)
    {
      bMatchFound = false;
      for (var count2=0; count2 < headers_list.length; count2++)
      {
        if (column_field_names[count] == headers_list[count2])
        {
          bMatchFound = true;
        }
      }

      if (!bMatchFound)
      {
        bodyString += '              <option>' + column_field_names[count] + '\\n';
      }
    }

    bodyString += '            </select></font></font></td>\\n';
    bodyString += '            <td align=center><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">\\n';
    bodyString += '            <input type=button value=\\">>\\" onClick=\\"window.opener.show_all(window);\\"><br>\\n';
    bodyString += '            <input type=button value=\\">\\" onClick=\\"window.opener.show_selected(window);\\"><br><br>\\n';
    bodyString += '            <input type=button value=\\"<\\" onClick=\\"window.opener.hide_selected(window);\\"><br>\\n';
    bodyString += '            <input type=button value=\\"<<\\" onClick=\\"window.opener.hide_all(window);\\">\\n';
    bodyString += '            </font></font></td>\\n';
    bodyString += '            <td align=center><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Show<br><select name=\\"show_columns\\" multiple size=\\"5\\" width=\\"150\\">\\n';

    for (var count=0; count < headers_list.length; count++)
    {
      bodyString += '              <option>' + headers_list[count] + '\\n';
    }

    bodyString += '            </select></font></font></td>\\n';
    bodyString += '          </tr>\\n';
    bodyString += '        </table>\\n';
    bodyString += '      </td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '    <tr>\\n';
    bodyString += '      <td colspan=\\"2\\" align=\\"center\\"><font size=\\"-1\\"><font color=\\"$menu_fgcolor\\">Printed Report Width:</font></font>';
    bodyString += ' <input type=\\"text\\" name=\\"reportWidth\\" size=\\"3\\" maxlength=\\"3\\" value=\\"'+f.reportWidth.value+'\\" onChange=\\"window.opener.reportWidthChange(this);\\">%</td>\\n';
    bodyString += '    </tr>\\n';
    bodyString += '  </table>\\n';
    bodyString += '  <input type=button value=\\"Re-display Report\\" onClick=\\"window.opener.display_report();\\">\\n';
    bodyString += '  <input type=button value=\\"Close\\" onClick=\\"window.close();\\">\\n';
    bodyString += '  </form>\\n';
    bodyString += '  </center>\\n';
    bodyString += '  </body>\\n';
    bodyString += '</html>';

    customize_win_ref.document.open();
    customize_win_ref.document.writeln(bodyString);
    customize_win_ref.document.close();
  }

  function show_all(win)
  {
    f = win.document.customize_form;
    headers = bottom_win_ref.document.run_form.headers;

    headers.value = "";

    for (var count=0; count < f.hide_columns.options.length; count++)
    {
      // move all select items into the show_columns select
      f.show_columns.options[f.show_columns.options.length] = new Option(f.hide_columns.options[count].text, f.hide_columns.options[count].value);
    }
    f.hide_columns.length = 0;

    for (var count=0; count < f.show_columns.options.length; count++)
    {
      headers.value += f.show_columns.options[count].text;
      if (count < f.show_columns.options.length - 1)
      {
        headers.value += "|";
      }
    }
  }

  function show_selected(win)
  {
    f = win.document.customize_form;
    headers = bottom_win_ref.document.run_form.headers;

    headers.value = "";

    for (var count=0; count < f.hide_columns.options.length; count++)
    {
      if (f.hide_columns.options[count].selected)
      {
        f.show_columns.options[f.show_columns.options.length] = new Option(f.hide_columns.options[count].text, f.hide_columns.options[count].value);
        f.hide_columns.options[count] = null;
        count--;
      }
    }

    for (var count=0; count < f.show_columns.options.length; count++)
    {
      headers.value += f.show_columns.options[count].text;
      if (count < f.show_columns.options.length - 1)
      {
        headers.value += "|";
      }
    }
  }

  function hide_all(win)
  {
    f = win.document.customize_form;
    headers = bottom_win_ref.document.run_form.headers;

    headers.value = "";

    for (var count=0; count < f.show_columns.options.length; count++)
    {
      // move all select items into the hide_columns select
      f.hide_columns.options[f.hide_columns.options.length] = new Option(f.show_columns.options[count].text, f.show_columns.options[count].value);
    }
    f.show_columns.length = 0;
  }

  function hide_selected(win)
  {
    f = win.document.customize_form;
    headers = bottom_win_ref.document.run_form.headers;

    headers.value = "";

    for (var count=0; count < f.show_columns.options.length; count++)
    {
      if (f.show_columns.options[count].selected)
      {
        f.hide_columns.options[f.hide_columns.options.length] = new Option(f.show_columns.options[count].text, f.show_columns.options[count].value);
        f.show_columns.options[count] = null;
        count--;
      }
    }

    for (var count=0; count < f.show_columns.options.length; count++)
    {
      headers.value += f.show_columns.options[count].text;
      if (count < f.show_columns.options.length - 1)
      {
        headers.value += "|";
      }
    }
  }

  function display_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.report_command.value = "display";
    f.submit();
  }

  function report_name_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.report_name.value = element.value;
  }

  function account_format_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.account_format.value = element.options[element.selectedIndex].value;
  }

  function negative_format_click(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.negative_format.value = element.value;
  }

  function fg_color_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.fg_color.value = element.options[element.selectedIndex].value;
  }

  function bg_color_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.bg_color.value = element.options[element.selectedIndex].value;
  }

  function text_font_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.text_font.value = element.options[element.selectedIndex].value;
  }

  function data_font_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.data_font.value = element.options[element.selectedIndex].value;
  }

  function text_size_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.text_size.value = element.options[element.selectedIndex].value;
  }

  function data_size_change(element)
  {
    var f = bottom_win_ref.document.run_form;

    f.data_size.value = element.options[element.selectedIndex].value;
  }

  function reportWidthChange(element)
  {
    var f = bottom_win_ref.document.run_form;

    if (element.value < 0 || element.value > 100)
    {
      alert('Printed Report Width = "'+element.value+'" is invalid!  Setting to 100.');
      element.value = 100;
    }
    f.reportWidth.value = element.value;
  }

  function print_report()
  {
    var f = bottom_win_ref.document.run_form;

    f.action = "$site_dir/cgi-bin/report_display.cgi";
    f.target = "_self";
    f.report_command.value = "print";
    f.submit();
  }

END_OF_SCRIPT

  $doc->display();
}

# display_detailed_report
# takes  : dbh, filename
# returns: nothing
sub display_detailed_report
{
  my %args = ( @_, );
  my $dbh = $args{'dbh'};
  my $file_name = $args{'file_name'};
  my $report_type = $args{'report_type'};
  my $args_ref;
  my @data = ();

  if (length $dbh == 0)
  {
    my_die("Error: Report.cgi - display_detailed_report", 4028, "The DB Handle is required at line " . __LINE__);
  }

  if (length $file_name == 0)
  {
    my_die("Error: Report.cgi - display_detailed_report", 4035, "The filename is required at line " . __LINE__);
  }

  if (length $report_type == 0)
  {
    my_die("Error: Report.cgi - display_detailed_report", 4036, "The report type is required at line " . __LINE__);
  }

  eval ("use HTMLObject::Normal;");
  if ($@)
  {
    my_die("Error: Report.cgi - Eval", 4002, "Error: $@ at line " . __LINE__);
  }

  my $doc = HTMLObject::Normal->new();

  $doc->setJavascriptErrorHandlerEmail(email => $email_address);

  $args_ref = retrieve($file_name);
  %args = %{@{$args_ref}[0]};
  @data = @{@{$args_ref}[1]};
  my $id = $args{'id'};
  my $ledger = $args{'ledger'};

  my @arguments = ( "report_name", "account_format", "negative_format", "default_fg_color", "default_bg_color", "fg_color", "bg_color", "data_font", "data_size", "text_font", "text_size", "subtotal", "subtotal_type", "headers", "sorted_by", "sorted_order", "windowName", "reportWidth" );

  foreach my $value (@arguments)
  {
    if (exists $input{$value})
    {
      if (length $input{$value} == 0 && ($value ne "headers" && $value ne "sorted_by" && $value ne "sorted_order"))
      {
        my_die("Error: Report.cgi - display_detailed_report", 4005, "Parameter = '$value'");
      }
      $args{$value} = $input{$value};  # override the arguments passed in with the values from the web page.
    }
  }

  my $fgColor;
  my $bgColor;

  if ($args{'fg_color'} eq "default")
  {
    $fgColor = $args{'default_fg_color'};
  }
  else
  {
    $fgColor = $args{'fg_color'};
  }
  if ($args{'bg_color'} eq "default")
  {
    $bgColor = $args{'default_bg_color'};
  }
  else
  {
    $bgColor = $args{'bg_color'};
  }

  if ($args{'subtotal'} eq "")
  {
    $args{'subtotal'} = "false";
  }
  if ($args{'subtotal_type'} eq "")
  {
    $args{'subtotal_type'} = "d";
  }

  my $tableWidth = ($input{report_command} eq "print" ? $args{reportWidth} : 100);

  my $current_date = `/bin/date +%m-%d-%Y`;
  chomp $current_date;

  $doc->setTitle("$args{'ledger_name'} - $args{'report_name'} - run on $current_date");

  $doc->setFocus("body");
  $doc->setLinkDecorations();

  $doc->print(<<"END_OF_BODY");
  <center>
  <form method=post name="run_form" action="$site_dir/cgi-bin/report_display.cgi">
  <input type=hidden name="command" value="run_report_bottom">
  <input type=hidden name="report_type" value="$report_type">
  <input type=hidden name="file_name" value="$file_name">
  <input type=hidden name="report_command" value="">
  <input type=hidden name="report_name" value="$args{'report_name'}">
  <input type=hidden name="account_format" value="$args{'account_format'}">
  <input type=hidden name="negative_format" value="$args{'negative_format'}">
  <input type=hidden name="fg_color" value="$args{'fg_color'}">
  <input type=hidden name="bg_color" value="$args{'bg_color'}">
  <input type=hidden name="default_fg_color" value="$args{'default_fg_color'}">
  <input type=hidden name="default_bg_color" value="$args{'default_bg_color'}">
  <input type=hidden name="text_font" value="$args{'text_font'}">
  <input type=hidden name="text_size" value="$args{'text_size'}">
  <input type=hidden name="data_font" value="$args{'data_font'}">
  <input type=hidden name="data_size" value="$args{'data_size'}">
  <input type=hidden name="total_column" value="$args{'total_column'}">
  <input type=hidden name="underline_length" value="$args{'underline_length'}">
  <input type=hidden name="subtotal" value="$args{'subtotal'}">
  <input type=hidden name="subtotal_type" value="$args{'subtotal_type'}">
  <input type=hidden name="headers" value="$args{'headers'}">
  <input type=hidden name="sql_statement" value="$args{'sql_statement'}">
  <input type=hidden name="sorted_by" value="$args{'sorted_by'}">
  <input type=hidden name="sorted_order" value="$args{'sorted_order'}">
  <!-- Journal Reference Number lookup/edit fields -->
  <input type=hidden name="ledger" value="$args{'ledger'}">
  <input type=hidden name="ref_num2" value="">
  <input type=hidden name="journal_view_command" value="search2">
  <input type=hidden name="num_entries_to_display" value="10">
  <input type=hidden name="start_index" value="1">
  <input type="hidden" name="windowName" value="$args{windowName}">
  <input type="hidden" name="reportWidth" value="$args{reportWidth}">

  <table border=0 cellspacing=0 cellpadding=2 bgcolor="$bgColor" width="$tableWidth%">
    <tr>
      <td>
        <table border=0 cellspacing=0 cellpadding=0 width="100%">
          <tr>
            <td align="center" valign="top" width="100%"><font size="$args{'text_size'}" face="$args{'text_font'}" color="$fgColor"><b>$args{'report_name'}</b></font></td>
          </tr>
        </table>
      </td>
    </tr>
END_OF_BODY
  for (my $row_count=0; $row_count < scalar @data; $row_count++)
  {
    my $row = $data[$row_count];
    my $cellType = $row->{cell_type};
    my $rowBold = $row->{bold};
    if ($cellType eq "text")
    {
      $doc->print("    <tr>\n");
      $doc->print("      <td align=left bgcolor=\"");
      if ($args{'bg_color'} eq "default")
      {
        if ($row->{bg_color} eq "default")
        {
          $doc->print("$args{'default_bg_color'}");
        }
        else
        {
          $doc->print("$row->{bg_color}");
        }
      }
      else
      {
        $doc->print("$args{'bg_color'}");
      }
      $doc->print("\"><font size=\"$args{'text_size'}\" face=\"$args{'text_font'}\" color=\"");
      if ($args{'fg_color'} eq "default")
      {
        if ($row->{fg_color} eq "default")
        {
          $doc->print("$args{'default_fg_color'}");
        }
        else
        {
          $doc->print("$row->{fg_color}");
        }
      }
      else
      {
        $doc->print("$args{'fg_color'}");
      }
      $doc->print("\">");
      if ($rowBold eq "1")
      {
        $doc->print("<b>");
      }
      $doc->print("$row->{cell_text}");
      if ($rowBold eq "1")
      {
        $doc->print("</b>");
      }
      $doc->print("</font></td>\n");
      $doc->print("    </tr>\n");
    }
    elsif ($cellType eq "line")
    {
      $doc->print("    <tr>\n");
      $doc->print("      <td bgcolor=\"");
      if ($args{'bg_color'} eq "default")
      {
        if ($row->{bg_color} eq "default")
        {
          $doc->print("$args{'default_bg_color'}");
        }
        else
        {
          $doc->print("$row->{bg_color}");
        }
      }
      else
      {
        $doc->print("$args{'bg_color'}");
      }
      $doc->print("\"><hr width=\"100%\"></td>\n");
      $doc->print("    </tr>\n");
    }
    elsif ($cellType eq "detail")
    {
      my @headers_array = split /\|/, $args{'headers'};
      my $with_links = "true";
      my $row_bg_color;
      my $row_fg_color;
      my $row_negative_format;
      my $debit_column = -1;
      my $credit_column = -1;
      my $subtotal_debit_amount = 0.0;
      my $subtotal_credit_amount = 0.0;
      my $total_debit_amount = 0.0;
      my $total_credit_amount = 0.0;
      my $old_value;
      my $sorted_by_display_string;
      my %headerAlign = ( "Ref #" => "left", "Journal" => "left", "Date" => "left", "Payee-Payer" => "left", "Memo" => "left", "SbE" => "left",
                          "Account" => "left", "Sub-account" => "left", "Cleared" => "right", "Debit" => "right", "Credit" => "right" );

      # determine if this report is to have links or not
      if ($input{'report_command'} eq "print")
      { # without links
        $with_links = "false";
      }
      # determine this row's background color
      if ($args{'bg_color'} eq "default")
      {
        if ($row->{bg_color} eq "default")
        {
          $row_bg_color = $args{'default_bg_color'};
        }
        else
        {
          $row_bg_color = $row->{bg_color};
        }
      }
      else
      {
        $row_bg_color = $args{'bg_color'};
      }
      # determine this row's foreground color
      if ($args{'fg_color'} eq "default")
      {
        if ($row->{fg_color} eq "default")
        {
          $row_fg_color = $args{'default_fg_color'};
        }
        else
        {
          $row_fg_color = $row->{fg_color};
        }
      }
      else
      {
        $row_fg_color = $args{'fg_color'};
      }
      # determine this row's negative format
      if ($args{'negative_format'} == -1)
      {
        $row_negative_format = $row->{negative_format};
      }
      else
      {
        $row_negative_format = $args{'negative_format'};
      }
      # determine this row's debit and credit column locations in the headers_array
      for (my $column_count=0; $column_count < scalar @headers_array; $column_count++)
      {
        if ($headers_array[$column_count] eq "Debit")
        {
          $debit_column = $column_count;
        }
        elsif ($headers_array[$column_count] eq "Credit")
        {
          $credit_column = $column_count;
        }
      }

      # display the headers; either they are links or non-links based on the report_command: display or print
      $doc->print("    <tr bgcolor=\"$row_bg_color\">\n");
      $doc->print("      <td>\n");
      $doc->print("        <table border=1 width=\"100%\" cellspacing=0 cellpadding=2>\n");
      $doc->print("          <tr>\n");
      $doc->print("            <td align=right" . (scalar @headers_array == 0 ? "" : " colspan=" . scalar @headers_array) . "><font face=\"$args{'text_font'}\" size=\"$args{'text_size'}\" color=\"$row_fg_color\">Number of rows returned: <b>" . scalar @{$row->{values}} . "</b></font></td>\n");
      $doc->print("          </tr>\n");
      $doc->print("          <tr>\n");
      if (scalar @headers_array == 0)
      {
        $doc->print("            <td align=center><font face=\"$args{'text_font'}\" size=\"$args{'text_size'}\" color=\"$row_fg_color\"><b>No headers being displayed!</b></font></td>\n");
      }
      for (my $header_count=0; $header_count < scalar @headers_array; $header_count++)
      {
        $doc->print("            <td align=\"$headerAlign{$headers_array[$header_count]}\" nowrap><font face=\"$args{'text_font'}\" size=\"$args{'text_size'}\" color=\"$row_fg_color\">");
        if ($rowBold eq "1")
        {
          $doc->print("<b>");
        }
        if ($with_links eq "true")
        {
          my $sorted_order = "a";

          if ($headers_array[$header_count] eq $args{'sorted_by'})
          {
            if ($args{'sorted_order'} eq "a")
            {
              $sorted_order = "d";
            }
          }
          $doc->print("<a href=\"javascript: document.run_form.sorted_by.value = '$headers_array[$header_count]'; document.run_form.sorted_order.value = '$sorted_order'; document.run_form.report_command.value = 'display'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.submit();\">");
        }
        $doc->print("$headers_array[$header_count]");
        if ($headers_array[$header_count] eq $args{'sorted_by'})
        {
          if ($args{'sorted_order'} eq "a")
          { # ascending image
            $doc->print("&nbsp;<img src=\"$site_dir/images/ascending.gif\" border=0>");
          }
          elsif ($args{'sorted_order'} eq "d")
          { # descending image
            $doc->print("&nbsp;<img src=\"$site_dir/images/descending.gif\" border=0>");
          }
        }
        if ($with_links eq "true")
        {
          $doc->print("</a>");
        }
        if ($rowBold eq "1")
        {
          $doc->print("</b>");
        }
        $doc->print("</font></td>\n");
      }
      $doc->print("          </tr>\n");
      # display the data in the order the columns are layed out and sorted and with sub-totals if necessary
      my @values = @{$row->{values}};
      if ($args{'sorted_by'} ne "")
      {
        my @temp_values_array;
        my $sorted_by = $header_map{$args{'sorted_by'}};
        my $date_index = $header_map{'Date'};
        my $parent_num_index = $header_map{'Ref #'};
        my $amount_index = $header_map{'Debit'};
        my $dorc_index = $amount_index + 1;

        sub reverse_date
        {
          my $date = $_[0];
          (my $month, my $day, my $year) = split /-/, $date;

          return $year . $month . $day;
        }

        if ($sorted_by != $date_index)
        {
          if ($sorted_by == $parent_num_index || $sorted_by == $amount_index)
          {
            if ($sorted_by == $amount_index)
            {
              sub order_debits_credits
              {
                my $debit_credit = $_[0];
                my $asc_desc = $_[1];

                (my $a_value = $a->[$sorted_by]) =~ s/$dotRE//g;
                (my $b_value = $b->[$sorted_by]) =~ s/$dotRE//g;

                if ($debit_credit == 1)
                { # debit
                  if ($asc_desc == 1)
                  { # ascending
                    if ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] != $debit_credit)
                    {
                      return -1;
                    }
                    elsif ($b->[$dorc_index] == $debit_credit && $a->[$dorc_index] != $debit_credit)
                    {
                      return 1;
                    }
                    elsif ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] == $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($a_value <=> $b_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                    elsif ($a->[$dorc_index] != $debit_credit && $b->[$dorc_index] != $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($a_value <=> $b_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                  }
                  else
                  { # descending
                    if ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] != $debit_credit)
                    {
                      return -1;
                    }
                    elsif ($b->[$dorc_index] == $debit_credit && $a->[$dorc_index] != $debit_credit)
                    {
                      return 1;
                    }
                    elsif ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] == $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($b_value <=> $a_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                    elsif ($a->[$dorc_index] != $debit_credit && $b->[$dorc_index] != $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($b_value <=> $a_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                  }
                }
                else
                { # credit
                  if ($asc_desc == 1)
                  { # ascending
                    if ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] != $debit_credit)
                    {
                      return -1;
                    }
                    elsif ($b->[$dorc_index] == $debit_credit && $a->[$dorc_index] != $debit_credit)
                    {
                      return 1;
                    }
                    elsif ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] == $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($a_value <=> $b_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                    elsif ($a->[$dorc_index] != $debit_credit && $b->[$dorc_index] != $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($a_value <=> $b_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                  }
                  else
                  { # descending
                    if ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] != $debit_credit)
                    {
                      return -1;
                    }
                    elsif ($b->[$dorc_index] == $debit_credit && $a->[$dorc_index] != $debit_credit)
                    {
                      return 1;
                    }
                    elsif ($a->[$dorc_index] == $debit_credit && $b->[$dorc_index] == $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($b_value <=> $a_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                    elsif ($a->[$dorc_index] != $debit_credit && $b->[$dorc_index] != $debit_credit)
                    { # sort on the value
                      if ($a_value != $b_value)
                      {
                        return ($b_value <=> $a_value);
                      }
                      else
                      { # sort on the date
                        return (reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]));
                      }
                    }
                  }
                }
              }

              if ($args{'sorted_by'} eq "Debit")
              {
                if ($args{'sorted_order'} eq "d")
                {
                  @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { order_debits_credits(1, 0) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                }
                else
                { # sort ascending by default
                  @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { order_debits_credits(1, 1) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                }
              }
              elsif ($args{'sorted_by'} eq "Credit")
              {
                if ($args{'sorted_order'} eq "d")
                {
                  @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { order_debits_credits(0, 0) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                }
                else
                { # sort ascending by default
                  @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { order_debits_credits(0, 1) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                }
              }
            }
            else
            {
              if ($args{'sorted_order'} eq "d")
              {
                @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by] <=> $a->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
              }
              else
              { # sort ascending by default
                @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by] <=> $b->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
              }
            }
          }
          else
          {
            if ($args{'sorted_by'} eq "Account" || $args{'sorted_by'} eq "Sub-account" || $args{'sorted_by'} eq "Sub-Entity" || $args{'sorted_by'} eq "Journal")
            {
              if ($args{'sorted_by'} eq "Sub-Entity" || $args{'sorted_by'} eq "Journal")
              {
                if ($args{'sorted_order'} eq "d")
                {
                  if ($args{'account_format'} == 0 || $args{'account_format'} == 2)
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by + 1] cmp $a->[$sorted_by + 1] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                  else
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by] cmp $a->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                }
                else
                { # sort ascending by default
                  if ($args{'account_format'} == 0 || $args{'account_format'} == 2)
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by + 1] cmp $b->[$sorted_by + 1] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                  else
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by] cmp $b->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                }
              }
              elsif ($args{'sorted_by'} eq "Account" || $args{'sorted_by'} eq "Sub-account")
              {
                if ($args{'sorted_order'} eq "d")
                {
                  if ($args{'account_format'} == 0 || $args{'account_format'} == 2)
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by + 1] cmp $a->[$sorted_by + 1] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) || $b->[$sorted_by] <=> $a->[$sorted_by] } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                  else
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by] <=> $a->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                }
                else
                { # sort ascending by default
                  if ($args{'account_format'} == 0 || $args{'account_format'} == 2)
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by + 1] cmp $b->[$sorted_by + 1] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) || $a->[$sorted_by] <=> $b->[$sorted_by] } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                  else
                  {
                    @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by] <=> $b->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
                  }
                }
              }
            }
            else
            {
              if ($args{'sorted_order'} eq "d")
              {
                @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $b->[$sorted_by] cmp $a->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
              }
              else
              { # sort ascending by default
                @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { $a->[$sorted_by] cmp $b->[$sorted_by] || reverse_date($a->[$date_index]) <=> reverse_date($b->[$date_index]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
              }
            }
          }
        }
        elsif ($sorted_by == $date_index)
        {
          if ($args{'sorted_order'} eq "d")
          {
            @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { reverse_date($b->[$sorted_by]) <=> reverse_date($a->[$sorted_by]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
          }
          else
          { # sort ascending by default
            @temp_values_array = map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } sort { reverse_date($a->[$sorted_by]) <=> reverse_date($b->[$sorted_by]) } map { [ $_->[0], $_->[1], $_->[2], $_->[3], $_->[4], $_->[5], $_->[6], $_->[7], $_->[8], $_->[9], $_->[10], $_->[11], $_->[12], $_->[13], $_->[14], $_->[15], $_->[16] ] } @values;
          }
        }
        @values = @temp_values_array;
      }
      for (my $value_count=0; $value_count < scalar @values; $value_count++)
      {
        if (scalar @headers_array > 0 && $debit_column >= 0 && $credit_column >= 0)
        {
          if ($args{'subtotal'} eq "true")
          {
            if ($args{'sorted_by'} ne "" && $args{'sorted_by'} ne "Debit" && $args{'sorted_by'} ne "Credit")
            {
              if ($value_count > 0 && $old_value ne $values[$value_count][$header_map{$args{'sorted_by'}}])
              {
                # display current subtotals
                $doc->print("          <tr>\n");
                if ($args{'subtotal_type'} eq "d")
                {
                  # take the difference of whichever of debits and credits is greater and place the difference in the larger's column
                  if ($subtotal_debit_amount >= $subtotal_credit_amount)
                  {
                    if ($debit_column > 0)
                    {
                      $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount - $subtotal_credit_amount))) . "</b></font></td>\n");
                    if (scalar @headers_array > $debit_column + 1)
                    {
                      $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $debit_column));
                      if ($debit_column == 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                  }
                  else
                  {
                    if ($credit_column > 0)
                    {
                      $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount - $subtotal_debit_amount))) . "</b></font></td>\n");
                    if (scalar @headers_array > $credit_column + 1)
                    {
                      $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $credit_column));
                      if ($credit_column == 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                  }
                }
                elsif ($args{'subtotal_type'} eq "b")
                {
                  # display a running subtotal for both columns of debits and credits
                  if ($debit_column > $credit_column)
                  {
                    if ($credit_column > 0)
                    {
                      $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount))) . "</b></font></td>\n");
                    if ($debit_column - $credit_column - 1 > 0)
                    {
                      $doc->print("            <td colspan=" . ($debit_column - $credit_column - 1));
                      if ($credit_column == 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount))) . "</b></font></td>\n");
                    if (scalar @headers_array > $debit_column + 1)
                    {
                      $doc->print("            <td colspan=" . ((scalar @headers_array) - ($debit_column + 1)));
                      if ($debit_column - $credit_column - 1 <= 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                  }
                  else
                  {
                    if ($debit_column > 0)
                    {
                      $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount))) . "</b></font></td>\n");
                    if ($credit_column - $debit_column - 1 > 0)
                    {
                      $doc->print("            <td colspan=" . ($credit_column - $debit_column - 1));
                      if ($debit_column == 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                    $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount))) . "</b></font></td>\n");
                    if (scalar @headers_array > $credit_column + 1)
                    {
                      $doc->print("            <td colspan=" . ((scalar @headers_array) - ($credit_column + 1)));
                      if ($credit_column - $debit_column - 1 <= 0)
                      {
                        $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                      }
                      else
                      {
                        $doc->print("><br>");
                      }
                      $doc->print("</td>\n");
                    }
                  }
                }
                $doc->print("          </tr>\n");

                # clear the subtotals
                $subtotal_debit_amount = 0.0;
                $subtotal_credit_amount = 0.0;
              }

              $old_value = $values[$value_count][$header_map{$args{'sorted_by'}}];

              if ($values[$value_count][$header_map{'Debit'} + 1] eq "1")
              {
                $subtotal_debit_amount += $values[$value_count][$header_map{'Debit'}];
                $total_debit_amount += $values[$value_count][$header_map{'Debit'}];
              }
              elsif ($values[$value_count][$header_map{'Credit'} + 1] eq "0")
              {
                $subtotal_credit_amount += $values[$value_count][$header_map{'Credit'}];
                $total_credit_amount += $values[$value_count][$header_map{'Credit'}];
              }
            }
          }
        }

        my $linkInfo = "";
        if ($with_links eq "true")
        {
          $linkInfo = "javascript: document.run_form.ref_num2.value = '$values[$value_count][$header_map{'Ref #'}]'; document.run_form.action = '$site_dir/cgi-bin/journal_mod1.cgi'; document.run_form.target = 'edit_window'; window.open('','edit_window','resizable,status,scrollbars'); document.run_form.submit();";
        }

        $doc->print("          <tr" . ($with_links eq "true" ? " onClick=\"$linkInfo\"" : "") . ">\n");
        for (my $column_count=0; $column_count < scalar @headers_array; $column_count++)
        {
          if ($headers_array[$column_count] eq "Ref #")
          {
            $doc->print("            <td align=\"$headerAlign{$headers_array[$column_count]}\" valign=\"top\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">");
            #if ($with_links eq "true")
            #{
            #  $doc->print("<a href=\"javascript: document.run_form.ref_num2.value = '$values[$value_count][$header_map{$headers_array[$column_count]}]'; document.run_form.action = '$site_dir/cgi-bin/journal_mod1.cgi'; document.run_form.target = 'edit_window'; window.open('','edit_window','resizable,status,scrollbars'); document.run_form.submit();\">");
            #}
            $doc->print("$values[$value_count][$header_map{$headers_array[$column_count]}]");
            if ($headers_array[$column_count] eq $args{'sorted_by'})
            {
              $sorted_by_display_string = "$values[$value_count][$header_map{$headers_array[$column_count]}]";
            }
            #if ($with_links eq "true")
            #{
            #  $doc->print("</a>");
            #}
            $doc->print("</font></td>\n");
          }
          elsif ($headers_array[$column_count] eq "Journal" || $headers_array[$column_count] eq "Sub-Entity" || $headers_array[$column_count] eq "Account" || $headers_array[$column_count] eq "Sub-account")
          {
            $doc->print("            <td align=\"$headerAlign{$headers_array[$column_count]}\" valign=\"top\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">");
            if ($values[$value_count][$header_map{$headers_array[$column_count]}] == -1)
            {
              $doc->print("&nbsp;");
              if ($headers_array[$column_count] eq $args{'sorted_by'})
              {
                $sorted_by_display_string = "&nbsp;";
              }
            }
            else
            {
              if ($args{'account_format'} == 0)
              {
                if ($values[$value_count][($header_map{$headers_array[$column_count]} + 1)] ne "")
                {
                  $doc->print("$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]&nbsp;-&nbsp;");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]&nbsp;-&nbsp;";
                  }
                }
                if ($values[$value_count][$header_map{$headers_array[$column_count]}] ne "")
                {
                  $doc->print("$values[$value_count][$header_map{$headers_array[$column_count]}]");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string .= "$values[$value_count][$header_map{$headers_array[$column_count]}]";
                  }
                }
                else
                {
                  $doc->print("&nbsp;");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string .= "&nbsp;";
                  }
                }
              }
              elsif ($args{'account_format'} == 1)
              {
                if ($values[$value_count][$header_map{$headers_array[$column_count]}] ne "")
                {
                  $doc->print("$values[$value_count][$header_map{$headers_array[$column_count]}]");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "$values[$value_count][$header_map{$headers_array[$column_count]}]";
                  }
                }
                else
                {
                  $doc->print("&nbsp;");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "&nbsp;";
                  }
                }
                if ($values[$value_count][($header_map{$headers_array[$column_count]} + 1)] ne "")
                {
                  $doc->print("&nbsp;-&nbsp;$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string .= "&nbsp;-&nbsp;$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]";
                  }
                }
              }
              elsif ($args{'account_format'} == 2)
              {
                if ($values[$value_count][($header_map{$headers_array[$column_count]} + 1)] ne "")
                {
                  $doc->print("$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "$values[$value_count][($header_map{$headers_array[$column_count]} + 1)]";
                  }
                }
                else
                {
                  $doc->print("&nbsp;");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "&nbsp;";
                  }
                }
              }
              elsif ($args{'account_format'} == 3)
              {
                if ($values[$value_count][$header_map{$headers_array[$column_count]}] ne "")
                {
                  $doc->print("$values[$value_count][$header_map{$headers_array[$column_count]}]");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "$values[$value_count][$header_map{$headers_array[$column_count]}]";
                  }
                }
                else
                {
                  $doc->print("&nbsp;");
                  if ($headers_array[$column_count] eq $args{'sorted_by'})
                  {
                    $sorted_by_display_string = "&nbsp;";
                  }
                }
              }
            }
            $doc->print("</font></td>\n");
          }
          elsif ($headers_array[$column_count] eq "Debit")
          {
            if ($values[$value_count][($header_map{$headers_array[$column_count]} + 1)] == 1)
            {
              $doc->print("            <td align=\"$headerAlign{$headers_array[$column_count]}\" valign=\"top\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">");
              if ($values[$value_count][$header_map{$headers_array[$column_count]}] < 0)
              {
                $doc->print(format_value(negative_format => $row_negative_format, sign => "-", value => commify(sprintf("%.2f", abs($values[$value_count][$header_map{$headers_array[$column_count]}])))) . "");
              }
              else
              {
                $doc->print(format_value(value => commify(sprintf("%.2f", abs($values[$value_count][$header_map{$headers_array[$column_count]}])))));
              }
              $doc->print("</font></td>\n");
            }
            else
            {
              $doc->print("            <td><br></td>\n");
            }
          }
          elsif ($headers_array[$column_count] eq "Credit")
          {
            if ($values[$value_count][($header_map{$headers_array[$column_count]} + 1)] == 0)
            {
              $doc->print("            <td align=\"$headerAlign{$headers_array[$column_count]}\" valign=\"top\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">");
              if ($values[$value_count][$header_map{$headers_array[$column_count]}] < 0)
              {
                $doc->print(format_value(negative_format => $row_negative_format, sign => "-", value => commify(sprintf("%.2f", abs($values[$value_count][$header_map{$headers_array[$column_count]}])))));
              }
              else
              {
                $doc->print(format_value(value => commify(sprintf("%.2f", abs($values[$value_count][$header_map{$headers_array[$column_count]}])))));
              }
              $doc->print("</font></td>\n");
            }
            else
            {
              $doc->print("            <td><br></td>\n");
            }
          }
          else
          {
            $doc->print("            <td align=\"$headerAlign{$headers_array[$column_count]}\" valign=\"top\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">");
            my $temp_value = $values[$value_count][$header_map{$headers_array[$column_count]}];
            $temp_value =~ s/\s+//g;
            if ($temp_value eq "")
            {
              $doc->print("&nbsp;");
              if ($headers_array[$column_count] eq $args{'sorted_by'})
              {
                $sorted_by_display_string = "&nbsp;";
              }
            }
            else
            {
              $doc->print("$values[$value_count][$header_map{$headers_array[$column_count]}]");
              if ($headers_array[$column_count] eq $args{'sorted_by'})
              {
                $sorted_by_display_string = "$values[$value_count][$header_map{$headers_array[$column_count]}]";
              }
            }
            $doc->print("</font></td>\n");
          }
        }
        $doc->print("          </tr>\n");
      }
      if (scalar @headers_array > 0 && $debit_column >= 0 && $credit_column >= 0)
      {
        if ($args{'subtotal'} eq "true")
        {
          if ($args{'sorted_by'} ne "" && $args{'sorted_by'} ne "Debit" && $args{'sorted_by'} ne "Credit")
          {
            # display current subtotals
            $doc->print("          <tr>\n");
            if ($args{'subtotal_type'} eq "d")
            {
              # take the difference of whichever of debits and credits is greater and place the difference in the larger's column
              if ($subtotal_debit_amount >= $subtotal_credit_amount)
              {
                if ($debit_column > 0)
                {
                  $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount - $subtotal_credit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $debit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $debit_column));
                  if ($debit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
              else
              {
                if ($credit_column > 0)
                {
                  $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount - $subtotal_debit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $credit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $credit_column));
                  if ($credit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
            }
            elsif ($args{'subtotal_type'} eq "b")
            {
              # display a running subtotal for both columns of debits and credits
              if ($debit_column > $credit_column)
              {
                if ($credit_column > 0)
                {
                  $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount))) . "</b></font></td>\n");
                if ($debit_column - $credit_column - 1 > 0)
                {
                  $doc->print("            <td colspan=" . ($debit_column - $credit_column - 1));
                  if ($credit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $debit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array) - ($debit_column + 1)));
                  if ($debit_column - $credit_column - 1 <= 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
              else
              {
                if ($debit_column > 0)
                {
                  $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_debit_amount))) . "</b></font></td>\n");
                if ($credit_column - $debit_column - 1 > 0)
                {
                  $doc->print("            <td colspan=" . ($credit_column - $debit_column - 1));
                  if ($debit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($subtotal_credit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $credit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array) - ($credit_column + 1)));
                  if ($credit_column - $debit_column - 1 <= 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\">Sub Total: $sorted_by_display_string</font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
            }
            $doc->print("          </tr>\n");
            # display grand totals
            $doc->print("          <tr>\n");
            if ($args{'subtotal_type'} eq "d")
            {
              # take the difference of whichever of debits and credits is greater and place the difference in the larger's column
              if ($total_debit_amount >= $total_credit_amount)
              {
                if ($debit_column > 0)
                {
                  $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_debit_amount - $total_credit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $debit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $debit_column));
                  if ($debit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
              else
              {
                if ($credit_column > 0)
                {
                  $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_credit_amount - $total_debit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $credit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array - 1) - $credit_column));
                  if ($credit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
            }
            elsif ($args{'subtotal_type'} eq "b")
            {
              # display the total for both columns of debits and credits
              if ($debit_column > $credit_column)
              {
                if ($credit_column > 0)
                {
                  $doc->print("            <td colspan=" . $credit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_credit_amount))) . "</b></font></td>\n");
                if ($debit_column - $credit_column - 1 > 0)
                {
                  $doc->print("            <td colspan=" . ($debit_column - $credit_column - 1));
                  if ($credit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_debit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $debit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array) - ($debit_column + 1)));
                  if ($debit_column - $credit_column - 1 <= 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
              else
              {
                if ($debit_column > 0)
                {
                  $doc->print("            <td colspan=" . $debit_column . " align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font></td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_debit_amount))) . "</b></font></td>\n");
                if ($credit_column - $debit_column - 1 > 0)
                {
                  $doc->print("            <td colspan=" . ($credit_column - $debit_column - 1));
                  if ($debit_column == 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
                $doc->print("            <td align=\"right\" style=\"padding-right: 1em;\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>" . commify(sprintf("%.2f", abs($total_credit_amount))) . "</b></font></td>\n");
                if (scalar @headers_array > $credit_column + 1)
                {
                  $doc->print("            <td colspan=" . ((scalar @headers_array) - ($credit_column + 1)));
                  if ($credit_column - $debit_column - 1 <= 0)
                  {
                    $doc->print(" align=\"left\"><font face=\"$args{'data_font'}\" size=\"$args{'data_size'}\" color=\"$row_fg_color\"><b>Total</b></font>");
                  }
                  else
                  {
                    $doc->print("><br>");
                  }
                  $doc->print("</td>\n");
                }
              }
            }
            $doc->print("          </tr>\n");
          }
        }
      }
      if ($with_links eq "true" && (scalar @headers_array != 0) && (scalar @values != 0)) # don't display the headers at the bottom if printing or there are no data rows or no headers are being displayed
      {
        $doc->print("          <tr>\n");
        if (scalar @headers_array == 0)
        {
          $doc->print("            <td align=\"center\"><font face=\"$args{'text_font'}\" size=\"$args{'text_size'}\" color=\"$row_fg_color\"><b>No headers being displayed!</b></font></td>\n");
        }
        for (my $header_count=0; $header_count < scalar @headers_array; $header_count++)
        {
          $doc->print("            <td align=\"$headerAlign{$headers_array[$header_count]}\" nowrap><font face=\"$args{'text_font'}\" size=\"$args{'text_size'}\" color=\"$row_fg_color\">");
          if ($rowBold eq "1")
          {
            $doc->print("<b>");
          }
          if ($with_links eq "true")
          {
            my $sorted_order = "a";

            if ($headers_array[$header_count] eq $args{'sorted_by'})
            {
              if ($args{'sorted_order'} eq "a")
              {
                $sorted_order = "d";
              }
            }
            $doc->print("<a href=\"javascript: document.run_form.sorted_by.value = '$headers_array[$header_count]'; document.run_form.sorted_order.value = '$sorted_order'; document.run_form.report_command.value = 'display'; document.run_form.action = '$site_dir/cgi-bin/report_display.cgi'; document.run_form.target = '_self'; document.run_form.submit();\">");
          }
          $doc->print("$headers_array[$header_count]");
          if ($headers_array[$header_count] eq $args{'sorted_by'})
          {
            if ($args{'sorted_order'} eq "a")
            { # ascending image
              $doc->print("&nbsp;<img src=\"$site_dir/images/ascending.gif\" border=0>");
            }
            elsif ($args{'sorted_order'} eq "d")
            { # descending image
              $doc->print("&nbsp;<img src=\"$site_dir/images/descending.gif\" border=0>");
            }
          }
          if ($with_links eq "true")
          {
            $doc->print("</a>");
          }
          if ($rowBold eq "1")
          {
            $doc->print("</b>");
          }
          $doc->print("</font></td>\n");
        }
        $doc->print("          </tr>\n");
      }
      $doc->print("        </table>\n");
      $doc->print("      </td>\n");
      $doc->print("    </tr>\n");
    }
  }
  $doc->print(<<"END_OF_BODY");
  </table>
  </form>
END_OF_BODY

  if ($input{'report_command'} eq "print")
  {
    my $onload_code = <<"END_OF_ONLOAD";
    if ((navigator.appName.indexOf("Microsoft") != -1 && parseInt(navigator.appVersion, 10) <= 4) || parseInt(navigator.appVersion < 4))
    {
      alert("This browser does not support automatic printing of the document.\\nPlease print the document manually.");
    }
    else
    {
      window.print();
    }
END_OF_ONLOAD

    $doc->setOnload(code => $onload_code);
  }

  $doc->display();
}

sub format_value
{
  my %args = ( negative_format => 0, sign => "+", value => "0.00", code => 1, @_ );
  my $negative_format = $args{'negative_format'};
  my $value = $args{'value'};
  my $sign = $args{'sign'};
  my $code = $args{code};
  my $result = "";
  my $padding = "1.5em";

  if ($sign ne "+" && $sign ne "-")
  {
    $sign = "+";
  }

  $result = "<code>" if ($code);
  if ($sign eq "-")
  {
    if ($negative_format == 0)
    {
      $result .= "<font color=\"red\">(" . $value . ")</font>";
      $padding = "1em";
    }
    elsif ($negative_format == 1)
    {
      $result .= "<font color=\"red\">-</font>" . $value;
    }
    elsif ($negative_format == 2)
    {
      $result .= $value . "<font color=\"red\">-</font>";
      $padding = "1em";
    }
  }
  else
  {
    $result .= $value;
  }

  $result .= "</code>" if ($code);

  return "<span style=\"padding-right: " . $padding . ";\">" . $result . "</span>";
}

sub formatUnderlineValue
{
  my %args = ( negative_format => 0, sign => "+", value => "0.00", underlineLength => 0, @_ );
  my $negative_format = $args{'negative_format'};
  my $value = $args{'value'};
  my $sign = $args{'sign'};
  my $underlineLength = $args{underlineLength};

  my $result = "";
  my $padding = "1.5em";
  my $spaces = 0;

  if ($sign ne "+" && $sign ne "-")
  {
    $sign = "+";
  }

  if ($sign eq "-")
  {
    if ($negative_format == 0)
    {
      $spaces = 1;
    }
    elsif ($negative_format == 1)
    {
      $spaces = 2;
    }
    elsif ($negative_format == 2)
    {
      $spaces = 1;
    }
  }
  else
  {
    $spaces = 2;
  }
  my $tmpOut = format_value(%args, code => 0);
  if ($underlineLength)
  {
    if (length ($value) + $spaces < $underlineLength)
    {
      my $flength = ($underlineLength - length ($value) - $spaces);
      #return "case 1. flength = $flength, length $value = " . length ($value);
      my $filler = ($flength > 0) ? sprintf("%0.1f", $flength * 0.5) . "em" : "0em";
      $result = "<span style=\"text-decoration: overline; white-space: pre;\">" . " " x $filler . "$tmpOut</span>";
    }
    elsif (length ($value) + $spaces > $underlineLength)
    {
      my $ignore = (length ($value) + $spaces - $underlineLength);
      #return "case 2.  ignore = $ignore";
      my $first = substr($value, 0, $ignore);
      my $rest = substr($value, $ignore, $underlineLength - $ignore + $spaces);
      ($result = $tmpOut) =~ s/^(.*)($value)(.*)$/$1$first<span style=\"text-decoration: overline;\">$rest<\/span>$3/;
    }
    else
    {
      # we are equal!
      #return "case 3 we are equal";
      $result = "<span style=\"text-decoration: overline;\">$tmpOut</span>";
    }
  }
  else
  {
    $result = $tmpOut;
  }

  return "<code>" . $result . "</code>";
}

sub format_account
{
  my %args = ( hide_number => 0, account_format => 0, name => "", code => "", @_ );
  my $hide_number = $args{'hide_number'};
  my $account_format = $args{'account_format'};
  my $name = $args{'name'};
  my $code = $args{'code'};
  my $output = "";

  if ($hide_number)
  {
    if ($name ne "")
    {
      $output .= $name;
    }
    else
    {
      $output .= "<i>None</i>";
    }
  }
  else
  {
    if ($account_format == 0)
    {
      if ($name ne "")
      {
        $output .= $name;
      }
      else
      {
        $output .= "<i>None</i>";
      }
      $output .= "&nbsp;-&nbsp;";
      if ($code ne "")
      {
        if ($code eq "-1")
        {
          $output .= "(";
        }
        $output .= $code;
        if ($code eq "-1")
        {
          $output .= ")";
        }
      }
      else
      {
        $output .= "<i>None</i>";
      }
    }
    elsif ($account_format == 1)
    {
      if ($code ne "")
      {
        if ($code eq "-1")
        {
          $output .= "(";
        }
        $output .= $code;
        if ($code eq "-1")
        {
          $output .= ")";
        }
      }
      else
      {
        $output .= "<i>None</i>";
      }
      $output .= "&nbsp;-&nbsp;";
      if ($name ne "")
      {
        $output .= $name;
      }
      else
      {
        $output .= "<i>None</i>";
      }
    }
    elsif ($account_format == 2)
    {
      if ($name ne "")
      {
        $output .= $name;
      }
      else
      {
        $output .= "<i>None</i>";
      }
    }
    elsif ($account_format == 3)
    {
      if ($code ne "")
      {
        if ($code eq "-1")
        {
          $output .= "(";
        }
        $output .= $code;
        if ($code eq "-1")
        {
          $output .= ")";
        }
      }
      else
      {
        $output .= "<i>None</i>";
      }
    }
  }

  return $output;
}
#*****************************************************************************
